-- $Id: inn.lua 3072 2017-09-17 00:19:49Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

store_util.set_prices(npc.store.owner, player, {
  inn_meal = {3, 2, 1},
  inn_room = {25, 20, 15},
})

newChat {
  id = 'welcome',
  text = [[Welcome, weary traveler.  The bar and dining hall are to the right, and travel supply store is to the left.  Will you be requiring a room for the evening?]],
  answers = {
    {
      'A room for the night, please.' .. store_util.cost_sfx('inn_room'),
      action = store_util.inn_room,
      cond = store_util.can_afford('inn_room'),
    },
    {
      'A meal, please.' .. store_util.cost_sfx('inn_meal'),
      action = store_util.inn_meal,
      cond = store_util.can_afford('inn_meal'),
    },
    {
      'You mentioned a shop?',
      action = function(npc, player)
	npc.store:loadup(game.level, game.zone)
	npc.store:interact(player)
      end
    },
    {
      "I think I'll go the bar and listen for rumors.",
      action = store_util.inn_rumor,
    },
    { "Oh, this isn't the magic shop?  Sorry.  [leave]" },
  },
}

newChat {
  id = 'rumor',
  text = '??? This text should have been replaced by now',
  answers = {
    { 'Ohh...kay, then. [leave]' }
  },
}

return 'welcome'
