-- $Id: paladins-guild.lua 3279 2018-03-09 04:36:28Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2018 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

store_util.set_prices(npc.owner, player, {
  heal = {600, 400, 0},
  ench_armor = {750, 700, 150},
})

newChat {
  id = 'welcome',
  text = [[#LIGHT_GREEN#*A Human in a light grey tabard looks up as you enter.*#LAST#
Ah, welcome to the Paladin's Guild, noble seeker.  We're a bit more practical than those priests of the Inner Temple; we can heal you, certainly, but we can also patch up your armor for you.]],
  answers = {
    {
      'A healing prayer, please. #YELLOW#(heal 200hp, cure poison/blind/confusion/cut/stun)#LAST#' .. store_util.cost_sfx('heal'),
      cond = store_util.can_afford('heal'),
      action = store_util.healing,
    },
    {
      'Can you improve my armor?' .. store_util.cost_sfx('ench_armor'),
      cond = function(npc, player)
	local function cb(inv, o) return inv.worn and o.type == 'armor' end
	return store_util.has_gear(player, cb)
      end,
      action = function(npc, player, dlg)
	local function cb(inv, o) return inv.worn and o.type == 'armor' end
	return store_util.enchant_item(player, dlg, cb, { 'armor', 'armor' }, prices.ench_armor, 'enchant', npc.owner.name)
      end,
    },
    { 'Oh, sorry, I was looking for the potion store. [leave]' },
  },
}

newChat {
  id = 'enchant',
  text = [[Well, that didn't work.  This store must be broken.]],
  answers = {
    { 'Ohh...kay, then. [leave]' }
  },
}

return 'welcome'
