-- $Id: quest-khazad-dum-house-finish.lua 3144 2017-10-17 01:57:09Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

local Quest = require 'engine.Quest'

newChat {
  id = 'welcome',
  text = [[#LIGHT_GREEN#*As you leave the abandoned mine, a group of Dwarven miners is hovering nearby, looking nervous.  An older-looking Dwarf in more elaborate robes steps forward.*#LAST#
So, you must be the foolhardy @playerdescriptor.race@ that was seen entering the mine.  I #{bold}#told#{normal}# the Council we should put a warning sign on the blasted thing.  We weren't sure you were coming out, frankly; another half-hour or so and I would have had to try to convince the rescue team to go in after you.]],
  answers = {
    {
      [[Lucky I came out when I did, then; those Balrogs would have slaughtered your team.  I took care of them, though.]],
      jump = 'house-done',
    }
  },
}

newChat {
  id = 'house-done',
  text = [["Took care of them"?  You mean you #{italic}#killed#{normal}# all those Balrogs, single-handedly?  Astonishing!  Clearly you are a mighty adventurer, and potentially useful as an ally... I know, I'll have the Council place the mine in your name.  We'll never get any miners back in there anyway.  You can use it for storage, if you like; I'm sure you can handle any more Balrogs that might sneak in.]],
  answers = {
    {
      'Thank you.',
      action = function(npc, player)
	player:setQuestStatus('khazad-dum-house', Quest.DONE)
	util.place_home('quest', 'house', 'PERMA_WALL', 'KHAZAD_DUM_HOME')
      end,
    },
  },
}

return 'welcome'
