-- $Id: soothsayer.lua 3073 2017-09-17 00:49:21Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

store_util.set_prices(npc.store.owner, player, { fate={600, 500, 480} })

newChat {
  id = 'welcome',
  text = store_util.price_interp([[Come in, come in, @playername@.  Oh, don't look so surprised, of course I know your name.  I know all, I see all.  Tell your fortune?  Only @price.fate@ gold.]]),
  answers = {
    {
      "Funny how you couldn't predict I can't afford that. [leave]",
      cond = store_util.cannot_afford('fate'),
    },
    {
      'Sure, why not?' .. store_util.cost_sfx('fate'),
      cond = store_util.can_afford('fate'),
      action = function(npc, player, dlg)
	player:adjGold(-prices.fate)
	local fate_desc = player:learnUnknownFate()
	if fate_desc then
	  -- Deep wizardry:  we reach ahead into the next chat object and
	  -- replace its text and answer with ours.
	  local chat = dlg.chat:get('fate')
	  chat.text = [[#LIGHT_GREEN#*The soothsayer peers into her crystal ball.*#LAST# Yes... yes, I see your fate clearly!  ]]..fate_desc
	  chat.answers[1][1] = 'Thanks.  [leave]'
	end
	-- I think this makes us fall through to the jump.
	return nil
      end,
      jump = 'fate',
    },
    {
      "Actually, you wouldn't happen to have any Scrolls of Divination for sale, would you?",
      action = function(npc, player)
	npc.store:loadup(game.level, game.zone)
	npc.store:interact(player)
      end
    },
    {
      "Funny how you couldn't predict I'd say no. [leave]",
      cond = store_util.can_afford('fate'),
    },
  },
}

newChat {
  id = 'fate',
  text = [[#LIGHT_GREEN#*The soothsayer peers into her crystal ball and frowns.*#LAST# Well, that's boring.  You seem to have no interesting fates at this time.  Sorry, no refund.]],
  answers = {
    { 'Hmph.  [leave]' }
  }
}

return 'welcome'
