-- $Id: egos.lua 3333 2018-04-20 00:32:38Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2018 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_ego' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Ego entities generated from T2's e_info.txt

-- BEGIN VERBATIM
local ActorTalents = require 'engine.interface.ActorTalents'
-- END VERBATIM

-- Mage Staff of Mana
newEntity {
  define_as = 'MANA',
  name = [[of Mana]],
  suffix = true,
  level = 5,
  rarity = { 3, 8 },
  cost = 10000,
  ego_filter = {
    { tval = 6 },
  },
  resolve_data = {
    { 100, { pval_flags = { mana_mult=true } } },
    { 70, { resolvers.ego_adjust_field('pval', 2) } },
    bonus = { pval=3, to_d=-30, to_h=-30 },
  },
  obvious_flags = { pval_flags = { mana_mult=true } },
  rating = 20,
}

-- Mage Staff of Power
newEntity {
  define_as = 'POWER_MSTAFF',
  name = [[of Power]],
  suffix = true,
  level = 5,
  rarity = { 5, 8 },
  cost = 20000,
  ego_filter = {
    { tval = 6 },
  },
  resolve_data = {
    { 100, { pval_flags = { spellpower=true } } },
    { 70, { resolvers.ego_adjust_field('pval', 2) } },
    bonus = { pval=10, to_d=-30, to_h=-30 },
  },
  obvious_flags = { pval_flags = { spellpower=true } },
  rating = 30,
}

-- Mage Staff of Wizardry
newEntity {
  define_as = 'WIZARDRY',
  name = [[of Wizardry]],
  suffix = true,
  level = 10,
  rarity = { 1, 8 },
  cost = 50000,
  ego_filter = {
    { tval = 6 },
  },
  resolve_data = {
    { 100, { pval_flags = { mana_mult=true, spellpower=true } } },
    { 50, { resolvers.ego_adjust_field('pval', 2) } },
    bonus = { pval=3, to_d=-40, to_h=-40 },
  },
  rating = 60,
}

-- Mage Staff of Spell
newEntity {
  define_as = 'SPELL',
  name = [[of Spell]],
  suffix = true,
  level = 0,
  rarity = { 2, 8 },
  cost = 40000,
  ego_filter = {
    { tval = 6 },
  },
  resolve_data = {
    { 100, {
      flags = { ACTIVATE=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true }
    } },
  },
  rating = 60,
}

-- Soft/Hard Armor of Resist Acid
newEntity {
  define_as = 'RESIST_ACID_ARMOR',
  name = [[of Resist Acid]],
  suffix = true,
  level = 0,
  rarity = { 4, 20 },
  cost = 1000,
  ego_filter = {
    { tval = 36 },
    { tval = 37 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ACID]=true },
      ignore_dam = { [DamageType.ACID]=true }
    } },
  },
  obvious_flags = {
    convey_resist_dam = { [DamageType.ACID]=true },
    ignore_dam = { [DamageType.ACID]=true }
  },
  rating = 16,
}

-- Soft/Hard Armor of Resist Lightning
newEntity {
  define_as = 'RESIST_LIGHTNING_ARMOR',
  name = [[of Resist Lightning]],
  suffix = true,
  level = 0,
  rarity = { 4, 20 },
  cost = 400,
  ego_filter = {
    { tval = 36 },
    { tval = 37 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ELEC]=true },
      ignore_dam = { [DamageType.ELEC]=true }
    } },
  },
  obvious_flags = {
    convey_resist_dam = { [DamageType.ELEC]=true },
    ignore_dam = { [DamageType.ELEC]=true }
  },
  rating = 10,
}

-- Soft/Hard Armor (except Thunderlord Coat) of Resist Fire
newEntity {
  define_as = 'RESIST_FIRE_ARMOR',
  name = [[of Resist Fire]],
  suffix = true,
  level = 0,
  rarity = { 4, 20 },
  cost = 800,
  ego_filter = {
    { tval = 36, sval={0,15} },
    { tval = 37 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.FIRE]=true },
      ignore_dam = { [DamageType.FIRE]=true }
    } },
  },
  obvious_flags = {
    convey_resist_dam = { [DamageType.FIRE]=true },
    ignore_dam = { [DamageType.FIRE]=true }
  },
  rating = 14,
}

-- Soft/Hard Armor (except Thunderlord Coat) of Resist Cold
newEntity {
  define_as = 'RESIST_COLD_ARMOR',
  name = [[of Resist Cold]],
  suffix = true,
  level = 0,
  rarity = { 4, 20 },
  cost = 600,
  ego_filter = {
    { tval = 36, sval={0,15} },
    { tval = 37 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.COLD]=true },
      ignore_dam = { [DamageType.COLD]=true }
    } },
  },
  obvious_flags = {
    convey_resist_dam = { [DamageType.COLD]=true },
    ignore_dam = { [DamageType.COLD]=true }
  },
  rating = 12,
}

-- Soft/Hard Armor of Resistance
newEntity {
  define_as = 'RESISTANCE_ARMOR',
  name = [[of Resistance]],
  suffix = true,
  level = 0,
  rarity = { 2, 20 },
  cost = 12500,
  ego_filter = {
    { tval = 36 },
    { tval = 37 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true }
    } },
    { 25, { resolvers.ego_high_resist() } },
    bonus = { to_a=10 },
  },
  obvious_flags = { convey_resist_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true } },
  rating = 20,
}

-- Elven Soft/Hard Armor
newEntity {
  define_as = 'ELVEN',
  name = [[Elven]],
  prefix = true,
  level = 0,
  rarity = { 2, 20 },
  cost = 15000,
  ego_filter = {
    { tval = 36 },
    { tval = 37 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      pval_flags = { skill_stealth=true },
      esp_flags = { ORC=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      resolvers.ego_old_resist()
    } },
    { 25, { convey_resist_dam = { [DamageType.POISON]=true } } },
    bonus = { to_a=10, pval=3 },
  },
  obvious_flags = { pval_flags = { skill_stealth=true } },
  rating = 25,
}

-- Robe of Permanence
newEntity {
  define_as = 'PERMANENCE',
  name = [[of Permanence]],
  suffix = true,
  level = 0,
  rarity = { 1, 10 },
  cost = 30000,
  ego_filter = {
    { tval = 36, sval=2 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      convey_flags = { SUST_STR=true, SUST_DEX=true, SUST_CON=true, SUST_INT=true, SUST_WIS=true, SUST_CHA=true, HOLD_LIFE=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      resolvers.ego_old_resist()
    } },
    { 2, { resolvers.ego_immunity() } },
    bonus = { to_a=10 },
  },
  rating = 30,
}

-- Filthy Rag of Leprousness
newEntity {
  define_as = 'LEPROUSNESS',
  name = [[of Leprousness]],
  suffix = true,
  level = 0,
  rarity = { 1, 10 },
  cost = 0,
  ego_filter = {
    { tval = 36, sval=1 },
  },
  resolve_data = {
    { 100, {
      stat_flags = { CON=true, STR=true },
      flags = { CURSED=true },
      resolvers.ego_stat_flag()
    } },
    bonus = { pval=-6 },
  },
}

-- Mithril Plate/Adamantite Plate/Power Dragon Scale Mail of Immunity
newEntity {
  define_as = 'IMMUNITY',
  name = [[of Immunity]],
  suffix = true,
  level = 60,
  rarity = { 10, 100 },
  cost = 30000,
  ego_filter = {
    { tval = 37, sval=25 },
    { tval = 37, sval=30 },
    { tval = 38, sval=30 },
  },
  resolve_data = {
    { 100, { resolvers.ego_immunity() } },
    bonus = { to_a=5 },
  },
  rating = 40,
}

-- Dragon Scale Mail of Defense
newEntity {
  define_as = 'DEFENSE',
  name = [[of Defense]],
  suffix = true,
  level = 20,
  rarity = { 40, 100 },
  cost = 1000,
  ego_filter = {
    { tval = 38 },
  },
  resolve_data = {
    { 100, { resolvers.ego_sustain() } },
    bonus = { to_a=8 },
  },
  rating = 5,
}

-- Footwear of Jumping
newEntity {
  define_as = 'JUMPING',
  name = [[of Jumping]],
  suffix = true,
  level = 0,
  rarity = { 3, 27 },
  cost = 500,
  ego_filter = {
    { tval = 30 },
  },
  resolve_data = {
    bonus = { pval=3 },
    all = {
      worn_talents = { ActorTalents.T_GNOME_BLINK },
      -- BEGIN VERBATIM ALL
      use_power = {
	use = function(self, who, inven, floor, item)
	  spell.teleport(who, 10)
	  return { used=true }
	end,
	power = { 10, 10 },
	name = 'teleport (range 10)',
      },
      cant_use_if = { not_wielded=true },
      power = 0,
      power_regen = -1,
      -- END VERBATIM
    },
  },
  rating = 16,
}

-- Shield/Demonshield (except Dragon Shield) of Resist Acid
newEntity {
  define_as = 'RESIST_ACID_SHIELD',
  name = [[of Resist Acid]],
  suffix = true,
  level = 0,
  rarity = { 6, 22 },
  cost = 1000,
  ego_filter = {
    { tval = 115, sval=56 },
    { tval = 34, sval={0,5} },
    { tval = 34, sval={7,255} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ACID]=true },
      ignore_dam = { [DamageType.ACID]=true }
    } },
  },
  obvious_flags = {
    convey_resist_dam = { [DamageType.ACID]=true },
    ignore_dam = { [DamageType.ACID]=true }
  },
  rating = 16,
}

-- Shield/Demonshield (except Dragon Shield) of Resist Lightning
newEntity {
  define_as = 'RESIST_LIGHTNING_SHIELD',
  name = [[of Resist Lightning]],
  suffix = true,
  level = 0,
  rarity = { 6, 22 },
  cost = 400,
  ego_filter = {
    { tval = 34, sval={0,5} },
    { tval = 34, sval={7,255} },
    { tval = 115, sval=56 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ELEC]=true },
      ignore_dam = { [DamageType.ELEC]=true }
    } },
  },
  obvious_flags = {
    convey_resist_dam = { [DamageType.ELEC]=true },
    ignore_dam = { [DamageType.ELEC]=true }
  },
  rating = 10,
}

-- Shield/Demonshield (except Dragon Shield) of Resist Fire
newEntity {
  define_as = 'RESIST_FIRE_SHIELD',
  name = [[of Resist Fire]],
  suffix = true,
  level = 0,
  rarity = { 6, 22 },
  cost = 800,
  ego_filter = {
    { tval = 34, sval={0,5} },
    { tval = 34, sval={7,255} },
    { tval = 115, sval=56 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.FIRE]=true },
      ignore_dam = { [DamageType.FIRE]=true }
    } },
  },
  obvious_flags = {
    convey_resist_dam = { [DamageType.FIRE]=true },
    ignore_dam = { [DamageType.FIRE]=true }
  },
  rating = 14,
}

-- Shield/Demonshield (except Dragon Shield) of Resist Cold
newEntity {
  define_as = 'RESIST_COLD_SHIELD',
  name = [[of Resist Cold]],
  suffix = true,
  level = 0,
  rarity = { 6, 22 },
  cost = 600,
  ego_filter = {
    { tval = 115, sval=56 },
    { tval = 34, sval={0,5} },
    { tval = 34, sval={7,255} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.COLD]=true },
      ignore_dam = { [DamageType.COLD]=true }
    } },
  },
  obvious_flags = {
    convey_resist_dam = { [DamageType.COLD]=true },
    ignore_dam = { [DamageType.COLD]=true }
  },
  rating = 12,
}

-- Shield/Demonshield (except Dragon Shield) of Resistance
newEntity {
  define_as = 'RESISTANCE_SHIELD',
  name = [[of Resistance]],
  suffix = true,
  level = 0,
  rarity = { 2, 22 },
  cost = 12500,
  ego_filter = {
    { tval = 115, sval=56 },
    { tval = 34, sval={0,5} },
    { tval = 34, sval={7,255} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true }
    } },
    bonus = { to_a=10 },
  },
  obvious_flags = { convey_resist_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true } },
  rating = 20,
}

-- Shield/Demonshield (except Dragon Shield) of Reflection
newEntity {
  define_as = 'REFLECTION',
  name = [[of Reflection]],
  suffix = true,
  level = 0,
  rarity = { 2, 22 },
  cost = 15000,
  ego_filter = {
    { tval = 115, sval=56 },
    { tval = 34, sval={0,5} },
    { tval = 34, sval={7,255} },
  },
  resolve_data = {
    { 100, {
      convey_flags = { REFLECT=true },
      ignore_dam = { [DamageType.ELEC]=true, [DamageType.ACID]=true, [DamageType.COLD]=true, [DamageType.FIRE]=true }
    } },
    bonus = { to_a=5 },
  },
  obvious_flags = { convey_flags = { REFLECT=true } },
  rating = 20,
}

-- Metal Shield/Shield of Deflection of Electricity
newEntity {
  define_as = 'ELECTRICITY_SHIELD',
  name = [[of Electricity]],
  suffix = true,
  level = 0,
  rarity = { 2, 22 },
  cost = 400,
  ego_filter = {
    { tval = 34, sval=3 },
    { tval = 34, sval=5 },
    { tval = 34, sval=10 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ELEC]=true },
      convey_melee_retal = { [DamageType.ELEC]='plyrdam' },
      ignore_dam = { [DamageType.ELEC]=true }
    } },
  },
  obvious_flags = { convey_melee_retal = { [DamageType.ELEC]='plyrdam' } },
  rating = 10,
}

-- Cap/Helm/Demonhorn of the Noldor
newEntity {
  define_as = 'NOLDOR',
  name = [[of the Ñoldor]],
  suffix = true,
  level = 0,
  rarity = { 1, 8 },
  cost = 500,
  ego_filter = {
    { tval = 115, sval=57 },
    { tval = 32, sval={0,6} },
  },
  resolve_data = {
    { 100, {
      convey_flags = { SUST_DEX=true },
      stat_flags = { DEX=true },
      esp_flags = { ORC=true }
    } },
    bonus = { pval=2 },
    all = {
      -- BEGIN VERBATIM ALL
      use_power = {
	use = function(self, who, inven, floor, item)
	  spell.detect_buried_treasure(25, who)
	  return { used=true }
	end,
	power = { 10, 20 },
	name = 'detect treasure',
      },
      cant_use_if = { not_wielded=true },
      power = 0,
      power_regen = -1,
      -- END VERBATIM
    },
  },
  rating = 13,
}

-- Cap/Helm/Demonhorn of Intelligence
newEntity {
  define_as = 'INTELLIGENCE',
  name = [[of Intelligence]],
  suffix = true,
  level = 0,
  rarity = { 2, 15 },
  cost = 500,
  ego_filter = {
    { tval = 32, sval={0,6} },
    { tval = 115, sval=57 },
  },
  resolve_data = {
    { 100, {
      convey_flags = { SUST_INT=true },
      stat_flags = { INT=true }
    } },
    bonus = { pval=2 },
  },
  obvious_flags = { stat_flags = { INT=true } },
  rating = 13,
}

-- Cap/Helm/Demonhorn of Wisdom
newEntity {
  define_as = 'WISDOM',
  name = [[of Wisdom]],
  suffix = true,
  level = 0,
  rarity = { 2, 15 },
  cost = 500,
  ego_filter = {
    { tval = 32, sval={0,6} },
    { tval = 115, sval=57 },
  },
  resolve_data = {
    { 100, {
      convey_flags = { SUST_WIS=true },
      stat_flags = { WIS=true }
    } },
    bonus = { pval=2 },
  },
  obvious_flags = { stat_flags = { WIS=true } },
  rating = 13,
}

-- Cap/Helm/Demonhorn of Beauty
newEntity {
  define_as = 'BEAUTY',
  name = [[of Beauty]],
  suffix = true,
  level = 0,
  rarity = { 2, 15 },
  cost = 1000,
  ego_filter = {
    { tval = 32, sval={0,6} },
    { tval = 115, sval=57 },
  },
  resolve_data = {
    { 100, {
      convey_flags = { SUST_CHA=true },
      stat_flags = { CHA=true }
    } },
    bonus = { pval=4 },
  },
  obvious_flags = { stat_flags = { CHA=true } },
  rating = 8,
}

-- Crown of the Magi
newEntity {
  define_as = 'MAGI_CROWN',
  name = [[of the Magi]],
  suffix = true,
  level = 0,
  rarity = { 1, 8 },
  cost = 7500,
  ego_filter = {
    { tval = 33, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      convey_flags = { SUST_INT=true },
      stat_flags = { INT=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      resolvers.ego_abil_flag(),
      resolvers.ego_high_resist()
    } },
    { 40, { pval_flags = { spellpower=true } } },
    { 50, { flags = { SPELL_CONTAIN=true, WIELD_CAST=true } } },
    bonus = { pval=3 },
  },
  rating = 15,
}

-- Crown of Might
newEntity {
  define_as = 'MIGHT',
  name = [[of Might]],
  suffix = true,
  level = 0,
  rarity = { 1, 8 },
  cost = 2000,
  ego_filter = {
    { tval = 33, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      convey_flags = { SUST_STR=true, SUST_DEX=true, SUST_CON=true, FREE_ACT=true },
      stat_flags = { STR=true, DEX=true, CON=true },
      resolvers.ego_high_resist()
    } },
    bonus = { pval=3 },
  },
  rating = 19,
}

-- Crown of Lordliness
newEntity {
  define_as = 'LORDLINESS',
  name = [[of Lordliness]],
  suffix = true,
  level = 0,
  rarity = { 1, 8 },
  cost = 2000,
  ego_filter = {
    { tval = 33, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      convey_flags = { SUST_WIS=true, SUST_CHA=true },
      stat_flags = { WIS=true, CHA=true },
      resolvers.ego_high_resist()
    } },
    bonus = { pval=3 },
  },
  rating = 17,
}

-- Cap/Helm/Crown/Demonhorn of Seeing
newEntity {
  define_as = 'SEEING',
  name = [[of Seeing]],
  suffix = true,
  level = 0,
  rarity = { 1, 8 },
  cost = 1000,
  ego_filter = {
    { tval = 32, sval={0,6} },
    { tval = 33, sval={0,99} },
    { tval = 115, sval=57 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.BLIND]=true },
      convey_flags = { SEE_INVIS=true },
      pval_flags = { skill_searching=true }
    } },
    { 20, { esp_flags = { ALL=true } } },
    bonus = { pval=5 },
  },
  obvious_flags = { pval_flags = { skill_searching=true } },
  rating = 8,
}

-- Cap/Helm/Demonhorn of Infravision
newEntity {
  define_as = 'INFRAVISION_HELM',
  name = [[of Infravision]],
  suffix = true,
  level = 0,
  rarity = { 1, 15 },
  cost = 500,
  ego_filter = {
    { tval = 32, sval={0,6} },
    { tval = 115, sval=57 },
  },
  resolve_data = {
    { 100, {
      pval_flags = { infravision=true },
      flags = { HIDE_TYPE=true }
    } },
    bonus = { pval=5 },
  },
  obvious_flags = { pval_flags = { infravision=true } },
  rating = 11,
}

-- Cap/Helm/Demonhorn of Light
newEntity {
  define_as = 'LIGHT',
  name = [[of Light]],
  suffix = true,
  level = 0,
  rarity = { 2, 15 },
  cost = 500,
  ego_filter = {
    { tval = 32, sval={0,6} },
    { tval = 115, sval=57 },
  },
  resolve_data = {
    { 100, {
      lite = 1,
      convey_resist_dam = { [DamageType.LITE]=true }
    } },
  },
  obvious_flags = { lite = 1 },
  rating = 6,
}

-- Crown of Telepathy
newEntity {
  define_as = 'TELEPATHY',
  name = [[of Telepathy]],
  suffix = true,
  level = 0,
  rarity = { 1, 8 },
  cost = 50000,
  ego_filter = {
    { tval = 33, sval={0,99} },
  },
  resolve_data = {
    { 100, { esp_flags = { ALL=true } } },
  },
  obvious_flags = { esp_flags = { ALL=true } },
  rating = 20,
}

-- Cap/Helm/Crown/Demonhorn of Regeneration
newEntity {
  define_as = 'REGENERATION',
  name = [[of Regeneration]],
  suffix = true,
  level = 0,
  rarity = { 1, 8 },
  cost = 1500,
  ego_filter = {
    { tval = 32, sval={0,6} },
    { tval = 33, sval={0,99} },
    { tval = 115, sval=57 },
  },
  resolve_data = {
    { 100, { convey_flags = { REGENERATE=true } } },
  },
  obvious_flags = { convey_flags = { REGENERATE=true } },
  rating = 10,
}

-- Cap/Helm/Demonhorn of Teleportation
newEntity {
  define_as = 'TELEPORTATION',
  name = [[of Teleportation]],
  suffix = true,
  level = 0,
  rarity = { 1, 7 },
  cost = 50,
  ego_filter = {
    { tval = 32, sval={0,6} },
    { tval = 115, sval=57 },
  },
  resolve_data = {
    { 100, { convey_flags = { TELEPORT=true } } },
    { 90, { flags = { CURSED=true } } },
  },
  obvious_flags = { convey_flags = { TELEPORT=true } },
}

-- Cap/Helm/Demonhorn of Stupidity
newEntity {
  define_as = 'STUPIDITY',
  name = [[of Stupidity]],
  suffix = true,
  level = 0,
  rarity = { 2, 7 },
  cost = 0,
  ego_filter = {
    { tval = 32, sval={0,6} },
    { tval = 115, sval=57 },
  },
  resolve_data = {
    { 100, {
      stat_flags = { INT=true },
      flags = { CURSED=true }
    } },
    bonus = { pval=-5 },
  },
  obvious_flags = { stat_flags = { INT=true } },
}

-- Cap/Helm/Demonhorn of Naivety
newEntity {
  define_as = 'NAIVETY',
  name = [[of Naivety]],
  suffix = true,
  level = 0,
  rarity = { 2, 7 },
  cost = 0,
  ego_filter = {
    { tval = 32, sval={0,6} },
    { tval = 115, sval=57 },
  },
  resolve_data = {
    { 100, { stat_flags = { WIS=true } } },
    bonus = { pval=-5 },
  },
  obvious_flags = { stat_flags = { WIS=true } },
}

-- Cap/Helm/Demonhorn of Ugliness
newEntity {
  define_as = 'UGLINESS',
  name = [[of Ugliness]],
  suffix = true,
  level = 0,
  rarity = { 1, 7 },
  cost = 0,
  ego_filter = {
    { tval = 32, sval={0,6} },
    { tval = 115, sval=57 },
  },
  resolve_data = {
    { 100, { stat_flags = { CHA=true } } },
    bonus = { pval=-5 },
  },
  obvious_flags = { stat_flags = { CHA=true } },
}

-- Crown of Sickliness
newEntity {
  define_as = 'SICKLINESS',
  name = [[of Sickliness]],
  suffix = true,
  level = 0,
  rarity = { 1, 7 },
  cost = 0,
  ego_filter = {
    { tval = 33, sval={0,99} },
  },
  resolve_data = {
    { 100, { stat_flags = { STR=true, DEX=true, CON=true } } },
    bonus = { pval=-5 },
  },
}

-- Dwarven Cap/Helm
newEntity {
  define_as = 'DWARVEN_HELM',
  name = [[Dwarven]],
  prefix = true,
  level = 0,
  rarity = { 1, 8 },
  cost = 500,
  ego_filter = {
    { tval = 32, sval={0,6} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.FIRE]=true },
      stat_flags = { CON=true },
      pval_flags = { infravision=true },
      esp_flags = { TROLL=true, DRAGON=true }
    } },
    bonus = { pval=2 },
  },
  rating = 13,
}

-- Cloak of Protection
newEntity {
  define_as = 'PROTECTION',
  name = [[of Protection]],
  suffix = true,
  level = 0,
  rarity = { 4, 19 },
  cost = 1500,
  ego_filter = {
    { tval = 35 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.SHARDS]=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true }
    } },
    bonus = { to_a=10 },
  },
  rating = 10,
}

-- Cloak (except Mimicry Cloak) of Stealth
newEntity {
  define_as = 'STEALTH_CLOAK',
  name = [[of Stealth]],
  suffix = true,
  level = 0,
  rarity = { 8, 18 },
  cost = 500,
  ego_filter = {
    { tval = 35, sval={0,99} },
  },
  resolve_data = {
    { 100, { pval_flags = { skill_stealth=true } } },
    bonus = { pval=3 },
  },
  obvious_flags = { pval_flags = { skill_stealth=true } },
  rating = 10,
}

-- Cloak of Aman
newEntity {
  define_as = 'AMAN_CLOAK',
  name = [[of Aman]],
  suffix = true,
  level = 0,
  rarity = { 1, 28 },
  cost = 4000,
  ego_filter = {
    { tval = 35 },
  },
  resolve_data = {
    { 100, {
      pval_flags = { skill_stealth=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      resolvers.ego_old_resist()
    } },
    bonus = { to_a=20, pval=3 },
  },
  obvious_flags = { pval_flags = { skill_stealth=true } },
  rating = 20,
}

-- Cloak of Immolation
newEntity {
  define_as = 'IMMOLATION',
  name = [[of Immolation]],
  suffix = true,
  level = 0,
  rarity = { 1, 18 },
  cost = 4000,
  ego_filter = {
    { tval = 35 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.FIRE]=true },
      convey_melee_retal = { [DamageType.FIRE]='plyrdam' },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.FIRE]=true }
    } },
    bonus = { to_a=4 },
  },
  obvious_flags = { convey_melee_retal = { [DamageType.FIRE]='plyrdam' } },
  rating = 16,
}

-- Cloak of Enveloping
newEntity {
  define_as = 'ENVELOPING',
  name = [[of Enveloping]],
  suffix = true,
  level = 0,
  rarity = { 1, 3 },
  cost = 0,
  ego_filter = {
    { tval = 35 },
  },
  resolve_data = {
    { 100, { flags = { SHOW_MODS=true } } },
    bonus = { to_d=-10, to_h=-10 },
  },
}

-- Cloak of Vulnerability
newEntity {
  define_as = 'VULNERABILITY_CLOAK',
  name = [[of Vulnerability]],
  suffix = true,
  level = 0,
  rarity = { 1, 3 },
  cost = 0,
  ego_filter = {
    { tval = 35 },
  },
  resolve_data = {
    { 100, { convey_flags = { AGGRAVATE=true } } },
    bonus = { to_a=-50 },
  },
}

-- Cloak of Irritation
newEntity {
  define_as = 'IRRITATION',
  name = [[of Irritation]],
  suffix = true,
  level = 0,
  rarity = { 1, 3 },
  cost = 0,
  ego_filter = {
    { tval = 35 },
  },
  resolve_data = {
    { 100, {
      convey_flags = { AGGRAVATE=true },
      flags = { SHOW_MODS=true }
    } },
    bonus = { to_d=-15, to_h=-15 },
  },
}

-- Cloak of Electricity
newEntity {
  define_as = 'ELECTRICITY_CLOAK',
  name = [[of Electricity]],
  suffix = true,
  level = 0,
  rarity = { 1, 18 },
  cost = 4000,
  ego_filter = {
    { tval = 35 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ELEC]=true },
      convey_melee_retal = { [DamageType.ELEC]='plyrdam' },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true }
    } },
    bonus = { to_a=4 },
  },
  rating = 16,
}

-- Handwear of Free Action
newEntity {
  define_as = 'FREE_ACTION_GLOVES',
  name = [[of Free Action]],
  suffix = true,
  level = 0,
  rarity = { 4, 10 },
  cost = 1000,
  ego_filter = {
    { tval = 31, sval={0,99} },
  },
  resolve_data = {
    { 100, { convey_flags = { FREE_ACT=true } } },
  },
  obvious_flags = { convey_flags = { FREE_ACT=true } },
  rating = 11,
}

-- Handwear of Slaying
newEntity {
  define_as = 'SLAYING_GLOVES',
  name = [[of Slaying]],
  suffix = true,
  level = 0,
  rarity = { 3, 10 },
  cost = 1500,
  ego_filter = {
    { tval = 31, sval={0,99} },
  },
  resolve_data = {
    { 100, { flags = { SHOW_MODS=true } } },
    bonus = { to_d=6, to_h=6 },
  },
  rating = 17,
}

-- Handwear of Agility
newEntity {
  define_as = 'AGILITY',
  name = [[of Agility]],
  suffix = true,
  level = 0,
  rarity = { 2, 10 },
  cost = 1000,
  ego_filter = {
    { tval = 31, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      stat_flags = { DEX=true },
      flags = { HIDE_TYPE=true }
    } },
    bonus = { pval=5 },
  },
  obvious_flags = { stat_flags = { DEX=true } },
  rating = 14,
}

-- Handwear of Power
newEntity {
  define_as = 'POWER_GLOVES',
  name = [[of Power]],
  suffix = true,
  level = 0,
  rarity = { 1, 10 },
  cost = 2500,
  ego_filter = {
    { tval = 31, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      stat_flags = { STR=true },
      flags = { SHOW_MODS=true, HIDE_TYPE=true },
      resolvers.ego_high_resist()
    } },
    bonus = { pval=5, to_d=5, to_h=5 },
  },
  obvious_flags = { stat_flags = { STR=true } },
  rating = 22,
}

-- Gauntlets of Peace
newEntity {
  define_as = 'PEACE',
  name = [[of Peace]],
  suffix = true,
  level = 0,
  rarity = { 1, 3 },
  cost = 0,
  ego_filter = {
    { tval = 31, sval=2 },
  },
  resolve_data = {
    { 100, { flags = { HEAVY_CURSE=true, CURSED=true } } },
    bonus = { to_d=-10, to_h=-10 },
  },
}

-- Gloves of Charming
newEntity {
  define_as = 'CHARMING',
  name = [[of Charming]],
  suffix = true,
  level = 0,
  rarity = { 1, 11 },
  cost = 400,
  ego_filter = {
    { tval = 31, sval=1 },
  },
  resolve_data = {
    { 100, { stat_flags = { CHA=true } } },
    { 33, { pval_flags = { skill_stealth=true } } },
    bonus = { pval=6 },
  },
  obvious_flags = { pval_flags = { skill_stealth=true } },
  rating = 5,
}

-- Handwear of Weakness
newEntity {
  define_as = 'WEAKNESS',
  name = [[of Weakness]],
  suffix = true,
  level = 0,
  rarity = { 1, 3 },
  cost = 0,
  ego_filter = {
    { tval = 31, sval={0,99} },
  },
  resolve_data = {
    { 100, { stat_flags = { STR=true } } },
    bonus = { pval=-10 },
  },
}

-- Handwear of Clumsiness
newEntity {
  define_as = 'CLUMSINESS',
  name = [[of Clumsiness]],
  suffix = true,
  level = 0,
  rarity = { 1, 3 },
  cost = 0,
  ego_filter = {
    { tval = 31, sval={0,99} },
  },
  resolve_data = {
    { 100, { stat_flags = { DEX=true } } },
    bonus = { pval=-10 },
  },
}

-- Footwear of Levitation
newEntity {
  define_as = 'LEVITATION',
  name = [[of Levitation]],
  suffix = true,
  level = 0,
  rarity = { 8, 27 },
  cost = 250,
  ego_filter = {
    { tval = 30, sval={0,99} },
  },
  resolve_data = {
    { 100, { convey_flags = { FEATHER=true } } },
    { 40, { resolvers.ego_high_resist() } },
  },
  obvious_flags = { convey_flags = { FEATHER=true } },
  rating = 7,
}

-- Footwear of Stealth
newEntity {
  define_as = 'STEALTH_BOOTS',
  name = [[of Stealth]],
  suffix = true,
  level = 0,
  rarity = { 8, 27 },
  cost = 500,
  ego_filter = {
    { tval = 30, sval={0,99} },
  },
  resolve_data = {
    { 100, { pval_flags = { skill_stealth=true } } },
    bonus = { pval=3 },
  },
  obvious_flags = { pval_flags = { skill_stealth=true } },
  rating = 16,
}

-- Footwear of Free Action
newEntity {
  define_as = 'FREE_ACTION_BOOTS',
  name = [[of Free Action]],
  suffix = true,
  level = 0,
  rarity = { 5, 27 },
  cost = 1000,
  ego_filter = {
    { tval = 30, sval={0,99} },
  },
  resolve_data = {
    { 100, { convey_flags = { FREE_ACT=true } } },
  },
  obvious_flags = { convey_flags = { FREE_ACT=true } },
  rating = 15,
}

-- Footwear of Speed
newEntity {
  define_as = 'SPEED',
  name = [[of Speed]],
  suffix = true,
  level = 0,
  rarity = { 1, 27 },
  cost = 200000,
  ego_filter = {
    { tval = 30, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      pval_flags = { speed=true },
      flags = { HIDE_TYPE=true }
    } },
    { 10, { resolvers.ego_adjust_field('pval', 3) } },
    bonus = { pval=10 },
  },
  obvious_flags = { pval_flags = { speed=true } },
  rating = 25,
}

-- Metal Shod Boots of Dwarvish Endurance
newEntity {
  define_as = 'DWARVISH_ENDURANCE',
  name = [[of Dwarvish Endurance]],
  suffix = true,
  level = 0,
  rarity = { 1, 20 },
  cost = 5000,
  ego_filter = {
    { tval = 30, sval=6 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.DARK]=true },
      stat_flags = { CON=true },
      pval_flags = { infravision=true }
    } },
    { 33, { stat_flags = { STR=true } } },
    bonus = { pval=6 },
  },
  rating = 15,
}

-- Footwear of Noise
newEntity {
  define_as = 'NOISE',
  name = [[of Noise]],
  suffix = true,
  level = 0,
  rarity = { 1, 3 },
  cost = 0,
  ego_filter = {
    { tval = 30, sval={0,99} },
  },
  resolve_data = {
    { 100, { convey_flags = { AGGRAVATE=true } } },
  },
  obvious_flags = { convey_flags = { AGGRAVATE=true } },
}

-- Footwear of Slowness
newEntity {
  define_as = 'SLOWNESS',
  name = [[of Slowness]],
  suffix = true,
  level = 0,
  rarity = { 1, 3 },
  cost = 0,
  ego_filter = {
    { tval = 30, sval={0,99} },
  },
  resolve_data = {
    { 100, { pval_flags = { speed=true } } },
    bonus = { pval=-5 },
  },
  obvious_flags = { pval_flags = { speed=true } },
}

-- Footwear of Annoyance
newEntity {
  define_as = 'ANNOYANCE',
  name = [[of Annoyance]],
  suffix = true,
  level = 0,
  rarity = { 1, 3 },
  cost = 0,
  ego_filter = {
    { tval = 30, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      convey_flags = { AGGRAVATE=true },
      pval_flags = { speed=true }
    } },
    bonus = { pval=-10 },
  },
}

-- Weapon of Aman
newEntity {
  define_as = 'AMAN_WPN',
  name = [[of Aman]],
  suffix = true,
  level = 0,
  rarity = { 2, 44 },
  cost = 20000,
  ego_filter = {
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.FEAR]=true },
      slay_flags = { EVIL=true, UNDEAD=true, DEMON=true },
      convey_flags = { SEE_INVIS=true, BLESSED=true },
      stat_flags = { WIS=true },
      flags = { LIMIT_BLOWS=true },
      esp_flags = { EVIL=true },
      resolvers.ego_sustain()
    } },
    { 10, { pval_flags = { extra_blows=true } } },
    { 1, { resolvers.ego_adjust_field('pval', 1) } },
    bonus = { to_a=4, pval=3, to_d=6, to_h=6 },
  },
  rating = 30,
}

-- Weapon/Boomerang (Defender)
newEntity {
  define_as = 'DEFENDER',
  name = [[(Defender)]],
  suffix = true,
  level = 0,
  rarity = { 2, 44 },
  cost = 15000,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      convey_flags = { FREE_ACT=true, SEE_INVIS=true, FEATHER=true, REGENERATE=true },
      pval_flags = { skill_stealth=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      resolvers.ego_sustain(),
      resolvers.ego_high_resist()
    } },
    { 33, { convey_resist_dam = { [DamageType.POISON]=true } } },
    bonus = { to_a=8, pval=4, to_d=4, to_h=4 },
  },
  obvious_flags = { pval_flags = { skill_stealth=true } },
  rating = 25,
}

-- Blessed Weapon
newEntity {
  define_as = 'BLESSED',
  name = [[Blessed]],
  prefix = true,
  level = 0,
  rarity = { 1, 44 },
  cost = 5000,
  ego_filter = {
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
  },
  resolve_data = {
    { 100, {
      convey_flags = { BLESSED=true },
      stat_flags = { WIS=true },
      esp_flags = { GOOD=true },
      resolvers.ego_abil_flag()
    } },
    bonus = { pval=3 },
  },
  obvious_flags = { convey_flags = { BLESSED=true } },
  rating = 20,
}

-- Weapon/Demonblade of Greater Life
newEntity {
  define_as = 'GREATER_LIFE',
  name = [[of Greater Life]],
  suffix = true,
  level = 0,
  rarity = { 1, 50 },
  cost = 30000,
  ego_filter = {
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
    require = { flags = { MUST2H=true } },
  },
  resolve_data = {
    { 100, {
      convey_flags = { HOLD_LIFE=true },
      pval_flags = { hp_mult=true }
    } },
    bonus = { pval=3, to_d=5, to_h=5 },
  },
  obvious_flags = { pval_flags = { hp_mult=true } },
  rating = 20,
}

-- Weapon/Boomerang of Westernesse
newEntity {
  define_as = 'WESTERNESSE',
  name = [[of Westernesse]],
  suffix = true,
  level = 0,
  rarity = { 2, 44 },
  cost = 20000,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
  },
  resolve_data = {
    { 100, {
      slay_flags = { ORC=true, TROLL=true, GIANT=true },
      convey_flags = { FREE_ACT=true, SEE_INVIS=true },
      stat_flags = { STR=true, DEX=true, CON=true },
      esp_flags = { ORC=true, TROLL=true, GIANT=true }
    } },
    { 33, { convey_resist_dam = { [DamageType.FEAR]=true } } },
    { 50, { flags = { RES_MORGUL=true } } },
    bonus = { pval=2, to_d=5, to_h=5 },
  },
  rating = 20,
}

-- Weapon/Demonblade of Extra Attacks
newEntity {
  define_as = 'EXTRA_ATTACKS',
  name = [[of Extra Attacks]],
  suffix = true,
  level = 0,
  rarity = { 1, 44 },
  cost = 10000,
  ego_filter = {
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, { pval_flags = { extra_blows=true } } },
    bonus = { pval=3 },
  },
  obvious_flags = { pval_flags = { extra_blows=true } },
  rating = 20,
}

-- Weapon/Boomerang/Demonblade of Slaying
newEntity {
  define_as = 'SLAYING_WPN',
  name = [[of Slaying]],
  suffix = true,
  level = 0,
  rarity = { 2, 44 },
  cost = 2500,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      flags = { WOUNDING=true },
      resolvers.ego_slaying()
    } },
  },
  rating = 15,
}

-- Weapon/Demonblade of Spinning
newEntity {
  define_as = 'SPINNING',
  name = [[of Spinning]],
  suffix = true,
  level = 0,
  rarity = { 1, 44 },
  cost = 9000,
  ego_filter = {
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      stat_flags = { DEX=true, STR=true },
      flags = { VORPAL=true }
    } },
    bonus = { pval=2, to_d=8, to_h=8 },
    all = {
      -- BEGIN VERBATIM ALL
      use_power = {
	-- Oddly, in the T2 code this activation manually attacks adjacent
	-- monsters, while the apparently equivalent Whirlwind prayer just
	-- fires a radius-1 caster-centered ball of PY_ATTACK.  We do the
	-- latter here for simplicity.
	use = function(self, who, inven, floor, item)
	  local DamageType = require 'engine.DamageType'
	  local ret = spell.ball_spell(who, nil, DamageType.ATTACK, 1, 1, who.x, who.y)
	  return { used=ret }
	end,
	power = { 50, 25 },
	name = 'strike all adjacent monsters with a single melee blow',
      },
      cant_use_if = { not_wielded=true },
      power = 0,
      power_regen = -1,
      -- END VERBATIM
    },
  },
  rating = 18,
}

-- Acidic Weapon/Boomerang/Demonblade
newEntity {
  define_as = 'ACIDIC',
  name = [[Acidic]],
  prefix = true,
  level = 0,
  rarity = { 4, 44 },
  cost = 5000,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ACID]=true },
      brand_dam = { [DamageType.ACID]=true },
      ignore_dam = { [DamageType.ACID]=true }
    } },
  },
  obvious_flags = { brand_dam = { [DamageType.ACID]=true } },
  rating = 15,
}

-- Shocking Weapon/Boomerang/Demonblade
newEntity {
  define_as = 'SHOCKING',
  name = [[Shocking]],
  prefix = true,
  level = 0,
  rarity = { 4, 44 },
  cost = 4500,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ELEC]=true },
      brand_dam = { [DamageType.ELEC]=true },
      ignore_dam = { [DamageType.ELEC]=true }
    } },
  },
  obvious_flags = { brand_dam = { [DamageType.ELEC]=true } },
  rating = 20,
}

-- Fiery Weapon/Boomerang/Demonblade
newEntity {
  define_as = 'FIERY',
  name = [[Fiery]],
  prefix = true,
  level = 0,
  rarity = { 4, 44 },
  cost = 3500,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      lite = 1,
      convey_resist_dam = { [DamageType.FIRE]=true },
      brand_dam = { [DamageType.FIRE]=true },
      ignore_dam = { [DamageType.FIRE]=true }
    } },
  },
  obvious_flags = { brand_dam = { [DamageType.FIRE]=true } },
  rating = 20,
}

-- Frozen Weapon/Boomerang/Demonblade
newEntity {
  define_as = 'FROZEN',
  name = [[Frozen]],
  prefix = true,
  level = 0,
  rarity = { 4, 44 },
  cost = 3000,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.COLD]=true },
      brand_dam = { [DamageType.COLD]=true },
      ignore_dam = { [DamageType.COLD]=true }
    } },
  },
  obvious_flags = { brand_dam = { [DamageType.COLD]=true } },
  rating = 15,
}

-- Venomous Weapon/Boomerang/Demonblade
newEntity {
  define_as = 'VENOMOUS',
  name = [[Venomous]],
  prefix = true,
  level = 0,
  rarity = { 4, 44 },
  cost = 4000,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.POISON]=true },
      brand_dam = { [DamageType.POISON]=true }
    } },
  },
  obvious_flags = { brand_dam = { [DamageType.POISON]=true } },
  rating = 20,
}

-- Chaotic Weapon/Demonblade (except Blade of Chaos)
newEntity {
  define_as = 'CHAOTIC',
  name = [[Chaotic]],
  prefix = true,
  level = 0,
  rarity = { 1, 44 },
  cost = 10000,
  ego_filter = {
    { tval = 21 },
    { tval = 22 },
    { tval = 23, sval={0,29} },
    { tval = 23, sval={31,255} },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.CHAOS]=true },
      flags = { CHAOTIC=true },
      ignore_dam = { [DamageType.ELEC]=true, [DamageType.ACID]=true, [DamageType.FIRE]=true },
      resolvers.ego_any_resist()
    } },
  },
  obvious_flags = { flags = { CHAOTIC=true } },
  rating = 28,
}

-- Sharp Sword/Axe/Demonblade
newEntity {
  define_as = 'SHARP',
  name = [[Sharp]],
  prefix = true,
  level = 0,
  rarity = { 2, 44 },
  cost = 5000,
  ego_filter = {
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, { flags = { VORPAL=true } } },
  },
  obvious_flags = { flags = { VORPAL=true } },
  rating = 20,
}

-- Hafted/Demonblade of Earthquakes
newEntity {
  define_as = 'EARTHQUAKES',
  name = [[of Earthquakes]],
  suffix = true,
  level = 0,
  rarity = { 1, 44 },
  cost = 4000,
  ego_filter = {
    { tval = 21 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      convey_flags = { IMPACT=true },
      stat_flags = { STR=true },
      pval_flags = { adj_digging=true },
      flags = { HIDE_TYPE=true }
    } },
    bonus = { pval=6, to_d=10, to_h=10 },
  },
  obvious_flags = { convey_flags = { IMPACT=true } },
  rating = 20,
}

-- Weapon/Boomerang/Demonblade of Slay Animal
newEntity {
  define_as = 'SLAY_ANIMAL_WPN',
  name = [[of Slay Animal]],
  suffix = true,
  level = 0,
  rarity = { 6, 44 },
  cost = 3500,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, { slay_flags = { ANIMAL=true } } },
  },
  obvious_flags = { slay_flags = { ANIMAL=true } },
  rating = 18,
}

-- Weapon/Boomerang/Demonblade of Slay Evil
newEntity {
  define_as = 'SLAY_EVIL_WPN',
  name = [[of Slay Evil]],
  suffix = true,
  level = 0,
  rarity = { 6, 44 },
  cost = 3500,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, { slay_flags = { EVIL=true } } },
  },
  obvious_flags = { slay_flags = { EVIL=true } },
  rating = 18,
}

-- Weapon/Boomerang/Demonblade (except Mace of Disruption) of Slay Undead
newEntity {
  define_as = 'SLAY_UNDEAD_WPN',
  name = [[of Slay Undead]],
  suffix = true,
  level = 0,
  rarity = { 6, 44 },
  cost = 3500,
  ego_filter = {
    { tval = 15 },
    { tval = 21, sval={0,19} },
    { tval = 21, sval={21,255} },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, { slay_flags = { UNDEAD=true } } },
  },
  obvious_flags = { slay_flags = { UNDEAD=true } },
  rating = 18,
}

-- Weapon/Boomerang/Demonblade of Slay Demon
newEntity {
  define_as = 'SLAY_DEMON_WPN',
  name = [[of Slay Demon]],
  suffix = true,
  level = 0,
  rarity = { 6, 44 },
  cost = 2500,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, { slay_flags = { DEMON=true } } },
  },
  obvious_flags = { slay_flags = { DEMON=true } },
  rating = 14,
}

-- Weapon/Boomerang/Demonblade of Slay Orc
newEntity {
  define_as = 'SLAY_ORC',
  name = [[of Slay Orc]],
  suffix = true,
  level = 0,
  rarity = { 6, 44 },
  cost = 2500,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, { slay_flags = { ORC=true } } },
  },
  obvious_flags = { slay_flags = { ORC=true } },
  rating = 10,
}

-- Weapon/Boomerang/Demonblade of Slay Troll
newEntity {
  define_as = 'SLAY_TROLL',
  name = [[of Slay Troll]],
  suffix = true,
  level = 0,
  rarity = { 6, 44 },
  cost = 2500,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, { slay_flags = { TROLL=true } } },
  },
  obvious_flags = { slay_flags = { TROLL=true } },
  rating = 10,
}

-- Weapon/Boomerang/Demonblade of Slay Giant
newEntity {
  define_as = 'SLAY_GIANT',
  name = [[of Slay Giant]],
  suffix = true,
  level = 0,
  rarity = { 6, 44 },
  cost = 2500,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, { slay_flags = { GIANT=true } } },
  },
  obvious_flags = { slay_flags = { GIANT=true } },
  rating = 14,
}

-- Weapon/Boomerang/Demonblade of Slay Dragon
newEntity {
  define_as = 'SLAY_DRAGON_WPN',
  name = [[of Slay Dragon]],
  suffix = true,
  level = 0,
  rarity = { 6, 44 },
  cost = 3500,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, { slay_flags = { DRAGON=true } } },
  },
  obvious_flags = { slay_flags = { DRAGON=true } },
  rating = 18,
}

-- Weapon/Boomerang/Demonblade of *Slay Animal*
newEntity {
  define_as = 'STAR_SLAY_ANIMAL',
  name = [[of *Slay Animal*]],
  suffix = true,
  level = 0,
  rarity = { 2, 44 },
  cost = 6000,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      slay_flags = { ANIMAL=true },
      convey_flags = { SLOW_DIGEST=true },
      stat_flags = { INT=true },
      pval_flags = { skill_stealth=true },
      esp_flags = { ANIMAL=true }
    } },
    bonus = { pval=2 },
  },
  obvious_flags = {
    slay_flags = { ANIMAL=true },
    pval_flags = { skill_stealth=true }
  },
  rating = 20,
}

-- Weapon/Demonblade of *Slay Evil*
newEntity {
  define_as = 'STAR_SLAY_EVIL',
  name = [[of *Slay Evil*]],
  suffix = true,
  level = 0,
  rarity = { 2, 44 },
  cost = 6000,
  ego_filter = {
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.FEAR]=true },
      slay_flags = { EVIL=true },
      convey_flags = { BLESSED=true },
      stat_flags = { WIS=true },
      esp_flags = { EVIL=true },
      resolvers.ego_abil_flag()
    } },
    bonus = { pval=2 },
  },
  obvious_flags = { slay_flags = { EVIL=true } },
  rating = 20,
}

-- Weapon/Boomerang/Demonblade of *Slay Undead*
newEntity {
  define_as = 'STAR_SLAY_UNDEAD',
  name = [[of *Slay Undead*]],
  suffix = true,
  level = 0,
  rarity = { 2, 44 },
  cost = 8000,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.NETHER]=true },
      slay_flags = { X_UNDEAD=true },
      convey_flags = { SEE_INVIS=true },
      stat_flags = { WIS=true },
      esp_flags = { UNDEAD=true }
    } },
    bonus = { pval=2 },
  },
  obvious_flags = { slay_flags = { X_UNDEAD=true } },
  rating = 24,
}

-- Weapon/Boomerang/Demonblade of *Slay Demon*
newEntity {
  define_as = 'STAR_SLAY_DEMON',
  name = [[of *Slay Demon*]],
  suffix = true,
  level = 0,
  rarity = { 2, 44 },
  cost = 8000,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.FIRE]=true, [DamageType.CHAOS]=true },
      slay_flags = { X_DEMON=true },
      stat_flags = { INT=true },
      esp_flags = { DEMON=true }
    } },
    bonus = { pval=2 },
  },
  obvious_flags = { slay_flags = { X_DEMON=true } },
  rating = 16,
}

-- Weapon/Boomerang/Demonblade of *Slay Orc*
newEntity {
  define_as = 'STAR_SLAY_ORC',
  name = [[of *Slay Orc*]],
  suffix = true,
  level = 0,
  rarity = { 2, 44 },
  cost = 4000,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      slay_flags = { ORC=true },
      convey_flags = { SUST_DEX=true },
      stat_flags = { DEX=true },
      esp_flags = { ORC=true }
    } },
    bonus = { pval=2 },
  },
  obvious_flags = { slay_flags = { ORC=true } },
  rating = 14,
}

-- Weapon/Boomerang/Demonblade of *Slay Troll*
newEntity {
  define_as = 'STAR_SLAY_TROLL',
  name = [[of *Slay Troll*]],
  suffix = true,
  level = 0,
  rarity = { 2, 44 },
  cost = 4000,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      slay_flags = { TROLL=true },
      convey_flags = { REGENERATE=true, SUST_STR=true },
      stat_flags = { STR=true },
      esp_flags = { TROLL=true }
    } },
    bonus = { pval=2 },
  },
  obvious_flags = { slay_flags = { TROLL=true } },
  rating = 14,
}

-- Weapon/Boomerang/Demonblade of *Slay Giant*
newEntity {
  define_as = 'STAR_SLAY_GIANT',
  name = [[of *Slay Giant*]],
  suffix = true,
  level = 0,
  rarity = { 2, 44 },
  cost = 4000,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.SHARDS]=true },
      slay_flags = { GIANT=true },
      convey_flags = { SUST_STR=true },
      stat_flags = { STR=true },
      esp_flags = { GIANT=true }
    } },
    bonus = { pval=2 },
  },
  obvious_flags = { slay_flags = { GIANT=true } },
  rating = 16,
}

-- Weapon/Boomerang/Demonblade of *Slay Dragon*
newEntity {
  define_as = 'STAR_SLAY_DRAGON',
  name = [[of *Slay Dragon*]],
  suffix = true,
  level = 0,
  rarity = { 2, 44 },
  cost = 8000,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.FEAR]=true },
      slay_flags = { X_DRAGON=true },
      stat_flags = { CON=true },
      esp_flags = { DRAGON=true },
      resolvers.ego_low_resist(),
      resolvers.ego_elem_resist()
    } },
    { 20, { convey_resist_dam = { [DamageType.POISON]=true } } },
    bonus = { pval=2 },
  },
  obvious_flags = { slay_flags = { X_DRAGON=true } },
  rating = 24,
}

-- Vampiric Sword/Demonblade
newEntity {
  define_as = 'VAMPIRIC',
  name = [[Vampiric]],
  prefix = true,
  level = 0,
  rarity = { 2, 44 },
  cost = 10000,
  ego_filter = {
    { tval = 23 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      convey_flags = { HOLD_LIFE=true },
      pval_flags = { hp_mult=true },
      flags = { VAMPIRIC=true }
    } },
    bonus = { pval=-2 },
  },
  obvious_flags = {
    pval_flags = { hp_mult=true },
    flags = { VAMPIRIC=true }
  },
  rating = 25,
}

-- Weapon (*Defender*)
newEntity {
  define_as = 'STAR_DEFENDER',
  name = [[(*Defender*)]],
  suffix = true,
  level = 0,
  rarity = { 1, 100 },
  cost = 50000,
  ego_filter = {
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.POISON]=true, [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      convey_flags = { HOLD_LIFE=true, FREE_ACT=true, SEE_INVIS=true, FEATHER=true, REGENERATE=true },
      stat_flags = { DEX=true, CON=true, WIS=true },
      pval_flags = { skill_stealth=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      resolvers.ego_any_resist(),
      resolvers.ego_low_resist(),
      resolvers.ego_sustain()
    } },
    { 30, {
      resolvers.ego_any_resist(),
      resolvers.ego_low_resist(),
      resolvers.ego_sustain()
    } },
    { 20, {
      resolvers.ego_any_resist(),
      resolvers.ego_low_resist(),
      resolvers.ego_sustain(),
      resolvers.ego_high_resist()
    } },
    { 10, {
      resolvers.ego_immunity(),
      resolvers.ego_any_resist()
    } },
    bonus = { to_a=20, pval=4, to_d=-15, to_h=-15 },
  },
  obvious_flags = { pval_flags = { skill_stealth=true } },
  rating = 35,
}

-- Weapon of the Thunderlords
newEntity {
  define_as = 'THUNDERLORDS',
  name = [[of the Thunderlords]],
  suffix = true,
  level = 0,
  rarity = { 1, 100 },
  cost = 7000,
  ego_filter = {
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.NEXUS]=true },
      brand_dam = { [DamageType.ELEC]=true },
      slay_flags = { EVIL=true, X_DRAGON=true },
      convey_flags = { TELEPORT=true, FREE_ACT=true, REGENERATE=true, SLOW_DIGEST=true, FLY=true },
      pval_flags = { skill_searching=true },
      esp_flags = { DRAGON=true },
      resolvers.ego_high_resist()
    } },
    { 12, { resolvers.ego_abil_flag() } },
    { 2, {
      flags = { LIMIT_BLOWS=true },
      resolvers.ego_pval_flag(),
      resolvers.ego_adjust_field('pval', 3)
    } },
    bonus = { pval=2, to_d=4, to_h=4 },
    all = {
      -- BEGIN VERBATIM ALL
      use_power = {
	use = function(self, who, inven, floor, item)
	  game.logPlayer(who, 'Your %s twists space around you...', self:getName{no_count=true, no_mods=true, no_pval=true, no_inscr=true})
	  spell.teleport(who, 100)
	  return { used=true }
	end,
	power = 45,
	name = 'teleport (range 100)',
      },
      cant_use_if = { not_wielded=true },
      power = 45,
      max_power = 45,
      power_regen = 1,
      -- END VERBATIM
    },
  },
  rating = 22,
}

-- Weapon of Gondolin
newEntity {
  define_as = 'GONDOLIN',
  name = [[of Gondolin]],
  suffix = true,
  level = 0,
  rarity = { 1, 44 },
  cost = 25000,
  ego_filter = {
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
  },
  resolve_data = {
    { 100, {
      lite = 1,
      convey_resist_dam = { [DamageType.FEAR]=true, [DamageType.DARK]=true },
      slay_flags = { EVIL=true, TROLL=true, DRAGON=true, DEMON=true },
      convey_flags = { FREE_ACT=true, SEE_INVIS=true },
      stat_flags = { STR=true, CON=true },
      esp_flags = { EVIL=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.FIRE]=true },
      resolvers.ego_abil_flag()
    } },
    { 33, { resolvers.ego_high_resist() } },
    { 33, { convey_flags = { HOLD_LIFE=true } } },
    { 22, { stat_flags = { DEX=true } } },
    bonus = { pval=3, to_d=7, to_h=7 },
  },
  rating = 26,
}

-- Digger of Digging
newEntity {
  define_as = 'DIGGING',
  name = [[of Digging]],
  suffix = true,
  level = 0,
  rarity = { 1, 2 },
  cost = 500,
  ego_filter = {
    { tval = 20 },
  },
  resolve_data = {
    { 100, {
      pval_flags = { adj_digging=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true }
    } },
    bonus = { pval=5 },
  },
  obvious_flags = { pval_flags = { adj_digging=true } },
  rating = 4,
}

-- Spectral Weapon/Demonblade
newEntity {
  define_as = 'SPECTRAL',
  name = [[Spectral]],
  prefix = true,
  level = 0,
  rarity = { 1, 5 },
  cost = 5000,
  ego_filter = {
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      slay_flags = { UNDEAD=true },
      convey_flags = { SEE_INVIS=true, HOLD_LIFE=true },
      cum_flags = { drain_hp=true }
    } },
    all = {
      -- BEGIN VERBATIM ALL
      use_power = {
	use = function(self, who, inven, floor, item)
	  who:setEffect(who.EFF_WRAITH_FORM, rng.range(1, 20), {merge=function(c,n) return n+20 end})
	  return { used=true }
	end,
	power = { 50, 50 },
	name = 'confer temporary wraith form',
      },
      cant_use_if = { not_wielded=true },
      power = 0,
      power_regen = -1,
      -- END VERBATIM
    },
  },
  rating = 30,
}

-- Weapon/Demonblade of Morgul
newEntity {
  define_as = 'MORGUL',
  name = [[of Morgul]],
  suffix = true,
  level = 0,
  rarity = { 1, 1 },
  cost = 0,
  ego_filter = {
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
  },
  resolve_data = {
    { 100, {
      convey_flags = { SEE_INVIS=true, AGGRAVATE=true, BLACK_BREATH=true, DRAIN_EXP=true },
      pval_flags = { adj_luck=true },
      flags = { HEAVY_CURSE=true, CURSED=true, AUTO_CURSE=true, WOUNDING=true }
    } },
    bonus = { to_a=-10, pval=-10, to_d=-20, to_h=-20 },
  },
}

-- Weapon/Boomerang of Nothingness
newEntity {
  define_as = 'NOTHINGNESS',
  name = [[of Nothingness]],
  suffix = true,
  level = 0,
  rarity = { 1, 2 },
  cost = 0,
  ego_filter = {
    { tval = 15 },
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
  },
  resolve_data = {
    { 100, { flags = { NEVER_BLOW=true, HEAVY_CURSE=true, CURSED=true, AUTO_CURSE=true } } },
    bonus = { to_d=-100, to_h=-100 },
  },
}

-- Launcher/Boomerang of Accuracy
newEntity {
  define_as = 'ACCURACY',
  name = [[of Accuracy]],
  suffix = true,
  level = 0,
  rarity = { 8, 21 },
  cost = 1000,
  ego_filter = {
    { tval = 19 },
    { tval = 15 },
  },
  resolve_data = {
    bonus = { to_d=5, to_h=15 },
  },
  rating = 10,
}

-- Launcher/Boomerang of Power
newEntity {
  define_as = 'POWER_RANGED',
  name = [[of Power]],
  suffix = true,
  level = 0,
  rarity = { 8, 21 },
  cost = 1000,
  ego_filter = {
    { tval = 19 },
    { tval = 15 },
  },
  resolve_data = {
    bonus = { to_d=15, to_h=5 },
  },
  rating = 10,
}

-- Launcher of Extra Might
newEntity {
  define_as = 'EXTRA_MIGHT_BOW',
  name = [[of Extra Might]],
  suffix = true,
  level = 0,
  rarity = { 4, 21 },
  cost = 10000,
  ego_filter = {
    { tval = 19 },
  },
  resolve_data = {
    { 100, {
      pval_flags = { extra_might=true },
      resolvers.ego_adjust_field('pval', 3),
      resolvers.ego_any_resist()
    } },
    bonus = { pval=1, to_d=10, to_h=5 },
  },
  obvious_flags = { pval_flags = { extra_might=true } },
  rating = 20,
}

-- Launcher of Extra Shots
newEntity {
  define_as = 'EXTRA_SHOTS_BOW',
  name = [[of Extra Shots]],
  suffix = true,
  level = 0,
  rarity = { 4, 21 },
  cost = 10000,
  ego_filter = {
    { tval = 19 },
  },
  resolve_data = {
    { 100, {
      cum_flags = { extra_shots=true },
      resolvers.ego_adjust_field('pval', 2)
    } },
    bonus = { pval=1, to_d=5, to_h=10 },
  },
  obvious_flags = { cum_flags = { extra_shots=true } },
  rating = 20,
}

-- Bow of Lothlorien
newEntity {
  define_as = 'LOTHLORIEN',
  name = [[of Lothlórien]],
  suffix = true,
  level = 50,
  rarity = { 2, 21 },
  cost = 30000,
  ego_filter = {
    { tval = 19, sval={12,13} },
  },
  resolve_data = {
    { 100, {
      convey_flags = { FREE_ACT=true, BLESSED=true },
      stat_flags = { DEX=true },
      pval_flags = { extra_might=true },
      flags = { HIDE_TYPE=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.FIRE]=true },
      resolvers.ego_abil_flag()
    } },
    bonus = { pval=2, to_d=10, to_h=10 },
  },
  rating = 20,
}

-- Crossbow of the Haradrim
newEntity {
  define_as = 'HARADRIM',
  name = [[of the Haradrim]],
  suffix = true,
  level = 50,
  rarity = { 2, 21 },
  cost = 20000,
  ego_filter = {
    { tval = 19, sval={23,24} },
  },
  resolve_data = {
    { 100, {
      pval_flags = { extra_might=true },
      cum_flags = { extra_shots=true },
      flags = { HIDE_TYPE=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.FIRE]=true }
    } },
    bonus = { pval=1, to_d=15, to_h=5 },
  },
  rating = 30,
}

-- Sling of Buckland
newEntity {
  define_as = 'BUCKLAND',
  name = [[of Buckland]],
  suffix = true,
  level = 40,
  rarity = { 2, 21 },
  cost = 20000,
  ego_filter = {
    { tval = 19, sval=2 },
  },
  resolve_data = {
    { 100, {
      stat_flags = { DEX=true },
      pval_flags = { extra_might=true },
      cum_flags = { extra_shots=true },
      flags = { HIDE_TYPE=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.FIRE]=true }
    } },
    bonus = { pval=2, to_d=8, to_h=8 },
  },
  rating = 25,
}

-- Ammo of Slay Animal
newEntity {
  define_as = 'SLAY_ANIMAL_AMMO',
  name = [[of Slay Animal]],
  suffix = true,
  level = 0,
  rarity = { 2, 12 },
  cost = 25,
  ego_filter = {
    { tval = 16, sval={0,99} },
    { tval = 17, sval={0,99} },
    { tval = 18, sval={0,99} },
  },
  resolve_data = {
    { 100, { slay_flags = { ANIMAL=true } } },
  },
  obvious_flags = { slay_flags = { ANIMAL=true } },
  rating = 10,
}

-- Ammo of Slay Evil
newEntity {
  define_as = 'SLAY_EVIL_AMMO',
  name = [[of Slay Evil]],
  suffix = true,
  level = 0,
  rarity = { 2, 12 },
  cost = 25,
  ego_filter = {
    { tval = 16, sval={0,99} },
    { tval = 17, sval={0,99} },
    { tval = 18, sval={0,99} },
  },
  resolve_data = {
    { 100, { slay_flags = { EVIL=true } } },
  },
  obvious_flags = { slay_flags = { EVIL=true } },
  rating = 10,
}

-- Ammo of Slay Undead
newEntity {
  define_as = 'SLAY_UNDEAD_AMMO',
  name = [[of Slay Undead]],
  suffix = true,
  level = 0,
  rarity = { 1, 12 },
  cost = 35,
  ego_filter = {
    { tval = 16, sval={0,99} },
    { tval = 17, sval={0,99} },
    { tval = 18, sval={0,99} },
  },
  resolve_data = {
    { 100, { slay_flags = { UNDEAD=true } } },
  },
  obvious_flags = { slay_flags = { UNDEAD=true } },
  rating = 10,
}

-- Ammo (except Silver Arrow/Bolt) of Venom
newEntity {
  define_as = 'VENOM',
  name = [[of Venom]],
  suffix = true,
  level = 0,
  rarity = { 2, 12 },
  cost = 25,
  ego_filter = {
    { tval = 16, sval={0,99} },
    { tval = 17, sval={0,2} },
    { tval = 18, sval={0,2} },
  },
  resolve_data = {
    { 100, { brand_dam = { [DamageType.POISON]=true } } },
  },
  obvious_flags = { brand_dam = { [DamageType.POISON]=true } },
  rating = 10,
}

-- Ammo of Acid
newEntity {
  define_as = 'ACID',
  name = [[of Acid]],
  suffix = true,
  level = 0,
  rarity = { 1, 12 },
  cost = 30,
  ego_filter = {
    { tval = 16, sval={0,99} },
    { tval = 17, sval={0,99} },
    { tval = 18, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      brand_dam = { [DamageType.ACID]=true },
      ignore_dam = { [DamageType.ACID]=true }
    } },
  },
  obvious_flags = { brand_dam = { [DamageType.ACID]=true } },
  rating = 10,
}

-- Elemental Weapon
newEntity {
  define_as = 'ELEMENTAL',
  name = [[Elemental]],
  prefix = true,
  level = 10,
  rarity = { 1, 50 },
  cost = 26000,
  ego_filter = {
    { tval = 21, sval={0,99} },
    { tval = 22, sval={0,99} },
    { tval = 23, sval={0,99} },
    { tval = 24, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true, [DamageType.POISON]=true },
      brand_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true, [DamageType.POISON]=true },
      cum_flags = { drain_mana=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true }
    } },
  },
  obvious_flags = { brand_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true, [DamageType.POISON]=true } },
  rating = 30,
}

-- Ammo of Slay Demon
newEntity {
  define_as = 'SLAY_DEMON_AMMO',
  name = [[of Slay Demon]],
  suffix = true,
  level = 0,
  rarity = { 1, 12 },
  cost = 35,
  ego_filter = {
    { tval = 16, sval={0,99} },
    { tval = 17, sval={0,99} },
    { tval = 18, sval={0,99} },
  },
  resolve_data = {
    { 100, { slay_flags = { DEMON=true } } },
  },
  obvious_flags = { slay_flags = { DEMON=true } },
  rating = 10,
}

-- Ammo of Slay Dragon
newEntity {
  define_as = 'SLAY_DRAGON_AMMO',
  name = [[of Slay Dragon]],
  suffix = true,
  level = 0,
  rarity = { 1, 12 },
  cost = 35,
  ego_filter = {
    { tval = 16, sval={0,99} },
    { tval = 17, sval={0,99} },
    { tval = 18, sval={0,99} },
  },
  resolve_data = {
    { 100, { slay_flags = { DRAGON=true } } },
  },
  obvious_flags = { slay_flags = { DRAGON=true } },
  rating = 10,
}

-- Ammo of Lightning
newEntity {
  define_as = 'LIGHTNING',
  name = [[of Lightning]],
  suffix = true,
  level = 0,
  rarity = { 1, 12 },
  cost = 30,
  ego_filter = {
    { tval = 16, sval={0,99} },
    { tval = 17, sval={0,99} },
    { tval = 18, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      brand_dam = { [DamageType.ELEC]=true },
      ignore_dam = { [DamageType.ELEC]=true }
    } },
  },
  obvious_flags = { brand_dam = { [DamageType.ELEC]=true } },
  rating = 10,
}

-- Ammo of Flame
newEntity {
  define_as = 'FLAME',
  name = [[of Flame]],
  suffix = true,
  level = 0,
  rarity = { 2, 12 },
  cost = 25,
  ego_filter = {
    { tval = 16, sval={0,99} },
    { tval = 17, sval={0,99} },
    { tval = 18, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      brand_dam = { [DamageType.FIRE]=true },
      ignore_dam = { [DamageType.FIRE]=true }
    } },
  },
  obvious_flags = { brand_dam = { [DamageType.FIRE]=true } },
  rating = 10,
}

-- Ammo of Frost
newEntity {
  define_as = 'FROST',
  name = [[of Frost]],
  suffix = true,
  level = 0,
  rarity = { 2, 12 },
  cost = 25,
  ego_filter = {
    { tval = 16, sval={0,99} },
    { tval = 17, sval={0,99} },
    { tval = 18, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      brand_dam = { [DamageType.COLD]=true },
      ignore_dam = { [DamageType.COLD]=true }
    } },
  },
  obvious_flags = { brand_dam = { [DamageType.COLD]=true } },
  rating = 10,
}

-- Ammo of Wounding
newEntity {
  define_as = 'WOUNDING',
  name = [[of Wounding]],
  suffix = true,
  level = 0,
  rarity = { 3, 12 },
  cost = 20,
  ego_filter = {
    { tval = 16, sval={0,99} },
    { tval = 17, sval={0,99} },
    { tval = 18, sval={0,99} },
  },
  resolve_data = {
    bonus = { to_d=6, to_h=6 },
  },
  rating = 5,
}

-- Ammo of Backbiting
newEntity {
  define_as = 'BACKBITING',
  name = [[of Backbiting]],
  suffix = true,
  level = 0,
  rarity = { 1, 2 },
  cost = 0,
  ego_filter = {
    { tval = 16, sval={0,99} },
    { tval = 17, sval={0,99} },
    { tval = 18, sval={0,99} },
  },
  resolve_data = {
    bonus = { to_d=-50, to_h=-50 },
  },
}

-- Shattered Ammo
newEntity {
  define_as = 'SHATTERED',
  name = [[Shattered]],
  prefix = true,
  level = 0,
  rarity = { 1, 2 },
  cost = 0,
  ego_filter = {
    { tval = 16, sval={0,99} },
    { tval = 17, sval={0,99} },
    { tval = 18, sval={0,99} },
  },
  resolve_data = {
    bonus = { to_d=-5, to_h=-5 },
  },
}

-- Blasted Ammo
newEntity {
  define_as = 'BLASTED',
  name = [[Blasted]],
  prefix = true,
  level = 0,
  rarity = { 1, 2 },
  cost = 0,
  ego_filter = {
    { tval = 16, sval={0,99} },
    { tval = 17, sval={0,99} },
    { tval = 18, sval={0,99} },
  },
  resolve_data = {
    bonus = { to_a=-10 },
  },
}

-- Drum/Harp of the Eldar
newEntity {
  define_as = 'ELDAR',
  name = [[of the Eldar]],
  suffix = true,
  level = 0,
  rarity = { 2, 3 },
  cost = 1000,
  ego_filter = {
    { tval = 14, sval={0,59} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.ACID]=true },
      convey_flags = { SEE_INVIS=true },
      stat_flags = { CHA=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      resolvers.ego_any_resist(),
      resolvers.ego_adjust_field('pval', 2)
    } },
    { 25, { resolvers.ego_adjust_field('pval', 1) } },
  },
  rating = 20,
}

-- Drum/Harp of Power
newEntity {
  define_as = 'POWER_INSTRUMENT',
  name = [[of Power]],
  suffix = true,
  level = 0,
  rarity = { 1, 3 },
  cost = 2000,
  ego_filter = {
    { tval = 14, sval={0,59} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.FIRE]=true, [DamageType.COLD]=true, [DamageType.ELEC]=true, [DamageType.ACID]=true },
      convey_flags = { SUST_CHA=true, SEE_INVIS=true },
      stat_flags = { CHA=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      resolvers.ego_any_resist(),
      resolvers.ego_adjust_field('pval', 3)
    } },
    { 50, { resolvers.ego_adjust_field('pval', 1) } },
    { 35, { resolvers.ego_adjust_field('pval', 1) } },
  },
  rating = 20,
}

-- Dragon Horn
newEntity {
  define_as = 'DRAGON',
  name = [[Dragon]],
  prefix = true,
  level = 0,
  rarity = { 1, 2 },
  cost = 2000,
  ego_filter = {
    { tval = 14, sval=60 },
  },
  resolve_data = {
    { 100, {
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      resolvers.ego_any_resist(),
      resolvers.ego_adjust_field('pval', 2)
    } },
    { 50, { resolvers.ego_adjust_field('pval', 1) } },
    { 25, { resolvers.ego_adjust_field('pval', 1) } },
    all = {
      -- BEGIN VERBATIM ALL
      use_power = {
	use = function(self, who, inven, floor, item)
	  local DamageType = require 'engine.DamageType'
	  local ret = spell.ball_spell(who, nil, DamageType.ACID, 300, 7, nil, nil, 20)
	  return { used=ret }
	end,
	power = 100,
	name = 'fire a ball of acid (dam 300, rad 7)'
      },
      cant_use_if = { not_wielded=true },
      power = 100,
      max_power = 100,
      power_regen = 1,
      -- END VERBATIM
    },
  },
  rating = 20,
}

-- Rod of Capacity
newEntity {
  define_as = 'CAPACITY',
  name = [[of Capacity]],
  suffix = true,
  level = 0,
  rarity = { 2, 10 },
  cost = 1000,
  ego_filter = {
    { tval = 67 },
  },
  resolve_data = {
    { 100, {
      flags = { CAPACITY=true },
      resolvers.ego_rod()
    } },
  },
  obvious_flags = { flags = { CAPACITY=true } },
  rating = 10,
}

-- Rod of Cheapness
newEntity {
  define_as = 'CHEAPNESS',
  name = [[of Cheapness]],
  suffix = true,
  level = 0,
  rarity = { 2, 10 },
  cost = 700,
  ego_filter = {
    { tval = 67 },
  },
  resolve_data = {
    { 100, { flags = { CHEAPNESS=true } } },
  },
  obvious_flags = { flags = { CHEAPNESS=true } },
  rating = 10,
}

-- Rod of Quickness
newEntity {
  define_as = 'QUICKNESS',
  name = [[of Quickness]],
  suffix = true,
  level = 0,
  rarity = { 3, 10 },
  cost = 1100,
  ego_filter = {
    { tval = 67 },
  },
  resolve_data = {
    { 100, {
      flags = { FAST_CAST=true },
      resolvers.ego_rod()
    } },
  },
  obvious_flags = { flags = { FAST_CAST=true } },
  rating = 15,
}

-- Rod of Charging
newEntity {
  define_as = 'CHARGING',
  name = [[of Charging]],
  suffix = true,
  level = 0,
  rarity = { 2, 10 },
  cost = 1500,
  ego_filter = {
    { tval = 67 },
  },
  resolve_data = {
    { 100, {
      flags = { CHARGING=true },
      resolvers.ego_rod()
    } },
  },
  obvious_flags = { flags = { CHARGING=true } },
  rating = 15,
}

-- Rod of the Istari
newEntity {
  define_as = 'ISTARI',
  name = [[of the Istari]],
  suffix = true,
  level = 0,
  rarity = { 1, 10 },
  cost = 10000,
  ego_filter = {
    { tval = 67 },
  },
  resolve_data = {
    { 100, {
      flags = { CAPACITY=true, CHARGING=true, CHEAPNESS=true, FAST_CAST=true },
      resolvers.ego_rod()
    } },
  },
  rating = 10,
}

-- Light of Boldness
newEntity {
  define_as = 'BOLDNESS',
  name = [[of Boldness]],
  suffix = true,
  level = 0,
  rarity = { 1, 5 },
  cost = 1000,
  ego_filter = {
    { tval = 39, sval={0,99} },
  },
  resolve_data = {
    all = {
      worn_talents = { ActorTalents.T_ORC_REMOVE_FEAR },
    },
  },
  rating = 5,
}

-- Light of Fearlessness
newEntity {
  define_as = 'FEARLESSNESS',
  name = [[of Fearlessness]],
  suffix = true,
  level = 0,
  rarity = { 1, 10 },
  cost = 1500,
  ego_filter = {
    { tval = 39, sval={0,99} },
  },
  resolve_data = {
    { 100, { convey_resist_dam = { [DamageType.FEAR]=true } } },
  },
  rating = 5,
}

-- Light of Illumination
newEntity {
  define_as = 'ILLUMINATION',
  name = [[of Illumination]],
  suffix = true,
  level = 0,
  rarity = { 3, 10 },
  cost = 1000,
  ego_filter = {
    { tval = 39, sval={0,99} },
  },
  resolve_data = {
    { 10, { lite = 1 } },
    { 5, { lite = 2 } },
    { 2, { lite = 3 } },
    all = {
      worn_talents = { ActorTalents.T_OBJ_ILLUMINATE },
    },
  },
  rating = 5,
}

-- Light of Brightness
newEntity {
  define_as = 'BRIGHTNESS',
  name = [[of Brightness]],
  suffix = true,
  level = 0,
  rarity = { 3, 10 },
  cost = 1000,
  ego_filter = {
    { tval = 39, sval={0,99} },
  },
  resolve_data = {
    { 100, { lite = 1 } },
    { 60, { lite = 2 } },
    { 30, { lite = 3 } },
    { 30, { convey_resist_dam = { [DamageType.DARK]=true } } },
  },
  obvious_flags = { lite = 1 },
  rating = 5,
}

-- Light of *Brightness*
newEntity {
  define_as = 'STAR_BRIGHTNESS',
  name = [[of *Brightness*]],
  suffix = true,
  level = 0,
  rarity = { 1, 40 },
  cost = 5000,
  ego_filter = {
    { tval = 39, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      lite = 6,
      convey_resist_dam = { [DamageType.DARK]=true }
    } },
  },
  obvious_flags = { lite = 6 },
  rating = 9,
}

-- Light of the Shadows
newEntity {
  define_as = 'SHADOWS',
  name = [[of the Shadows]],
  suffix = true,
  level = 0,
  rarity = { 1, 20 },
  cost = 3000,
  ego_filter = {
    { tval = 39, sval={0,99} },
  },
  resolve_data = {
    { 100, { pval_flags = { invisibility=true } } },
    { 70, { convey_resist_dam = { [DamageType.DARK]=true } } },
    { 50, { convey_resist_dam = { [DamageType.LITE]=true } } },
    bonus = { pval=2 },
  },
  rating = 6,
}

-- Light of Infravision
newEntity {
  define_as = 'INFRAVISION_LITE',
  name = [[of Infravision]],
  suffix = true,
  level = 0,
  rarity = { 1, 10 },
  cost = 700,
  ego_filter = {
    { tval = 39, sval={0,99} },
  },
  resolve_data = {
    { 100, { pval_flags = { infravision=true } } },
    bonus = { pval=3 },
  },
  obvious_flags = { pval_flags = { infravision=true } },
  rating = 3,
}

-- Light of the Eternal Eye
newEntity {
  define_as = 'ETERNAL_EYE',
  name = [[of the Eternal Eye]],
  suffix = true,
  level = 0,
  rarity = { 3, 40 },
  cost = 4000,
  ego_filter = {
    { tval = 39, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.BLIND]=true },
      convey_flags = { SEE_INVIS=true }
    } },
  },
  rating = 7,
}

-- Light of the Ethereal Eye
newEntity {
  define_as = 'ETHEREAL_EYE',
  name = [[of the Ethereal Eye]],
  suffix = true,
  level = 0,
  rarity = { 3, 40 },
  cost = 4000,
  ego_filter = {
    { tval = 39, sval={0,99} },
  },
  resolve_data = {
    all = {
      worn_talents = { ActorTalents.T_OBJ_MAGIC_MAP },
    },
  },
  rating = 7,
}

-- Light (except fueled) of Fading
newEntity {
  define_as = 'FADING',
  name = [[of Fading]],
  suffix = true,
  level = 0,
  rarity = { 1, 1 },
  cost = 0,
  ego_filter = {
    { tval = 39, sval={2,99} },
  },
  resolve_data = {
    { 100, { fuel_lite = true, lite_fuel = 0 } },
  },
}

-- Dwarven Hard Armor (except Rusty Chain Mail)
newEntity {
  define_as = 'DWARVEN_ARMOR',
  name = [[Dwarven]],
  prefix = true,
  level = 0,
  rarity = { 2, 20 },
  cost = 5000,
  ego_filter = {
    { tval = 37, sval={2,255} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.FEAR]=true, [DamageType.DARK]=true },
      convey_flags = { FREE_ACT=true, SUST_STR=true, SUST_CON=true },
      stat_flags = { STR=true, CON=true },
      pval_flags = { infravision=true },
      flags = { HIDE_TYPE=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true }
    } },
    bonus = { to_a=15, pval=2 },
  },
  rating = 18,
}

-- Indestructible Amulet/Ring
newEntity {
  define_as = 'INDESTRUCTIBLE',
  name = [[Indestructible]],
  prefix = true,
  level = 0,
  rarity = { 1, 10 },
  cost = 1000,
  ego_filter = {
    { tval = 40 },
    { tval = 45 },
  },
  resolve_data = {
    { 100, { ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true } } },
  },
  obvious_flags = { ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true } },
  rating = 2,
}

-- Cursed Amulet/Ring
newEntity {
  define_as = 'CURSED',
  name = [[Cursed]],
  prefix = true,
  level = 0,
  rarity = { 1, 10 },
  cost = 0,
  ego_filter = {
    { tval = 40 },
    { tval = 45 },
  },
  resolve_data = {
    { 100, { flags = { AUTO_CURSE=true } } },
  },
  obvious_flags = { flags = { AUTO_CURSE=true } },
}

-- Fireproof Staff/Scroll/Spellbook
newEntity {
  define_as = 'FIREPROOF',
  name = [[Fireproof]],
  prefix = true,
  level = 0,
  rarity = { 1, 10 },
  cost = 1000,
  ego_filter = {
    { tval = 70 },
    { tval = 111 },
    { tval = 55 },
  },
  resolve_data = {
    { 100, { ignore_dam = { [DamageType.FIRE]=true } } },
  },
  obvious_flags = { ignore_dam = { [DamageType.FIRE]=true } },
  rating = 1,
}

-- Staff/Wand (except of Nothing) of Plenty
newEntity {
  define_as = 'PLENTY',
  name = [[of Plenty]],
  suffix = true,
  level = 0,
  rarity = { 1, 20 },
  cost = 1000,
  ego_filter = {
    { tval = 55, sval={0,29} },
    { tval = 65, sval={0,29} },
  },
  resolve_data = {
    { 100, {
      resolvers.ego_adjust_field('power', 5),
      resolvers.ego_adjust_field('power', 3)
    } },
    { 50, {
      resolvers.ego_adjust_field('power', 5),
      resolvers.ego_adjust_field('power', 3)
    } },
    { 10, {
      resolvers.ego_adjust_field('power', 5),
      resolvers.ego_adjust_field('power', 3)
    } },
    { 1, {
      resolvers.ego_adjust_field('power', 5),
      resolvers.ego_adjust_field('power', 3)
    } },
    bonus = { pval=3 },
  },
  rating = 1,
}

-- Ammo-based Trap Kit of Extra Might
newEntity {
  define_as = 'EXTRA_MIGHT_TRAP',
  name = [[of Extra Might]],
  suffix = true,
  level = 0,
  rarity = { 1, 10 },
  cost = 1000,
  ego_filter = {
    { tval = 46, sval={1,3} },
  },
  resolve_data = {
    { 100, { pval_flags = { extra_might=true } } },
    bonus = { pval=2, to_d=20, to_h=20 },
  },
  obvious_flags = { pval_flags = { extra_might=true } },
  rating = 5,
}

-- Trap Kit of Extra Shots
newEntity {
  define_as = 'EXTRA_SHOTS_TRAP',
  name = [[of Extra Shots]],
  suffix = true,
  level = 0,
  rarity = { 1, 10 },
  cost = 2000,
  ego_filter = {
    { tval = 46, sval={0,99} },
  },
  resolve_data = {
    { 100, { pval_flags = { MULTI_SHOT=true } } },
    bonus = { pval=3, to_d=20, to_h=20 },
  },
  obvious_flags = { pval_flags = { MULTI_SHOT=true } },
  rating = 10,
}

-- Automatic Trap Kit
newEntity {
  define_as = 'AUTOMATIC',
  name = [[Automatic]],
  prefix = true,
  level = 0,
  rarity = { 1, 10 },
  cost = 3000,
  ego_filter = {
    { tval = 46, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      flags = { AUTOMATIC_5=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.COLD]=true, [DamageType.FIRE]=true }
    } },
    bonus = { to_d=10, to_h=10 },
  },
  obvious_flags = { flags = { AUTOMATIC_5=true } },
  rating = 15,
}

-- Fully Automatic Trap Kit
newEntity {
  define_as = 'FULLY_AUTOMATIC',
  name = [[Fully Automatic]],
  prefix = true,
  level = 0,
  rarity = { 1, 15 },
  cost = 5000,
  ego_filter = {
    { tval = 46, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      flags = { AUTOMATIC_99=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.COLD]=true, [DamageType.FIRE]=true }
    } },
    bonus = { to_d=10, to_h=10 },
  },
  obvious_flags = { flags = { AUTOMATIC_99=true } },
  rating = 15,
}

-- Well-hidden Trap Kit
newEntity {
  define_as = 'WELL_HIDDEN',
  name = [[Well-hidden]],
  prefix = true,
  level = 0,
  rarity = { 1, 8 },
  cost = 1000,
  ego_filter = {
    { tval = 46, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      pval_flags = { CONCEAL=true },
      flags = { HIDE_TYPE=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.COLD]=true, [DamageType.FIRE]=true }
    } },
    bonus = { to_a=5, pval=12, to_d=15, to_h=15 },
  },
  obvious_flags = { pval_flags = { CONCEAL=true } },
  rating = 5,
}

-- Complicated Trap Kit
newEntity {
  define_as = 'COMPLICATED',
  name = [[Complicated]],
  prefix = true,
  level = 0,
  rarity = { 1, 12 },
  cost = 2000,
  ego_filter = {
    { tval = 46, sval={0,99} },
  },
  resolve_data = {
    { 100, { ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.COLD]=true, [DamageType.FIRE]=true } } },
    bonus = { to_a=30, to_d=15, to_h=15 },
  },
  rating = 10,
}

-- Obvious Trap Kit
newEntity {
  define_as = 'OBVIOUS',
  name = [[Obvious]],
  prefix = true,
  level = 0,
  rarity = { 1, 1 },
  cost = 0,
  ego_filter = {
    { tval = 46, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      pval_flags = { CONCEAL=true },
      flags = { CURSED=true, HIDE_TYPE=true }
    } },
    bonus = { to_a=-20, pval=-20, to_d=-20, to_h=-20 },
  },
  obvious_flags = { pval_flags = { CONCEAL=true } },
}

-- Trap Kit for Dragons
newEntity {
  define_as = 'FOR_DRAGONS',
  name = [[for Dragons]],
  suffix = true,
  level = 0,
  rarity = { 3, 10 },
  cost = 500,
  ego_filter = {
    { tval = 46, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      pval_flags = { CONCEAL=true, MULTI_SHOT=true },
      trap_trigger = { DRAGON=true },
      flags = { HIDE_TYPE=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.FIRE]=true }
    } },
    bonus = { to_a=10, pval=4, to_d=20, to_h=20 },
  },
  rating = 5,
}

-- Trap Kit for Demons
newEntity {
  define_as = 'FOR_DEMONS',
  name = [[for Demons]],
  suffix = true,
  level = 0,
  rarity = { 3, 10 },
  cost = 500,
  ego_filter = {
    { tval = 46, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      pval_flags = { CONCEAL=true, MULTI_SHOT=true },
      trap_trigger = { DEMON=true },
      flags = { HIDE_TYPE=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.FIRE]=true }
    } },
    bonus = { to_a=10, pval=4, to_d=20, to_h=20 },
  },
  rating = 5,
}

-- Trap Kit for Animals
newEntity {
  define_as = 'FOR_ANIMALS',
  name = [[for Animals]],
  suffix = true,
  level = 0,
  rarity = { 3, 10 },
  cost = 500,
  ego_filter = {
    { tval = 46, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      pval_flags = { CONCEAL=true, MULTI_SHOT=true },
      trap_trigger = { ANIMAL=true },
      flags = { HIDE_TYPE=true }
    } },
    bonus = { to_a=10, pval=4, to_d=20, to_h=20 },
  },
  rating = 5,
}

-- Trap Kit for Undead
newEntity {
  define_as = 'FOR_UNDEAD',
  name = [[for Undead]],
  suffix = true,
  level = 0,
  rarity = { 3, 10 },
  cost = 500,
  ego_filter = {
    { tval = 46, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      pval_flags = { CONCEAL=true, MULTI_SHOT=true },
      trap_trigger = { UNDEAD=true },
      flags = { HIDE_TYPE=true, KILL_GHOST=true }
    } },
    bonus = { to_a=10, pval=4, to_d=20, to_h=20 },
  },
  rating = 5,
}

-- Trap Kit for Evil
newEntity {
  define_as = 'FOR_EVIL',
  name = [[for Evil]],
  suffix = true,
  level = 0,
  rarity = { 3, 10 },
  cost = 500,
  ego_filter = {
    { tval = 46, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      pval_flags = { CONCEAL=true, MULTI_SHOT=true },
      trap_trigger = { EVIL=true },
      flags = { HIDE_TYPE=true, KILL_GHOST=true }
    } },
    bonus = { to_a=10, pval=4, to_d=20, to_h=20 },
  },
  rating = 5,
}

-- Light (except Wooden Torch) of the Magi
newEntity {
  define_as = 'MAGI_LITE',
  name = [[of the Magi]],
  suffix = true,
  level = 0,
  rarity = { 1, 150 },
  cost = 2000,
  ego_filter = {
    { tval = 39, sval={1,99} },
  },
  resolve_data = {
    { 100, { stat_flags = { INT=true, WIS=true, CHA=true } } },
    { 60, {
      convey_resist_dam = { [DamageType.BLIND]=true },
      pval_flags = { invisibility=true }
    } },
    { 30, { resolvers.ego_high_resist() } },
    { 30, { resolvers.ego_adjust_field('pval', 2) } },
    { 50, { flags = { SPELL_CONTAIN=true, WIELD_CAST=true } } },
    bonus = { pval=3 },
    all = {
      worn_talents = { ActorTalents.T_OBJ_MAGIC_MAP },
    },
  },
}

-- Soft/Hard Armor of Vulnerability
newEntity {
  define_as = 'VULNERABILITY_ARMOR',
  name = [[of Vulnerability]],
  suffix = true,
  level = 0,
  rarity = { 2, 20 },
  cost = 0,
  ego_filter = {
    { tval = 36, sval={0,99} },
    { tval = 37, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      convey_flags = { AGGRAVATE=true },
      flags = { CURSED=true }
    } },
    bonus = { to_a=-50 },
  },
}

-- Shield/Demonshield of Vulnerability
newEntity {
  define_as = 'VULNERABILITY_SHIELD',
  name = [[of Vulnerability]],
  suffix = true,
  level = 0,
  rarity = { 2, 22 },
  cost = 0,
  ego_filter = {
    { tval = 115, sval=56 },
    { tval = 34, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      convey_flags = { AGGRAVATE=true },
      flags = { CURSED=true }
    } },
    bonus = { to_a=-50 },
  },
}

-- Shield/Demonshield of Preservation
newEntity {
  define_as = 'PRESERVATION',
  name = [[of Preservation]],
  suffix = true,
  level = 40,
  rarity = { 2, 44 },
  cost = 20000,
  ego_filter = {
    { tval = 115, sval=56 },
    { tval = 34, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.DISENCHANT]=true },
      convey_flags = { SUST_STR=true, SUST_CON=true, SUST_DEX=true, HOLD_LIFE=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
      resolvers.ego_high_resist()
    } },
    { 33, { resolvers.ego_low_resist() } },
    { 33, { resolvers.ego_low_resist() } },
    bonus = { to_a=20, to_d=-10, to_h=-10 },
  },
  rating = 25,
}

-- Cap/Helm/Crown of Serenity
newEntity {
  define_as = 'SERENITY',
  name = [[of Serenity]],
  suffix = true,
  level = 35,
  rarity = { 1, 15 },
  cost = 4000,
  ego_filter = {
    { tval = 32, sval={0,6} },
    { tval = 33, sval={0,99} },
  },
  resolve_data = {
    { 100, { convey_resist_dam = { [DamageType.SOUND]=true, [DamageType.CONFUSION]=true, [DamageType.FEAR]=true } } },
  },
  rating = 20,
}

-- Crown of Night and Day
newEntity {
  define_as = 'NIGHT_AND_DAY',
  name = [[of Night and Day]],
  suffix = true,
  level = 35,
  rarity = { 1, 15 },
  cost = 4000,
  ego_filter = {
    { tval = 33, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      lite = 1,
      convey_resist_dam = { [DamageType.LITE]=true, [DamageType.DARK]=true, [DamageType.BLIND]=true },
      convey_flags = { SEE_INVIS=true },
      ignore_dam = { [DamageType.ACID]=true }
    } },
  },
  rating = 18,
}

-- Cloak (except Mimicry Cloak) of the Magi
newEntity {
  define_as = 'MAGI_CLOAK',
  name = [[of the Magi]],
  suffix = true,
  level = 30,
  rarity = { 1, 18 },
  cost = 2000,
  ego_filter = {
    { tval = 35, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      convey_flags = { SUST_INT=true, FREE_ACT=true },
      stat_flags = { INT=true },
      pval_flags = { speed=true, skill_stealth=true },
      flags = { HIDE_TYPE=true },
      ignore_dam = { [DamageType.ACID]=true }
    } },
    { 30, { flags = { SPELL_CONTAIN=true, WIELD_CAST=true } } },
    bonus = { to_a=5, pval=3, to_d=-5, to_h=-5 },
  },
  rating = 15,
}

-- Cloak (except Mimicry Cloak) of Invisibility
newEntity {
  define_as = 'INVISIBILITY',
  name = [[of Invisibility]],
  suffix = true,
  level = 40,
  rarity = { 1, 18 },
  cost = 3000,
  ego_filter = {
    { tval = 35, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      pval_flags = { skill_stealth=true, invisibility=true },
      flags = { HIDE_TYPE=true }
    } },
    bonus = { to_a=10, pval=5 },
  },
  obvious_flags = { pval_flags = { invisibility=true } },
  rating = 20,
}

-- Cloak (except Mimicry Cloak) of the Bat
newEntity {
  define_as = 'BAT',
  name = [[of the Bat]],
  suffix = true,
  level = 50,
  rarity = { 1, 35 },
  cost = 3000,
  ego_filter = {
    { tval = 35, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.DARK]=true },
      convey_flags = { FLY=true, SEE_INVIS=true },
      pval_flags = { speed=true, infravision=true, skill_stealth=true },
      flags = { HIDE_TYPE=true }
    } },
    bonus = { to_a=10, pval=3, to_d=-10, to_h=-10 },
  },
  rating = 15,
}

-- Gloves of Thievery
newEntity {
  define_as = 'THIEVERY',
  name = [[of Thievery]],
  suffix = true,
  level = 40,
  rarity = { 1, 15 },
  cost = 5000,
  ego_filter = {
    { tval = 31, sval=1 },
  },
  resolve_data = {
    { 100, {
      convey_flags = { FEATHER=true, FREE_ACT=true },
      stat_flags = { DEX=true },
      pval_flags = { skill_searching=true },
      flags = { SHOW_MODS=true, HIDE_TYPE=true },
      ignore_dam = { [DamageType.ACID]=true }
    } },
    { 10, { pval_flags = { speed=true } } },
    bonus = { pval=5, to_d=3, to_h=8 },
  },
  rating = 22,
}

-- Gauntlets/Cesti of Combat
newEntity {
  define_as = 'COMBAT',
  name = [[of Combat]],
  suffix = true,
  level = 50,
  rarity = { 1, 15 },
  cost = 7000,
  ego_filter = {
    { tval = 31, sval={2,99} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.FEAR]=true },
      convey_flags = { AGGRAVATE=true },
      stat_flags = { STR=true, CON=true },
      cum_flags = { drain_hp=true },
      flags = { SHOW_MODS=true, HIDE_TYPE=true },
      ignore_dam = { [DamageType.ACID]=true }
    } },
    { 25, { pval_flags = { extra_blows=true } } },
    bonus = { to_a=-20, pval=2, to_d=8, to_h=6 },
  },
  rating = 22,
}

-- Footwear of Stability
newEntity {
  define_as = 'STABILITY',
  name = [[of Stability]],
  suffix = true,
  level = 0,
  rarity = { 3, 27 },
  cost = 5000,
  ego_filter = {
    { tval = 30, sval={0,99} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.NEXUS]=true },
      convey_flags = { FEATHER=true }
    } },
  },
  rating = 20,
}

-- Leather Boots of Elvenkind
newEntity {
  define_as = 'ELVENKIND',
  name = [[of Elvenkind]],
  suffix = true,
  level = 60,
  rarity = { 1, 36 },
  cost = 200000,
  ego_filter = {
    { tval = 30, sval={2,3} },
  },
  resolve_data = {
    { 100, {
      convey_flags = { FEATHER=true },
      pval_flags = { skill_stealth=true, speed=true },
      flags = { HIDE_TYPE=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.FIRE]=true },
      resolvers.ego_abil_flag()
    } },
    bonus = { pval=5 },
  },
  rating = 30,
}

-- Weapon (some) of Fury
newEntity {
  define_as = 'FURY',
  name = [[of Fury]],
  suffix = true,
  level = 40,
  rarity = { 1, 66 },
  cost = 20000,
  ego_filter = {
    { tval = 21, sval={12,99} },
    { tval = 22, sval={10,99} },
    { tval = 23, sval={16,99} },
    { tval = 24, sval={8,99} },
  },
  resolve_data = {
    { 100, {
      convey_resist_dam = { [DamageType.FEAR]=true },
      convey_flags = { AGGRAVATE=true },
      stat_flags = { STR=true },
      pval_flags = { extra_blows=true },
      cum_flags = { drain_mana=true },
      flags = { HIDE_TYPE=true },
      ignore_dam = { [DamageType.ACID]=true, [DamageType.FIRE]=true }
    } },
    bonus = { to_a=-20, pval=2, to_d=10, to_h=10 },
  },
  rating = 30,
}

-- Magical Digger
newEntity {
  define_as = 'MAGICAL',
  name = [[Magical]],
  prefix = true,
  level = 0,
  rarity = { 1, 10 },
  cost = 500,
  ego_filter = {
    { tval = 20 },
  },
  resolve_data = {
    all = {
      worn_talents = { ActorTalents.T_OBJ_STONE_TO_MUD },
    },
  },
  rating = 4,
}

-- Rod of Simplicity
newEntity {
  define_as = 'SIMPLICITY',
  name = [[of Simplicity]],
  suffix = true,
  level = 3,
  rarity = { 2, 8 },
  cost = 1000,
  ego_filter = {
    { tval = 67 },
  },
  resolve_data = {
    { 100, { flags = { EASY_USE=true } } },
  },
  obvious_flags = { flags = { EASY_USE=true } },
  rating = 8,
}

-- Light (except Wooden Torch) of Warmth
newEntity {
  define_as = 'WARMTH',
  name = [[of Warmth]],
  suffix = true,
  level = 0,
  rarity = { 1, 10 },
  cost = 500,
  ego_filter = {
    { tval = 39, sval={1,99} },
  },
  resolve_data = {
    { 100, { convey_resist_dam = { [DamageType.COLD]=true } } },
  },
}

-- Helm/Dragon Helm of Water Breathing
newEntity {
  define_as = 'WATER_BREATHING',
  name = [[of Water Breathing]],
  suffix = true,
  level = 15,
  rarity = { 1, 25 },
  cost = 1000,
  ego_filter = {
    { tval = 32, sval={5,10} },
  },
  resolve_data = {
    { 100, {
      convey_flags = { WATER_BREATH=true },
      ignore_dam = { [DamageType.ACID]=true }
    } },
    bonus = { pval=2 },
  },
  obvious_flags = { convey_flags = { WATER_BREATH=true } },
  rating = 13,
}

-- Weapon/Demonblade of Life
newEntity {
  define_as = 'LIFE',
  name = [[of Life]],
  suffix = true,
  level = 0,
  rarity = { 1, 50 },
  cost = 30000,
  ego_filter = {
    { tval = 21 },
    { tval = 22 },
    { tval = 23 },
    { tval = 24 },
    { tval = 115, sval=55 },
    forbid = { flags = { MUST2H=true } },
  },
  resolve_data = {
    { 100, {
      convey_flags = { HOLD_LIFE=true },
      pval_flags = { hp_mult=true }
    } },
    bonus = { pval=1, to_d=5, to_h=5 },
  },
  obvious_flags = { pval_flags = { hp_mult=true } },
  rating = 20,
}

-- Cloak of Air
newEntity {
  define_as = 'AIR',
  name = [[of Air]],
  suffix = true,
  level = 30,
  rarity = { 1, 35 },
  cost = 1500,
  ego_filter = {
    { tval = 35 },
  },
  resolve_data = {
    { 100, { convey_flags = { MAGIC_BREATH=true } } },
  },
  rating = 10,
}

-- Polished Dragon Scale Mail
newEntity {
  define_as = 'POLISHED',
  name = [[Polished]],
  prefix = true,
  level = 40,
  rarity = { 25, 100 },
  cost = 25000,
  ego_filter = {
    { tval = 38 },
  },
  resolve_data = {
    { 100, { convey_flags = { REFLECT=true } } },
  },
  rating = 5,
}

-- Heavy Crossbow of Siegecraft
newEntity {
  define_as = 'SIEGECRAFT',
  name = [[of Siegecraft]],
  suffix = true,
  level = 60,
  rarity = { 5, 30 },
  cost = 30000,
  ego_filter = {
    { tval = 19, sval=24 },
  },
  resolve_data = {
    { 120, {
      convey_flags = { REFLECT=true, IMMOVABLE=true },
      pval_flags = { extra_might=true },
      cum_flags = { extra_shots=true }
    } },
    bonus = { to_a=20, pval=2, to_d=15, to_h=10 },
  },
  rating = 30,
}



-- Seen flags:
--   ABILITY
--   ACTIVATE
--   AGGRAVATE
--   AUTOMATIC_5
--   AUTOMATIC_99
--   AUTO_CURSE
--   BLACK_BREATH
--   BLESSED
--   BLOWS
--   BRAND_ACID
--   BRAND_COLD
--   BRAND_ELEC
--   BRAND_FIRE
--   BRAND_POIS
--   CAPACITY
--   CHAOTIC
--   CHARGING
--   CHEAPNESS
--   CHR
--   CON
--   CONCEAL
--   CURSED
--   DAM_DIE
--   DEX
--   DRAIN_EXP
--   DRAIN_HP
--   DRAIN_MANA
--   EASY_USE
--   ESP_ALL
--   ESP_ANIMAL
--   ESP_DEMON
--   ESP_DRAGON
--   ESP_EVIL
--   ESP_GIANT
--   ESP_GOOD
--   ESP_ORC
--   ESP_TROLL
--   ESP_UNDEAD
--   FAST_CAST
--   FEATHER
--   FLY
--   FREE_ACT
--   FUEL_LITE
--   HEAVY_CURSE
--   HIDE_TYPE
--   HOLD_LIFE
--   IGNORE_ACID
--   IGNORE_COLD
--   IGNORE_ELEC
--   IGNORE_FIRE
--   IMMOVABLE
--   IMPACT
--   INFRA
--   INT
--   INVIS
--   KILL_DEMON
--   KILL_DRAGON
--   KILL_GHOST
--   KILL_UNDEAD
--   LIFE
--   LIMIT_BLOWS
--   LITE1
--   LITE2
--   LITE3
--   LUCK
--   MAGIC_BREATH
--   MANA
--   MULTI_SHOT
--   MUST2H
--   NEVER_BLOW
--   OLD_RESIST
--   ONLY_ANIMAL
--   ONLY_DEMON
--   ONLY_DRAGON
--   ONLY_EVIL
--   ONLY_UNDEAD
--   PVAL_M1
--   PVAL_M2
--   PVAL_M3
--   PVAL_M5
--   REFLECT
--   REGEN
--   RES_ACID
--   RES_BLIND
--   RES_CHAOS
--   RES_COLD
--   RES_CONF
--   RES_DARK
--   RES_DISEN
--   RES_ELEC
--   RES_FEAR
--   RES_FIRE
--   RES_LITE
--   RES_MORGUL
--   RES_NETHER
--   RES_NEXUS
--   RES_POIS
--   RES_SHARDS
--   RES_SOUND
--   R_ANY
--   R_ELEM
--   R_HIGH
--   R_IMMUNITY
--   R_LOW
--   R_P_ABILITY
--   R_STAT
--   SEARCH
--   SEE_INVIS
--   SHOW_MODS
--   SH_ELEC
--   SH_FIRE
--   SLAY_ANIMAL
--   SLAY_DEMON
--   SLAY_DRAGON
--   SLAY_EVIL
--   SLAY_GIANT
--   SLAY_ORC
--   SLAY_TROLL
--   SLAY_UNDEAD
--   SLAY_WEAP
--   SLOW_DIGEST
--   SPEED
--   SPELL
--   SPELL_CONTAIN
--   STEALTH
--   STR
--   SUSTAIN
--   SUST_CHR
--   SUST_CON
--   SUST_DEX
--   SUST_INT
--   SUST_STR
--   SUST_WIS
--   TELEPORT
--   TUNNEL
--   VAMPIRIC
--   VORPAL
--   WATER_BREATH
--   WIELD_CAST
--   WIS
--   WOUNDING
--   XTRA_MIGHT
--   XTRA_SHOTS

-- Seen powers:
--   blink
--   illuminate
--   magic map
--   remove fear
--   stone to mud

-- Seen 'HARDCORE' fields:
--   BA_ACID_H
--   BA_COLD_3
--   BA_ELEC_3
--   BA_FIRE_H
--   JUMP
--   NOLDOR
--   SPECTRAL
--   SPIN
--   TELEPORT
