-- $Id: potions.lua 3333 2018-04-20 00:32:38Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2018 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_obj' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Object entities generated from T2's k_info.txt

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_SLIME_MOLD_JUICE',
  name = 'POT_SLIME_MOLD_JUICE',
  display_name = 'Slime Mold Juice',
  desc = [[A strange sort of yellowish-green slime, too viscous to even slosh in the bottle. And as I know you, you're going to slurp it down.]],
  sval = 2,
  image = 'object/pot_placeholder.png',
  level = 0,
  cost = 2,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=0, rarity=1 } },
  pval = 400,
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'drink the potion',
    use = function(self, who) return obj_util.simple_drink(who) end,
  },
  shatter_dam = { angry=true },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_APPLE_JUICE',
  name = 'POT_APPLE_JUICE',
  display_name = 'Apple Juice',
  desc = 'A healthy fruit beverage.',
  sval = 1,
  image = 'object/pot_placeholder.png',
  level = 0,
  cost = 1,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=0, rarity=1 } },
  pval = 250,
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'drink the potion',
    use = function(self, who) return obj_util.simple_drink(who) end,
  },
  shatter_dam = { angry=true },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_WATER',
  name = 'POT_WATER',
  display_name = 'Water',
  desc = 'A small bottle filled with pure water.',
  sval = 0,
  image = 'object/pot_placeholder.png',
  level = 0,
  cost = 1,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=0, rarity=1 } },
  pval = 200,
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'drink the potion',
    use = function(self, who) return obj_util.simple_drink(who) end,
  },
  shatter_dam = { angry=true },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_STRENGTH',
  name = 'POT_STRENGTH',
  display_name = 'Strength',
  desc = 'This beneficial potion will magically improve your physical strength.',
  sval = 48,
  image = 'object/pot_placeholder.png',
  level = 20,
  cost = 8000,
  combat = { 1, 1 },
  allocation = {
    { level=20, rarity=6 },
    { level=25, rarity=3 },
    { level=30, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore and increase your STR',
    use = function(self, who) return obj_util.raise_stat_and_learn(who, 'STR') end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_WEAKNESS',
  name = 'POT_WEAKNESS',
  display_name = 'Weakness',
  desc = 'This nasty potion will sap your strength, making you weaker.',
  sval = 16,
  image = 'object/pot_placeholder.png',
  level = 3,
  cost = 0,
  combat = { 3, 12 },
  flags = { FOUNTAIN=true },
  allocation = { { level=3, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'damage your STR',
    use = function(self, who) return obj_util.reduce_stat_and_learn(who, 'STR') end,
  },
  shatter_dam = { angry=true },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_RESTORE_STRENGTH',
  name = 'POT_RESTORE_STRENGTH',
  display_name = 'Restore Strength',
  desc = 'This magical potion will bring back your physical power to its full extent, should it be drained.',
  sval = 42,
  image = 'object/pot_placeholder.png',
  level = 25,
  cost = 300,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=25, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore any damage to your STR',
    use = function(self, who)
      return { used=true, destroy=true, id=who:restoreStat('STR') }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_INTELLIGENCE',
  name = 'POT_INTELLIGENCE',
  display_name = 'Intelligence',
  desc = 'This nice potion will magically enhance your wit, permanently improving your intellect.',
  sval = 49,
  image = 'object/pot_placeholder.png',
  level = 20,
  cost = 8000,
  combat = { 1, 1 },
  allocation = {
    { level=20, rarity=6 },
    { level=25, rarity=3 },
    { level=30, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'resotre and increase your INT',
    use = function(self, who) return obj_util.raise_stat_and_learn(who, 'INT') end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_STUPIDITY',
  name = 'POT_STUPIDITY',
  display_name = 'Stupidity',
  desc = 'This accursed potion will cloud your intellect, making you stupid.',
  sval = 17,
  image = 'object/pot_placeholder.png',
  level = 20,
  cost = 0,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=20, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'damage your INT',
    use = function(self, who) return obj_util.reduce_stat_and_learn(who, 'INT') end,
  },
  shatter_dam = { angry=true },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_RESTORE_INTELLIGENCE',
  name = 'POT_RESTORE_INTELLIGENCE',
  display_name = 'Restore Intelligence',
  desc = 'This beneficial potion will magically heal your brain, restoring drained intelligence.',
  sval = 43,
  image = 'object/pot_placeholder.png',
  level = 25,
  cost = 300,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=25, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore any damage to your INT',
    use = function(self, who)
      return { used=true, destroy=true, id=who:restoreStat('INT') }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_WISDOM',
  name = 'POT_WISDOM',
  display_name = 'Wisdom',
  desc = 'This potion grants great insight, making you wiser.',
  sval = 50,
  image = 'object/pot_placeholder.png',
  level = 20,
  cost = 8000,
  combat = { 1, 1 },
  allocation = {
    { level=20, rarity=6 },
    { level=25, rarity=3 },
    { level=30, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore and increase your WIS',
    use = function(self, who) return obj_util.raise_stat_and_learn(who, 'WIS') end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_NAIVETY',
  name = 'POT_NAIVETY',
  display_name = 'Naivety',
  desc = 'This potion casts a shadow on your knowledge, making you foolish.',
  sval = 18,
  image = 'object/pot_placeholder.png',
  level = 20,
  cost = 0,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=20, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'damage your WIS',
    use = function(self, who) return obj_util.reduce_stat_and_learn(who, 'WIS') end,
  },
  shatter_dam = { angry=true },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_RESTORE_WISDOM',
  name = 'POT_RESTORE_WISDOM',
  display_name = 'Restore Wisdom',
  desc = 'This potion benefits the naive, bringing back their wisdom to what it once was.',
  sval = 44,
  image = 'object/pot_placeholder.png',
  level = 25,
  cost = 300,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=25, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore any damage to your WIS',
    use = function(self, who)
      return { used=true, destroy=true, id=who:restoreStat('WIS') }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_CHARISMA',
  name = 'POT_CHARISMA',
  display_name = 'Charisma',
  desc = 'This potion infuses you with beauty and charm.',
  sval = 53,
  image = 'object/pot_placeholder.png',
  level = 20,
  cost = 1000,
  combat = { 1, 1 },
  allocation = {
    { level=20, rarity=1 },
    { level=25, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore and increase your CHA',
    use = function(self, who) return obj_util.raise_stat_and_learn(who, 'CHA') end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_UGLINESS',
  name = 'POT_UGLINESS',
  display_name = 'Ugliness',
  desc = 'This wicked potion slightly twists your features, making you appear less fair.',
  sval = 21,
  image = 'object/pot_placeholder.png',
  level = 20,
  cost = 0,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=20, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'damage your CHA',
    use = function(self, who) return obj_util.reduce_stat_and_learn(who, 'CHA') end,
  },
  shatter_dam = { angry=true },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_RESTORE_CHARISMA',
  name = 'POT_RESTORE_CHARISMA',
  display_name = 'Restore Charisma',
  desc = 'This useful potion restores drained charm.',
  sval = 47,
  image = 'object/pot_placeholder.png',
  level = 20,
  cost = 300,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=20, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore any damage to your CHA',
    use = function(self, who)
      return { used=true, destroy=true, id=who:restoreStat('CHA') }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_CURING',
  name = 'POT_CURING',
  display_name = 'Curing',
  desc = 'This blessed potion helps to recover from a wide variety of ailments.',
  sval = 61,
  image = 'object/pot_placeholder.png',
  level = 18,
  cost = 250,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = {
    { level=18, rarity=1 },
    { level=40, rarity=1 },
  },
  pval = 100,
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'heal 50hp and cure blindness, poison, confusion, stun, cuts, hallucination and sanity',
    use = function(self, who)
      local l1 = obj_util.heal_and_learn(who, 50, self)
      local l2 = obj_util.remove_effects_and_learn(who, who.EFF_BLIND,
							who.EFF_POISON,
							who.EFF_CONFUSED,
							who.EFF_STUN,
							who.EFF_CUT,
							who.EFF_HALLUCINATION)
      local l3 = who:healSanity(50, self)
      return { used=true, destroy=true, id=(l1 or l2) }
    end,
  },
  shatter_dam = { dt=DamageType.OLD_HEAL, dice={6,3}, r=2, ident=true },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_INVULNERABILITY',
  name = 'POT_INVULNERABILITY',
  display_name = 'Invulnerability',
  desc = [[This immensely powerful potion makes your physique almost indestructible for a very short time. Very rarely, an attempt to hurt you will still succeed, so don't be too confident.]],
  sval = 62,
  image = 'object/pot_placeholder.png',
  level = 90,
  cost = 100000,
  combat = { 1, 1 },
  allocation = { { level=90, rarity=9 } },
  pval = -2500,
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'render yourself nearly invulnerable for 7+1d7 turns',
    use = function(self, who)
      local learn = who:setEffect(who.EFF_INVULNERABILITY, 7 + rng.range(1, 7), { merge='combine' })
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_NEW_LIFE',
  name = 'POT_NEW_LIFE',
  display_name = 'New Life',
  desc = [[This potion fundamentally twists your physical features, as if you were another mother's child. Your physique will be shaped anew.]],
  sval = 63,
  image = 'object/pot_placeholder.png',
  level = 50,
  cost = 750000,
  combat = { 1, 1 },
  allocation = {
    { level=50, rarity=20 },
    { level=100, rarity=10 },
    { level=120, rarity=5 },
  },
  pval = 100,
  -- BEGIN VERBATIM
  use_simple = {
    use = function(self, who)
    -- TODO Recalc hit points
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_CURE_SERIOUS_WOUNDS',
  name = 'POT_CURE_SERIOUS_WOUNDS',
  display_name = 'Cure Serious Wounds',
  desc = 'This beneficial potion will cure some wounds and other inhibiting ailments.',
  sval = 35,
  image = 'object/pot_placeholder.png',
  level = 3,
  cost = 40,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=3, rarity=1 } },
  pval = 100,
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'heal 4d8hp, cure blindness and confusion, and reduce cuts',
    use = function(self, who)
      local l1 = obj_util.heal_and_learn(who, rng.dice(4, 8), self)
      local l2 = obj_util.remove_effects_and_learn(who, who.EFF_BLIND, who.EFF_CONFUSED)
      local l3 = obj_util.reduce_effect_and_learn(who, who.EFF_CUT, 1, { merge=function(c,n) return math.floor(c/2) - 50 end })
      return { used=true, destroy=true, id=(l1 or l2 or l3) }
    end,
  },
  shatter_dam = { dt=DamageType.OLD_HEAL, dice={4,3}, r=2, ident=true },
  in_trap = { damtype=DamageType.OLD_HEAL, dam={4,6}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_CURE_CRITICAL_WOUNDS',
  name = 'POT_CURE_CRITICAL_WOUNDS',
  display_name = 'Cure Critical Wounds',
  desc = 'This nice potion will cure a good bit of hurt you have suffered and also allows you to recover from unhealthy conditions like blood poisoning, confusion or blindness.',
  sval = 36,
  image = 'object/pot_placeholder.png',
  level = 5,
  cost = 100,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=5, rarity=1 } },
  pval = 100,
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'heal 6d8hp and cure blindness, confusion, poison, stun and cuts',
    use = function(self, who)
      local l1 = obj_util.heal_and_learn(who, rng.dice(6, 8), self)
      local l2 = obj_util.remove_effects_and_learn(who, who.EFF_BLIND,
							who.EFF_CONFUSED,
							who.EFF_POISON,
							who.EFF_STUN,
							who.EFF_CUT)
      return { used=true, destroy=true, id=(l1 or l2) }
    end,
  },
  shatter_dam = { dt=DamageType.OLD_HEAL, dice={6,3}, r=2, ident=true },
  in_trap = { damtype=DamageType.OLD_HEAL, dam={6,8}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_HEALING',
  name = 'POT_HEALING',
  display_name = 'Healing',
  desc = 'This blessed potion greatly heals you and also cures many other ailments from which you might suffer.',
  sval = 37,
  image = 'object/pot_placeholder.png',
  level = 15,
  cost = 300,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = {
    { level=15, rarity=1 },
    { level=30, rarity=1 },
    { level=60, rarity=1 },
  },
  pval = 200,
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'heal 300hp and cure blindness, confusion, poison, stun and cuts',
    use = function(self, who)
      local l1 = obj_util.heal_and_learn(who, 300, self)
      local l2 = obj_util.remove_effects_and_learn(who, who.EFF_BLIND,
							who.EFF_CONFUSED,
							who.EFF_POISON,
							who.EFF_STUN,
							who.EFF_CUT)
      return { used=true, destroy=true, id=(l1 or l2) }
    end,
  },
  shatter_dam = { dt=DamageType.OLD_HEAL, dice={10,10}, r=2, ident=true },
  in_trap = { damtype=DamageType.OLD_HEAL, dam=300, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_CONSTITUTION',
  name = 'POT_CONSTITUTION',
  display_name = 'Constitution',
  desc = 'This magical concoction greatly improves your health, making you permanently tougher.',
  sval = 52,
  image = 'object/pot_placeholder.png',
  level = 20,
  cost = 8000,
  combat = { 1, 1 },
  allocation = {
    { level=20, rarity=6 },
    { level=25, rarity=3 },
    { level=30, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore and increase your CON',
    use = function(self, who) return obj_util.raise_stat_and_learn(who, 'CON') end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_EXPERIENCE',
  name = 'POT_EXPERIENCE',
  display_name = 'Experience',
  desc = 'This exceptional drink instills into you knowledge, allowing you to advance further in your trade.',
  sval = 59,
  image = 'object/pot_placeholder.png',
  level = 65,
  cost = 25000,
  combat = { 1, 1 },
  allocation = { { level=65, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'increase your EXP',
    use = function(self, who)
      local add = math.min(math.floor(who.exp/2) + 10, 100000)
      game.logPlayer(who, 'You feel more experienced.')
      who:gainExp(add)
      return { used=true, destroy=true, id=true }
    end,
  },
  in_trap = {
    side_effect = function(self, _, x, y, who)
      if who.level < who.max_level then
	who:gainExp(who:getExpChart(who.level+1) - who.exp + 1)
      end
    end,
    side_effect_desc = 'levels up target monster',
  }
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_SLEEP',
  name = 'POT_SLEEP',
  display_name = 'Sleep',
  desc = [[This potion was made to help people with bad sleeping disorders to find rest. Surely you don't want to take a nap while nasty goblins are searching for you?]],
  sval = 11,
  image = 'object/pot_placeholder.png',
  level = 0,
  cost = 0,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=0, rarity=1 } },
  pval = 100,
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'fall asleep for 4+1d4 turns',
    use = function(self, who)
      local learn = false
      if not who:has('FREE_ACT') then
	learn = obj_util.set_effect_and_learn(who, who.EFF_PARALYZED, 4 + rng.range(1,4), { merge='combine' })
      end
      return { used=true, destroy=true, id=learn }
    end,
  },
  shatter_dam = { dt=DamageType.OLD_SLEEP, r=2, ident=true, angry=true },
  in_trap = { damtype=DamageType.OLD_SLEEP, dam={4,6}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_BLINDNESS',
  name = 'POT_BLINDNESS',
  display_name = 'Blindness',
  desc = 'This slightly poisonous potion temporarily impedes your eyesight, making you unable to see a thing.',
  sval = 7,
  image = 'object/pot_placeholder.png',
  level = 0,
  cost = 0,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=0, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'render yourself blind for 100+1d100 turns',
    use = function(self, who)
      local learn = false
      if not who:resistDam(DamageType.BLIND) then
	learn = obj_util.set_effect_and_learn(who, who.EFF_BLIND, 100 + rng.range(1,100), { merge='combine' })
      end
      return { used=true, destroy=true, id=learn }
    end,
  },
  shatter_dam = { dt=DamageType.DARK, r=2, ident=true, angry=true },
  in_trap = { damtype=DamageType.DARK, dam=10, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_BOOZE',
  name = 'POT_BOOZE',
  display_name = 'Booze',
  desc = 'A small bottle of a dark brown distilled beverage. By its look and smell, it contains a fair amount of still muck and wood alcohol.',
  sval = 9,
  image = 'object/pot_placeholder.png',
  level = 0,
  cost = 0,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=0, rarity=1 } },
  pval = 50,
  -- BEGIN VERBATIM
  -- TODO This can teleport us; figure out implementation later.
  shatter_dam = { dt=DamageType.OLD_CONF, r=2, ident=true, angry=true },
  in_trap = { damtype=DamageType.CONFUSION, dam={4,6}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_POISON',
  name = 'POT_POISON',
  display_name = 'Poison',
  desc = 'This bottle is filled with a mild but still dangerous liquid poison. Drinking it would be highly unwise.',
  sval = 6,
  image = 'object/pot_placeholder.png',
  level = 3,
  cost = 0,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=3, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'poison yourself, doing 1 poison damage per turn for 10+1d15 turns',
    use = function(self, who)
      local learn = false
      if not who:resistDam(DamageType.POISON) then
	learn = obj_util.set_effect_and_learn(who, who.EFF_POISON, 10 + rng.range(1,15), { merge='combine', src=self })
      end
      return { used=true, destroy=true, id=learn }
    end,
  },
  shatter_dam = { dt=DamageType.POISON, dice={3,1}, r=2, ident=true, angry=true },
  in_trap = { damtype=DamageType.POISON, dam={8,6}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_SPEED',
  name = 'POT_SPEED',
  display_name = 'Speed',
  desc = 'A magical drink which temporarily allows you to act much faster when imbibed.',
  sval = 29,
  image = 'object/pot_placeholder.png',
  level = 1,
  cost = 75,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = {
    { level=1, rarity=1 },
    { level=40, rarity=1 },
    { level=60, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'increase your speed by 10 for 15+1d25 turns',
    use = function(self, who)
      learn = obj_util.set_effect_and_learn(who, who.EFF_SPEED, 15 + rng.range(1, 25), {
	speed = 10,
	merge = function(c,n) return c+5 end,
      })
      return { used=true, destroy=true, id=learn }
    end,
  },
  shatter_dam = { dt=DamageType.OLD_SPEED, r=2, ident=true },
  in_trap = { damtype=DamageType.OLD_SPEED, dam={5,10}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_SLOWNESS',
  name = 'POT_SLOWNESS',
  display_name = 'Slowness',
  desc = 'A magical concoction which drains force from you, forcing you to move and act a lot slower, until it wears off.',
  sval = 4,
  image = 'object/pot_placeholder.png',
  level = 1,
  cost = 0,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=1, rarity=1 } },
  pval = 50,
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'decrease your speed by 10 for 15+1d25 turns',
    use = function(self, who)
      local learn = obj_util.set_effect_and_learn(who, who.EFF_SLOW, 15 + rng.range(1, 25), { merge='combine' })
      return { used=true, destroy=true, id=learn }
    end,
  },
  shatter_dam = { dt=DamageType.OLD_SLOW, dice={5,1}, r=2, ident=true, angry=true },
  in_trap = { damtype=DamageType.OLD_SLOW, dam={4,6}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_DEXTERITY',
  name = 'POT_DEXTERITY',
  display_name = 'Dexterity',
  desc = 'A strange magical drink which greatly improves your agility and nimbleness.',
  sval = 51,
  image = 'object/pot_placeholder.png',
  level = 20,
  cost = 8000,
  combat = { 1, 1 },
  allocation = {
    { level=20, rarity=6 },
    { level=25, rarity=3 },
    { level=30, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore and increase your DEX',
    use = function(self, who) return obj_util.raise_stat_and_learn(who, 'DEX') end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_RESTORE_DEXTERITY',
  name = 'POT_RESTORE_DEXTERITY',
  display_name = 'Restore Dexterity',
  desc = 'This magical brew brings your agility back to its former glory should it have been reduced.',
  sval = 45,
  image = 'object/pot_placeholder.png',
  level = 25,
  cost = 300,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=25, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore any damage to your DEX',
    use = function(self, who)
      return { used=true, destroy=true, id=who:restoreStat('DEX') }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_RESTORE_CONSTITUTION',
  name = 'POT_RESTORE_CONSTITUTION',
  display_name = 'Restore Constitution',
  desc = 'A beneficial magical concoction, restoring your damaged health.',
  sval = 46,
  image = 'object/pot_placeholder.png',
  level = 25,
  cost = 300,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=25, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore any damage to your CON',
    use = function(self, who)
      return { used=true, destroy=true, id=who:restoreStat('CON') }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_LOSE_MEMORIES',
  name = 'POT_LOSE_MEMORIES',
  display_name = 'Lose Memories',
  desc = 'A wicked potion, making you less of an adventurer than by right you should be.',
  sval = 13,
  image = 'object/pot_placeholder.png',
  level = 10,
  cost = 0,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'reduce your experience',
    use = function(self, who)
      local learn = not who:has('HOLD_LIFE') and who.exp > 0
      if learn then
	game.logPlayer(who, 'You feel your memories fade.')
	who:gainExp(-math.floor(who.exp/4))
      end
      return { used=true, destroy=true, id=learn }
    end,
  },
  shatter_dam = { angry=true },
  in_trap = { damtype=DamageType.OLD_CONF, dam={10,10}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_SALT_WATER',
  name = 'POT_SALT_WATER',
  display_name = 'Salt Water',
  desc = 'A solution of salt in water, made for curing meat. Drinking it would cause violent nausea.',
  sval = 5,
  image = 'object/pot_placeholder.png',
  level = 0,
  cost = 0,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=0, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'vomit, purging poisons in your body but making you very hungry',
    use = function(self, who)
      game.logSeen(who, 'The potion makes you vomit!')
      who:setFood(util.FOOD.starve - 1)
      who:removeEffect(who.EFF_POISON)
      who:setEffect(who.EFF_PARALYZED, 4, { merge='combine' })
      return { used=true, destroy=true, id=true }
    end,
  },
  shatter_dam = { angry=true },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_ENLIGHTENMENT',
  name = 'POT_ENLIGHTENMENT',
  display_name = 'Enlightenment',
  desc = 'An exceptional magical drink which lets you "remember" your current location as if you had already seen all of it.',
  sval = 56,
  image = 'object/pot_placeholder.png',
  level = 25,
  cost = 800,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = {
    { level=25, rarity=1 },
    { level=50, rarity=1 },
    { level=100, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'gain knowledge of the surrounding area',
    use = function(self, who)
      game.logPlayer(who, 'An image of your surroundings forms in your mind...')
      local map = game.level.map
      map:liteAll(0, 0, map.w, map.h)
      map:rememberAll(0, 0, map.w, map.h)
      return { used=true, destroy=true, id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_HEROISM',
  name = 'POT_HEROISM',
  display_name = 'Heroism',
  desc = 'Quaffing this drink will temporarily make you fight like a hero of great might.',
  sval = 32,
  image = 'object/pot_placeholder.png',
  level = 1,
  cost = 35,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=1, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'protect yourself from fear and increase your fighting ability for 25+1d25 turns',
    use = function(self, who)
      local l1 = obj_util.remove_effects_and_learn(who, who.EFF_AFRAID)
      local l2 = obj_util.set_effect_and_learn(who, who.EFF_HEROISM, rng.range(1, 25) + 25, { merge='combine' })
      local l3 = obj_util.heal_and_learn(who, 10, self)
      return { used=true, destroy=true, id=(l1 or l2 or l3) }
    end,
  },
  in_trap = {
    damtype=DamageType.OLD_HEAL, dam={2,10}, r=0,
    side_effect = function(self, _, x, y, who)
      who:removeEffect(who.EFF_AFRAID)
    end,
    side_effect_desc = 'cures target monster of fear',
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_BERSERK_STRENGTH',
  name = 'POT_BERSERK_STRENGTH',
  display_name = 'Berserk Strength',
  desc = 'This strange drink will instill in you a wild battle rage for a while.',
  sval = 33,
  image = 'object/pot_placeholder.png',
  level = 3,
  cost = 100,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=3, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'protect yourself from fear and increase your fighting ability for 25+1d25 turns',
    use = function(self, who)
      local l1 = obj_util.remove_effects_and_learn(who, who.EFF_AFRAID)
      local l2 = obj_util.set_effect_and_learn(who, who.EFF_SUPERHEROISM, rng.range(1, 25) + 25, { merge='combine' })
      local l3 = obj_util.heal_and_learn(who, 30, self)
      return { used=true, destroy=true, id=(l1 or l2 or l3) }
    end,
  },
  in_trap = {
    damtype=DamageType.OLD_HEAL, dam={2,10}, r=0,
    side_effect = function(self, _, x, y, who)
      who:removeEffect(who.EFF_AFRAID)
    end,
    side_effect_desc = 'cures target monster of fear',
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_BOLDNESS',
  name = 'POT_BOLDNESS',
  display_name = 'Boldness',
  desc = 'This drink will improve your courage, dispelling all fear.',
  sval = 28,
  image = 'object/pot_placeholder.png',
  level = 1,
  cost = 10,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=1, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'remove fear',
    use = function(self, who)
      local learn = obj_util.remove_effects_and_learn(who, who.EFF_AFRAID)
      return { used=true, destroy=true, id=learn }
    end,
  },
  in_trap = {
    side_effect = function(self, _, x, y, who)
      who:removeEffect(who.EFF_AFRAID)
    end,
    side_effect_desc = 'cures target monster of fear',
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_RESTORE_LIFE_LEVELS',
  name = 'POT_RESTORE_LIFE_LEVELS',
  display_name = 'Restore Life Levels',
  desc = 'If your life force has been drained, this blessed brew will bring it back.',
  sval = 41,
  image = 'object/pot_placeholder.png',
  level = 40,
  cost = 400,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=40, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore lost EXP',
    use = function(self, who)
      local learn = who.restoreExp and who:restoreExp()
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_RESIST_HEAT',
  name = 'POT_RESIST_HEAT',
  display_name = 'Resist Heat',
  desc = 'This magical potion will make fire flow in your veins, rendering you less vulnerable to outward heat.',
  sval = 30,
  image = 'object/pot_placeholder.png',
  level = 1,
  cost = 30,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=1, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'increase your resistance to fire for 10+1d10 turns',
    use = function(self, who)
      local learn = obj_util.set_effect_and_learn(who, who.EFF_RES_FIRE, 10 + rng.range(1, 10), { merge='combine' })
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_RESIST_COLD',
  name = 'POT_RESIST_COLD',
  display_name = 'Resist Cold',
  desc = 'This magical potion will for a short while grant you a familiarity with frost, so that you take less harm from extreme cold.',
  sval = 31,
  image = 'object/pot_placeholder.png',
  level = 1,
  cost = 30,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=1, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'increase your resistance to cold for 10+1d10 turns',
    use = function(self, who)
      local learn = obj_util.set_effect_and_learn(who, who.EFF_RES_COLD, 10 + rng.range(1, 10), { merge='combine' })
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_DETECT_INVISIBLE',
  name = 'POT_DETECT_INVISIBLE',
  display_name = 'Detect Invisible',
  desc = 'This magical concoction will temporarily improve your eyesight so that you can see creatures otherwise unseen.',
  sval = 25,
  image = 'object/pot_placeholder.png',
  level = 3,
  cost = 50,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=3, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'see invisible monsters for 12+1d12 turns',
    use = function(self, who)
      learn = obj_util.set_effect_and_learn(who, who.EFF_SEE_INVIS, 12 + rng.range(1,12), { merge='combine' })
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_SLOW_POISON',
  name = 'POT_SLOW_POISON',
  display_name = 'Slow Poison',
  desc = 'This healthy potion will dilute poisons in your blood.',
  sval = 26,
  image = 'object/pot_placeholder.png',
  level = 1,
  cost = 25,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=1, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'reduce poison duration by half',
    use = function(self, who)
      local learn = obj_util.reduce_effect_and_learn(who, who.EFF_POISON, 1, { merge=function(c,n) return math.floor(c/2) end })
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_NEUTRALISE_POISON',
  name = 'POT_NEUTRALISE_POISON',
  display_name = 'Neutralise Poison',
  desc = 'This powerful antidote will completely negate the effect of poisons currently affecting you.',
  sval = 27,
  image = 'object/pot_placeholder.png',
  level = 5,
  cost = 75,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=5, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'cure poison',
    use = function(self, who)
      local learn = obj_util.remove_effects_and_learn(who, who.EFF_POISON)
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_RESTORE_MANA',
  name = 'POT_RESTORE_MANA',
  display_name = 'Restore Mana',
  desc = 'This potion infuses the drinker with pure magic force, bringing their magical potential back to its full extent.',
  sval = 40,
  image = 'object/pot_placeholder.png',
  level = 25,
  cost = 350,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=25, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore your mana to its maximum value',
    use = function(self, who)
      local do_msg = who.mana < who.max_mana
      local learn = false
      who.mana = who.max_mana
      if do_msg then
	game.logPlayer(who, 'You feel your head clear')
	learn = true
	self.changed = true
      end
      return { used=true, destroy=true, id=learn }
    end,
  },
  shatter_dam = { dt=DamageType.MANA, dice={10,10}, r=1, ident=true },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_INFRA_VISION',
  name = 'POT_INFRA_VISION',
  display_name = 'Infra-vision',
  desc = 'This potion temporarily grants or improves the ability to optically perceive heat sources.',
  sval = 24,
  image = 'object/pot_placeholder.png',
  level = 3,
  cost = 20,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=3, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'increase your infravision range by 1 for 100+1d100 turns',
    use = function(self, who)
      local learn = obj_util.set_effect_and_learn(who, who.EFF_INFRAVISION, 100 + rng.range(1,100), { merge='combine' })
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_RESISTANCE',
  name = 'POT_RESISTANCE',
  display_name = 'Resistance',
  desc = 'This great potion infuses you with the power of the elements, so that you can better withstand their ravages.',
  sval = 60,
  image = 'object/pot_placeholder.png',
  level = 20,
  cost = 250,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  allocation = {
    { level=20, rarity=1 },
    { level=45, rarity=1 },
    { level=80, rarity=1 },
    { level=100, rarity=1 },
  },
  pval = 100,
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'increase your resistance to fire, cold, lightning, acid and poison for 20+1d20 turns',
    use = function(self, who)
      local resists = {
	self.EFF_RES_FIRE, self.EFF_RES_COLD, self.EFF_RES_LIGHTNING,
	self.EFF_RES_ACID, self.EFF_RES_POIS
      }
      for _, res in ipairs(resists) do
	who:setEffect(res, 20 + rng.range(1, 20), { merge='combine' })
      end
      return { used=true, destroy=true, id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_DEATH',
  name = 'POT_DEATH',
  display_name = 'Death',
  desc = 'A potent and very quickly working poison, sometimes utilised by those who wish to end their lives. It is immensely toxic and will seriously hurt you even if you just get some of it on your hands.',
  sval = 23,
  image = 'object/pot_placeholder.png',
  level = 55,
  cost = 0,
  combat = { 20, 20 },
  flags = { FOUNTAIN=true },
  allocation = { { level=55, rarity=4 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'take 5000hp damage (presumably killing yourself)',
    use = function(self, who)
      game.logPlayer(who, 'A feeling of Death flows through your body.')
      who:takeHit(5000, self)
      return { used=true, destroy=true, id=true }
    end,
  },
  shatter_dam = { dt=DamageType.MANA, dice={10,10}, r=1, ident=true, angry=true },
  in_trap = { damtype=DamageType.NETHER, dam={100,20}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_RUINATION',
  name = 'POT_RUINATION',
  display_name = 'Ruination',
  desc = 'This wicked potion will seriously damage your abilities beyond the powers of magical restoration.',
  sval = 15,
  image = 'object/pot_placeholder.png',
  level = 40,
  cost = 0,
  combat = { 20, 20 },
  flags = { FOUNTAIN=true },
  allocation = { { level=40, rarity=8 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'take 10d10hp damage and temporarily reduce all your stats by 25',
    use = function(self, who)
      game.logPlayer(who, 'Your nerves and muscles feel weak and lifeless!')
      who:takeHit(rng.dice(10, 10), self)
      local Stats = require 'mod.class.interface.ActorStats'
      for _, s in ipairs(Stats.stats) do
	-- Surprisingly, this appears to be a temporary drop (the original T2
	-- code passes TRUE for the mode parameter, which is equal to one of
	-- the usual parameters, STAT_DEC_TEMPORARY); no idea if this is
	-- intentional.
	who:reduceStat(s, 25, { quiet=1, temporary=1 })
      end
      return { used=true, destroy=true, id=true }
    end,
  },
  shatter_dam = { dt=DamageType.SHARDS, dice={25,25}, r=2, ident=true, angry=true },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_DETONATIONS',
  name = 'POT_DETONATIONS',
  display_name = 'Detonations',
  desc = [[This bottle is filled with a strange substance which will violently explode if strongly agitated. You don't want to know what it might do to your intestines.]],
  sval = 22,
  image = 'object/pot_placeholder.png',
  level = 60,
  cost = 10000,
  combat = { 25, 25 },
  flags = { FOUNTAIN=true },
  allocation = { { level=60, rarity=8 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'take 50d20 explosive damage, stunning and cutting yourself',
    use = function(self, who)
      game.logPlayer(who, 'Massive explosions rupture your body!')
      who:takeHit(rng.dice(50, 20), self)
      who:setEffect(who.EFF_STUN, 75, { merge='combine' })
      who:setEffect(who.EFF_CUT, 5000, { merge='combine', src=self })
      return { used=true, destroy=true, id=true }
    end,
  },
  shatter_dam = { dt=DamageType.SHARDS, dice={25,25}, r=2, ident=true, angry=true },
  in_trap = { damtype=DamageType.DISINTEGRATE, dam={20,20}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_AUGMENTATION',
  name = 'POT_AUGMENTATION',
  display_name = 'Augmentation',
  desc = 'This blessed potion will greatly improve all your abilities, if they can still be improved.',
  sval = 55,
  image = 'object/pot_placeholder.png',
  level = 40,
  cost = 60000,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=40, rarity=16 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore and increase all your stats',
    use = function(self, who)
      local Stats = require 'mod.class.interface.ActorStats'
      local learn = false
      for _, s in ipairs(Stats.stats) do
	local ret = obj_util.raise_stat_and_learn(who, s)
	learn = learn or ret.id
      end
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_XTRA_HEALING',
  name = 'POT_XTRA_HEALING',
  display_name = '*Healing*',
  desc = 'This highly desirable potion will greatly help recovering from wounds, typically healing you fully.',
  sval = 38,
  image = 'object/pot_placeholder.png',
  level = 40,
  cost = 1500,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = {
    { level=40, rarity=4 },
    { level=60, rarity=2 },
    { level=80, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'heal 1200hp and cure blindness, confusion, poison, stun and cuts',
    use = function(self, who)
      local l1 = obj_util.heal_and_learn(who, 1200, self)
      local l2 = obj_util.remove_effects_and_learn(who, who.EFF_BLIND,
							who.EFF_CONFUSED,
							who.EFF_POISON,
							who.EFF_STUN,
							who.EFF_CUT)
      return { used=true, destroy=true, id=(l1 or l2) }
    end,
  },
  shatter_dam = { dt=DamageType.OLD_HEAL, dice={50,50}, r=1, ident=true },
  in_trap = { damtype=DamageType.OLD_HEAL, dam=1000, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_LIFE',
  name = 'POT_LIFE',
  display_name = 'Life',
  desc = [[This wonderful potion will fully heal you no matter how badly you're hurt, allow drained abilities to recover and remove various other ailments.]],
  sval = 39,
  image = 'object/pot_placeholder.png',
  level = 60,
  cost = 5000,
  combat = { 1, 1 },
  allocation = {
    { level=60, rarity=4 },
    { level=100, rarity=2 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'heal 5000hp, restore stats and EXP, and cure blindness, confusion, poison, hallucination, stun and cuts',
    use = function(self, who)
      if who.restoreExp then who:restoreExp() end
      who:heal(5000)
      who:removeEffect(who.EFF_BLIND)
      who:removeEffect(who.EFF_CONFUSED)
      who:removeEffect(who.EFF_POISON)
      who:removeEffect(who.EFF_HALLUCINATION)
      who:removeEffect(who.EFF_STUN)
      who:removeEffect(who.EFF_CUT)
      local Stats = require 'mod.class.interface.ActorStats'
      for _, s in ipairs(Stats.stats) do
	who:restoreStat(s)
      end
      who:removeEffect(who.EFF_BLACK_BREATH)
      return { used=true, destroy=true, id=true }
    end,
  },
  shatter_dam = { dt=DamageType.OLD_HEAL, dice={50,50}, r=1, ident=true },
  in_trap = {
    side_effect = function(self, _, x, y, who)
      local DamageType = require 'engine.DamageType'
      if who:hasFlag('UNDEAD') then
	local fake_spec = { damtype=DamageType.HOLY_FIRE, dam={20,20}, r=0 }
	trap_util.apply_trap_spec(trap, x, y, who, fake_spec)
      else
	who:heal(5000)
      end
    end,
    side_effect_desc = '20d20 #C__W#holy fire#LAST# damage to undead, otherwise heal 5000'
  }
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_SELF_KNOWLEDGE',
  name = 'POT_SELF_KNOWLEDGE',
  display_name = 'Self Knowledge',
  desc = 'A drink of insight, letting you know yourself better.',
  sval = 58,
  image = 'object/pot_placeholder.png',
  level = 40,
  cost = 2000,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=40, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'learn what properties your character has',
    use = function(self, who)
      game.logPlayer(who, 'You begin to know yourself a little better...')
      spell.self_knowledge_dialog(who)
      return { used=true, destroy=true, id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_XTRA_ENLIGHTENMENT',
  name = 'POT_XTRA_ENLIGHTENMENT',
  display_name = '*Enlightenment*',
  desc = 'This magical concoction will grant you great insight, magically improving your wits and wisdom, letting you know precisely who and where you are and what you possess.',
  sval = 57,
  image = 'object/pot_placeholder.png',
  level = 70,
  cost = 80000,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=70, rarity=4 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'learn the layout of the level, increase your INT and WIS, and learn what properties your character has',
    use = function(self, who)
      game.logPlayer(who, 'You begin to feel more enlightened...')
      local map = game.level.map
      map:liteAll(0, 0, map.w, map.h)
      map:rememberAll(0, 0, map.w, map.h)
      who:bumpStatUp('INT')
      who:bumpStatUp('WIS')
      spell.detect_traps(25, who)
      spell.detect_doors_stairs(25, who)
      spell.detect_buried_treasure(25, who)
      spell.detect_gold(25, who)
      spell.detect_objects(25, who)
      spell:inventoryApplyAll(function(_, _, o) o:identify(true, who) end)
      spell.self_knowledge_dialog(who)
      return { used=true, destroy=true, id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_CURE_LIGHT_WOUNDS',
  name = 'POT_CURE_LIGHT_WOUNDS',
  display_name = 'Cure Light Wounds',
  desc = 'This healthy drink heals a little damage you have taken.',
  sval = 34,
  image = 'object/pot_placeholder.png',
  level = 0,
  cost = 15,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = {
    { level=0, rarity=1 },
    { level=1, rarity=1 },
    { level=3, rarity=1 },
  },
  pval = 50,
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'heal 2d8hp, cure blindness and reduce cuts',
    use = function(self, who)
      local l1 = obj_util.heal_and_learn(who, rng.dice(2, 8), self)
      local l2 = obj_util.remove_effects_and_learn(who, who.EFF_BLIND)
      local l3 = obj_util.reduce_effect_and_learn(who, who.EFF_CUT, 1, { merge=function(c,n) return c - 10 end })
      return { used=true, destroy=true, id=(l1 or l2 or l3) }
    end,
  },
  shatter_dam = { dt=DamageType.OLD_HEAL, dice={2,3}, r=2, ident=true },
  in_trap = { damtype=DamageType.OLD_HEAL, dam={3,4}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_CLUMSINESS',
  name = 'POT_CLUMSINESS',
  display_name = 'Clumsiness',
  desc = 'This nasty concoction will numb your nerves, making you clumsier.',
  sval = 19,
  image = 'object/pot_placeholder.png',
  level = 5,
  cost = 0,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=5, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'damage your DEX',
    use = function(self, who) return obj_util.reduce_stat_and_learn(who, 'DEX') end,
  },
  shatter_dam = { angry=true },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_SICKLINESS',
  name = 'POT_SICKLINESS',
  display_name = 'Sickliness',
  desc = 'This unhealthy drink damages your health, reducing your physical constitution.',
  sval = 20,
  image = 'object/pot_placeholder.png',
  level = 10,
  cost = 0,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'damage your CON',
    use = function(self, who) return obj_util.reduce_stat_and_learn(who, 'CON') end,
  },
  shatter_dam = { angry=true },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_WATER_CURING',
  name = 'POT_WATER_CURING',
  display_name = 'Water Curing',
  desc = 'It is a magical component that can purify water.',
  sval = 274,
  image = 'object/pot_placeholder.png',
  level = 0,
  cost = 0,
  combat = { 1, 1 },
  special_gene = true,
  allocation = { { level=0, rarity=1 } },
  pval = 80,
  -- BEGIN VERBATIM
  -- This doesn't appear to do anything, so don't let the player quaff it.
  use_simple = table.NIL_MERGE,
  -- As a courtesy to the player. ;)
  destroyed_by = table.NIL_MERGE,
  ignore_dam = { [DamageType.COLD]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.ACID]=true },
  -- Drop checking will be handled in the quest's on_drop_pre() callback.
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_BLOOD_OF_LIFE',
  name = 'POT_BLOOD_OF_LIFE',
  display_name = '& Blood~ of Life',
  desc = 'Quaffing this measure of living blood will imbue your body and soul with the power to escape death one time.',
  sval = 3,
  image = 'object/pot_placeholder.png',
  level = 70,
  cost = 10000,
  combat = { 1, 1 },
  norm_art = true,
  unique = 'POT_BLOOD_OF_LIFE',
  flags = { FULL_NAME=true, EASY_KNOW=table.NIL_MERGE },
  allocation = { { level=70, rarity=16 } },
  artifact_info = '71:2',
  pval = 200,
  -- BEGIN VERBATIM
  rating = 25,
  use_simple = {
    name_base = 'gain one resurrection',
    use = function(self, who)
      who:setEffect(who.EFF_BLOOD_OF_LIFE, 1, {})
      return { used=true, destroy=true, id=true }
    end,
  },
  resolvers.precog_mention(),
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_INVISIBILITY',
  name = 'POT_INVISIBILITY',
  display_name = 'Invisibility',
  desc = 'This magical brew will temporarily hide you from sight, and also attunes you to this state so that your eyes can still perceive your hidden form.',
  sval = 8,
  image = 'object/pot_placeholder.png',
  level = 3,
  cost = 50,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=3, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'become invisible (power 35) for 30+1d30 turns',
    use = function(self, who)
      local learn = obj_util.set_effect_and_learn(who, who.EFF_INVISIBLE, 30 + rng.range(1, 30), { combine='merge', power=35 })
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_CORRUPTION',
  name = 'POT_CORRUPTION',
  display_name = 'Corruption',
  desc = 'This concoction of toxic wastes will strangely warp your shape.',
  sval = 10,
  image = 'object/pot_placeholder.png',
  level = 3,
  cost = 0,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = {
    { level=20, rarity=1 },
    { level=30, rarity=1 },
    { level=40, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    use = function(self, who)
      -- TODO Gain corruption, if I don't punt this altogether...
      return { used=true, destroy=true, id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_MORPHIC_OIL_OF',
  name = 'POT_MORPHIC_OIL_OF',
  display_name = '& Morphic Oil~ of #',
  desc = 'This concoction can transform your body for a short period of time.',
  sval = 257,
  image = 'object/pot_placeholder.png',
  level = 5,
  cost = 100,
  combat = { 1, 1 },
  flags = { FULL_NAME=true, EASY_KNOW=true },
  allocation = {
    { level=1, rarity=3 },
    { level=5, rarity=1 },
    { level=10, rarity=1 },
  },
  -- BEGIN VERBATIM
  name_cb = function(self, name, t)
    if t.unresolved then return '& Morphic Oil' end
    local ObjectData = require 'mod.class.interface.ObjectData'
    local mf = ObjectData.mimicry_forms[self.mimic_form]
    return '& Morphic Oil~ of '..(mf and mf.name or '???')
  end,
  use_simple = {
    name_base = function(self)
      local ObjectData = require 'mod.class.interface.ObjectData'
      local mf = ObjectData.mimicry_forms[self.mimic_form]
      local a = mf.name:gmatch('^[AEIOUaeiou]') and 'an' or 'a'
      local fmt = 'transform into %s %s for %dd%d turns'
      return fmt:format(a, mf.name, mf.duration[1], mf.duration[2])
    end,
    use = function (self, who)
      if not who:hasEffect(who.EFF_MIMIC_FORM) then
	local ObjectData = require 'mod.class.interface.ObjectData'
	local t = ObjectData.mimicry_forms[self.mimic_form]
	local dur = rng.range(t.duration[1], t.duration[2])
	local lev = math.floor((who.level*2)/3)
	who:setEffect(who.EFF_MIMIC_FORM, dur, { mimic = t, level = lev })
      end
      return { used=true, destroy=true, id=true }
    end,
  },
  mimic_form = resolvers.mimicry_form(false),
  check_stack = function(self, o)
    -- If we've gotten to this point, both objects are Morphic Oils; we
    -- just need to check that they have the same mimicry form.
    return self.mimic_form == o.mimic_form
  end,
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_CURE_LIGHT_INSANITY',
  name = 'POT_CURE_LIGHT_INSANITY',
  display_name = 'Cure Light Insanity',
  desc = 'A magical potion which drives away irrational quirks of behaviour.',
  sval = 270,
  image = 'object/pot_placeholder.png',
  level = 1,
  cost = 15,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = {
    { level=5, rarity=1 },
    { level=1, rarity=1 },
    { level=3, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore 4d8 sanity',
    use = function(self, who)
      local learn = who:healSanity(rng.dice(4, 8), self)
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_CURE_SERIOUS_INSANITY',
  name = 'POT_CURE_SERIOUS_INSANITY',
  display_name = 'Cure Serious Insanity',
  desc = 'A magical brew which will lift shadows that have been cast on your soul.',
  sval = 271,
  image = 'object/pot_placeholder.png',
  level = 10,
  cost = 40,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore 8d8 sanity',
    use = function(self, who)
      local learn = who:healSanity(rng.dice(8, 8), self)
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_CURE_CRITICAL_INSANITY',
  name = 'POT_CURE_CRITICAL_INSANITY',
  display_name = 'Cure Critical Insanity',
  desc = 'This drink will cure you even of serious mental disorders.',
  sval = 272,
  image = 'object/pot_placeholder.png',
  level = 15,
  cost = 100,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=15, rarity=3 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore 12d8 sanity',
    use = function(self, who)
      local learn = who:healSanity(rng.dice(12, 8), self)
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_CURE_INSANITY',
  name = 'POT_CURE_INSANITY',
  display_name = 'Cure Insanity',
  desc = 'This blessed potion can make you completely sane and healthy, even if you have only the faintest shred of sanity left.',
  sval = 273,
  image = 'object/pot_placeholder.png',
  level = 25,
  cost = 300,
  combat = { 1, 1 },
  flags = { FOUNTAIN=true },
  allocation = { { level=25, rarity=3 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'restore 10d100 sanity',
    use = function(self, who)
      local learn = who:healSanity(rng.dice(10, 100), self)
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'POTION_BASE',
  define_as = 'POT_POTION_OF_LEARNING',
  name = 'POT_POTION_OF_LEARNING',
  display_name = '& Potion~ of Learning',
  desc = 'This old potion is supposed to grant more learning power to its user.',
  sval = 12,
  image = 'object/pot_placeholder.png',
  level = 90,
  cost = 100000,
  combat = { 1, 1 },
  norm_art = true,
  unique = 'POT_POTION_OF_LEARNING',
  flags = { FULL_NAME=true, EASY_KNOW=table.NIL_MERGE },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true, [DamageType.ELEC]=true },
  allocation = { { level=90, rarity=25 } },
  artifact_info = '71:49',
  pval = 200,
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'gain 4-14 skill points',
    use = function(self, who)
      local learn = false
      if who == game.player then
	who.skill_points = who.skill_points + rng.range(4, 10 + who.getLuckScale(-4, 4))
	local key = util.getFormattedKeyBinds('LEVELUP', "' or '")
	game.log("#00FFFF#%s has %d skill points to spend.  Press '%s' to use them.#LAST#", self.name, self.skill_points, key)
	learn = true
      end
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}
-- 68 total items
-- level:  0=9; 1=8; 10=3; 15=2; 18=1; 20=11; 25=8; 3=8; 40=5; 5=4; 50=1; 55=1; 60=2; 65=1; 70=2; 90=2
-- cost:  0=17; 1=2; 10=1; 100=4; 1000=1; 10000=2; 100000=2; 15=2; 1500=1; 2=1; 20=1; 2000=1; 25=1; 250=2; 25000=1; 30=2; 300=8; 35=1; 350=1; 40=2; 400=1; 50=2; 5000=1; 60000=1; 75=2; 750000=1; 800=1; 8000=5; 80000=1
-- artifact_info:  71:2=1; 71:49=1
-- pval:  -2500=1; 100=6; 200=4; 250=1; 400=1; 50=3; 80=1
