-- $Id: stores.lua 2835 2017-04-11 00:13:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_store' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Store entities generated from T2's st_info.txt.

newEntity {
  define_as = 'GENERAL_STORE',
  name = "General Store",
  display = '1',
  color = colors.C_U,
  image = 'store/general_store.png',
  owner = resolvers.store_owner{ 'BILBO', 'RAISTLIN', 'SULTAN', 'LYAR_EL' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  store = {
    prob_filters = {
      { defined='WOODEN_TORCH', id='full' },
      { defined='BRASS_LANTERN', id='full', prob=95 },
      { defined='FLASK_OF_OIL', id='full', prob=95 },
      { defined='RATION_OF_FOOD', id='full' },
      { defined='HARD_BISCUIT', id='full' },
      { defined='STRIP_OF_VENISON', id='full', prob=90 },
      { defined='PINT_OF_FINE_WINE', id='full', prob=70 },
      { defined='PINT_OF_FINE_ALE', id='full', prob=80 },
      { defined='SHOVEL', id='full', prob=60 },
      { defined='PICK', id='full', prob=50 },
      { defined='IRON_SPIKE', id='full' },
      { defined='IRON_SHOT', id='full', prob=70 },
      { defined='BOLT', id='full', prob=70 },
      { defined='ARROW', id='full', prob=70 },
      { defined='CLOAK', id='full', prob=98 },
      { defined='FUR_CLOAK', id='full', prob=46 },
    },
    fixed = {
      { defined='BRASS_LANTERN', id='full' },
    },
    max_stock = 24,
    actor_filter = function(o)
      return require('mod.class.Store'):actor_filter_hack('GENERAL_STORE', o)
    end,
    stock_base = {
      misc = { corpse=true, oil=true, spike=true, bottle=true, },
      food = true,
      equipment = { light = true },
      ammo = true,
      tool = 'digger',
      armor = 'cloak',
    },
  },
}

newEntity {
  define_as = 'ARMOURY',
  name = "Armoury",
  display = '2',
  color = colors.C_s,
  image = 'store/armoury.png',
  owner = resolvers.store_owner{ 'KON_DAR', 'DARG_LOW', 'DECADO', 'WIELAND' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  store = {
    prob_filters = {
      { defined='PAIR_OF_SOFT_LEATHER_BOOTS', id='full', prob=70 },
      { defined='PAIR_OF_HARD_LEATHER_BOOTS', id='full', prob=60 },
      { defined='HARD_LEATHER_CAP', id='full', prob=80 },
      { defined='METAL_CAP', id='full', prob=70 },
      { defined='IRON_HELM', id='full', prob=65 },
      { defined='ROBE', id='full' },
      { defined='SOFT_LEATHER_ARMOUR', id='full', prob=90 },
      { defined='SOFT_STUDDED_LEATHER', id='full', prob=90 },
      { defined='HARD_LEATHER_ARMOUR', id='full', prob=90 },
      { defined='HARD_STUDDED_LEATHER', id='full', prob=85 },
      { defined='LEATHER_SCALE_MAIL', id='full', prob=90 },
      { defined='METAL_SCALE_MAIL', id='full', prob=80 },
      { defined='CHAIN_MAIL', id='full', prob=75 },
      { defined='AUGMENTED_CHAIN_MAIL', id='full', prob=80 },
      { defined='METAL_BRIGANDINE_ARMOUR', id='full', prob=75 },
      { defined='BAR_CHAIN_MAIL', id='full', prob=68 },
      { defined='SET_OF_LEATHER_GLOVES', id='full' },
      { defined='SET_OF_GAUNTLETS', id='full', prob=80 },
      { defined='SMALL_LEATHER_SHIELD', id='full' },
      { defined='LARGE_LEATHER_SHIELD', id='full', prob=90 },
      { defined='SMALL_METAL_SHIELD', id='full', prob=80 },
    },
    max_stock = 24,
    actor_filter = function(o)
      return require('mod.class.Store'):actor_filter_hack('ARMOURY', o)
    end,
    stock_base = {
      armor = true,
    },
  },
}

newEntity {
  define_as = 'WEAPONSMITH',
  name = "Weaponsmith",
  display = '3',
  color = colors.C_w,
  image = 'store/weaponsmith.png',
  owner = resolvers.store_owner{ 'ARNOLD', 'ARNDAL', 'EDDIE', 'OGLIGN' },
  -- actions:
  --   Compare weapons (23)
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  store = {
    prob_filters = {
      { defined='DAGGER', id='full' },
      { defined='MAIN_GAUCHE', id='full' },
      { defined='RAPIER', id='full' },
      { defined='SMALL_SWORD', id='full' },
      { defined='SHORT_SWORD', id='full' },
      { defined='SABRE', id='full' },
      { defined='CUTLASS', id='full' },
      { defined='TULWAR', id='full' },
      { defined='BROAD_SWORD', id='full' },
      { defined='LONG_SWORD', id='full' },
      { defined='SCIMITAR', id='full' },
      { defined='KATANA', id='full' },
      { defined='BASTARD_SWORD', id='full' },
      { defined='SPEAR', id='full' },
      { defined='AWL_PIKE', id='full' },
      { defined='TRIDENT', id='full' },
      { defined='PIKE', id='full' },
      { defined='BEAKED_AXE', id='full' },
      { defined='BROAD_AXE', id='full' },
      { defined='LANCE', id='full' },
      { defined='BATTLE_AXE', id='full' },
      { defined='HATCHET', id='full' },
      { defined='SLING', id='full' },
      { defined='SHORT_BOW', id='full' },
      { defined='LONG_BOW', id='full' },
      { defined='LIGHT_CROSSBOW', id='full' },
      { defined='IRON_SHOT', id='full' },
      { defined='ARROW', id='full' },
      { defined='BOLT', id='full' },
      { defined='WHIP', id='full' },
      { defined='SMALL_WOODEN_BOOMERANG', id='full' },
    },
    max_stock = 24,
    actor_filter = function(o)
      return require('mod.class.Store'):actor_filter_hack('WEAPONSMITH', o)
    end,
    stock_base = {
      ammo = true,
      weapon = true,
      shooter = true,
    },
  },
}

newEntity {
  define_as = 'TEMPLE',
  name = "Temple",
  display = '4',
  color = colors.C_g,
  image = 'store/temple.png',
  owner = resolvers.store_owner{ 'LUDWIG', 'GUNNAR', 'TORIN', 'SARASTRO' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  store = {
    prob_filters = {
      { defined='QUARTERSTAFF', id='full' },
      { defined='MACE', id='full' },
      { defined='WAR_HAMMER', id='full' },
      { defined='LUCERNE_HAMMER', id='full' },
      { defined='MORNING_STAR', id='full' },
      { defined='FLAIL', id='full' },
      { defined='LEAD_FILLED_MACE', id='full' },
      { defined='SCRL_REMOVE_CURSE', id='full' },
      { defined='SCRL_BLESSING', id='full' },
      { defined='SCRL_HOLY_CHANT', id='full' },
      { defined='POT_HEROISM', id='full' },
      { defined='SCRL_WORD_OF_RECALL', id='full' },
      { defined='SCRL_WORD_OF_RECALL', id='full' },
      { defined='SCRL_WORD_OF_RECALL', id='full' },
      { defined='POT_CURE_LIGHT_WOUNDS', id='full' },
      { defined='POT_CURE_SERIOUS_WOUNDS', id='full' },
      { defined='POT_CURE_SERIOUS_WOUNDS', id='full' },
      { defined='POT_CURE_CRITICAL_WOUNDS', id='full' },
      { defined='POT_CURE_CRITICAL_WOUNDS', id='full' },
      { defined='POT_RESTORE_LIFE_LEVELS', id='full' },
      { defined='POT_RESTORE_LIFE_LEVELS', id='full' },
      { defined='POT_RESTORE_LIFE_LEVELS', id='full' },
      { defined='WHIP', id='full' },
      { defined='MACE', id='full' },
      { defined='BALL_AND_CHAIN', id='full' },
      { defined='WAR_HAMMER', id='full' },
      { defined='SCRL_WORD_OF_RECALL', id='full' },
      { defined='SCRL_WORD_OF_RECALL', id='full' },
      { defined='SCRL_WORD_OF_RECALL', id='full' },
      { defined='POT_CURE_CRITICAL_WOUNDS', id='full' },
      { defined='POT_CURE_CRITICAL_WOUNDS', id='full' },
      { defined='POT_RESTORE_LIFE_LEVELS', id='full' },
      { defined='POT_RESTORE_LIFE_LEVELS', id='full' },
      { defined='POT_RESTORE_LIFE_LEVELS', id='full' },
      { defined='SCRL_REMOVE_CURSE', id='full' },
      { defined='SCRL_REMOVE_CURSE', id='full' },
      { defined='SCRL_XTRA_REMOVE_CURSE', id='full' },
      { defined='SCRL_XTRA_REMOVE_CURSE', id='full' },
    },
    max_stock = 24,
    actor_filter = function(o)
      return require('mod.class.Store'):actor_filter_hack('TEMPLE', o)
    end,
    stock_base = {
      -- resolve_flags{} below will make this a god spell book.
      magic = 'spellbook',
      utility = { scroll=true, potion=true, },
      weapon = function(o)
	-- TODO Allow blessed weapons.
	return o.subtype == 'hafted' or o.subtype == 'magestaff'
      end
    },
  },
  -- BEGIN VERBATIM
  resolve_flags = { force_spell_type = 'SPIRITUALITY' }
  -- END VERBATIM
}

newEntity {
  define_as = 'ALCHEMY_SHOP',
  name = "Alchemy shop",
  display = '5',
  color = colors.C_b,
  image = 'store/alchemy_shop.png',
  owner = resolvers.store_owner{ 'MAUSER', 'WIZZLE', 'MIDAS', 'JA_FAR' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  store = {
    prob_filters = {
      { defined='SCRL_ENCHANT_WEAPON_TO_HIT', id='full' },
      { defined='SCRL_ENCHANT_WEAPON_TO_DAM', id='full' },
      { defined='SCRL_ENCHANT_ARMOUR', id='full' },
      { defined='STAFF_IDENTIFY', id='full' },
      { defined='STAFF_IDENTIFY', id='full' },
      { defined='STAFF_IDENTIFY', id='full' },
      { defined='STAFF_IDENTIFY', id='full' },
      { defined='ESS_LIGHT', id='full' },
      { defined='SCRL_PHASE_DOOR', id='full' },
      { defined='SCRL_PHASE_DOOR', id='full' },
      { defined='SCRL_TELEPORTATION', id='full' },
      { defined='SCRL_MONSTER_CONFUSION', id='full' },
      { defined='SCRL_MAGIC_MAPPING', id='full' },
      { defined='SCRL_TREASURE_DETECTION', id='full' },
      { defined='SCRL_OBJECT_DETECTION', id='full' },
      { defined='SCRL_TRAP_DETECTION', id='full' },
      { defined='POT_DETECT_INVISIBLE', id='full' },
      { defined='SCRL_RECHARGING', id='full' },
      { defined='SCRL_SATISFY_HUNGER', id='full' },
      { defined='SCRL_WORD_OF_RECALL', id='full' },
      { defined='SCRL_WORD_OF_RECALL', id='full' },
      { defined='SCRL_WORD_OF_RECALL', id='full' },
      { defined='SCRL_WORD_OF_RECALL', id='full' },
      { defined='SCRL_TELEPORTATION', id='full' },
      { defined='SCRL_TELEPORTATION', id='full' },
      { defined='POT_RESTORE_STRENGTH', id='full' },
      { defined='POT_RESTORE_INTELLIGENCE', id='full' },
      { defined='POT_RESTORE_WISDOM', id='full' },
      { defined='POT_RESTORE_DEXTERITY', id='full' },
      { defined='POT_RESTORE_CONSTITUTION', id='full' },
      { defined='POT_RESTORE_CHARISMA', id='full' },
      { defined='STAFF_IDENTIFY', id='full' },
      { defined='SCRL_XTRA_IDENTIFY', id='full' },
      { defined='SCRL_XTRA_IDENTIFY', id='full' },
      { defined='SCRL_XTRA_IDENTIFY', id='full' },
      { defined='SCRL_XTRA_IDENTIFY', id='full' },
      { defined='SCRL_XTRA_IDENTIFY', id='full' },
      { defined='SCRL_XTRA_IDENTIFY', id='full' },
      { defined='ESS_LIGHT', id='full' },
      { defined='POT_RESTORE_STRENGTH', id='full' },
      { defined='POT_RESTORE_INTELLIGENCE', id='full' },
      { defined='POT_RESTORE_WISDOM', id='full' },
      { defined='POT_RESTORE_DEXTERITY', id='full' },
      { defined='POT_RESTORE_CONSTITUTION', id='full' },
      { defined='POT_RESTORE_CHARISMA', id='full' },
      { defined='SCRL_ENCHANT_ARMOUR', id='full' },
      { defined='SCRL_ENCHANT_ARMOUR', id='full' },
      { defined='SCRL_RECHARGING', id='full' },
      { defined='SCRL_SATISFY_HUNGER', id='full' },
      { defined='SCRL_SATISFY_HUNGER', id='full' },
      { defined='SCRL_SATISFY_HUNGER', id='full' },
    },
    max_stock = 24,
    actor_filter = function(o)
      return require('mod.class.Store'):actor_filter_hack('ALCHEMY_SHOP', o)
    end,
    stock_base = {
      utility = { scroll=true, potion=true, },
      misc = { alchemic=true, bottle=true, },
    },
  },
}

newEntity {
  define_as = 'MAGIC_SHOP',
  name = "Magic shop",
  display = '6',
  color = colors.C_r,
  image = 'store/magic_shop.png',
  owner = resolvers.store_owner{ 'ARIEL', 'BUGGERBY', 'INGLORIAN', 'LUTHIEN' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  store = {
    prob_filters = {
      { defined='RUNE_PROTECTION', id='full' },
      { defined='RING_LEVITATION', id='full' },
      { defined='RUNE_PROTECTION', id='full' },
      { defined='RING_FIRE_RESISTANCE', id='full' },
      { defined='RING_COLD_RESISTANCE', id='full' },
      { defined='POT_CHARISMA', id='full' },
      { defined='AMULET_SLOW_DIGESTION', id='full' },
      { defined='AMULET_SLOW_DIGESTION', id='full' },
      { defined='AMULET_ACID_RESISTANCE', id='full' },
      { defined='AMULET_LIGHTNING_RESISTANCE', id='full' },
      { defined='AMULET_SEARCHING', id='full' },
      { defined='POT_CURE_LIGHT_WOUNDS', id='full' },
      { defined='TIP_PROBING', id='full' },
      { defined='WOODEN_ROD_OF', id='full', prob=25 },
      { defined='BOOK_OF_BEGINNER_CANTRIPS', id='full' },
      { defined='WAND_MANATHRUST', id='full' },
      { defined='WAND_NOXIOUS_CLOUD', id='full' },
      { defined='WAND_DIG', id='full' },
      { defined='WAND_MAGELOCK', id='full' },
      { defined='WAND_CONFUSE', id='full' },
      { defined='STAFF_GLOBE_OF_LIGHT', id='full' },
      { defined='STAFF_REMOVE_CURSES', id='full' },
      { defined='STAFF_DISARM', id='full' },
      { defined='STAFF_TELEPORTATION', id='full' },
      { defined='STAFF_IDENTIFY', id='full' },
      { defined='STAFF_SENSE_HIDDEN', id='full', prob=60 },
      { defined='STAFF_REVEAL_WAYS', id='full', prob=60 },
      { defined='STAFF_SENSE_MONSTERS', id='full', prob=60 },
    },
    max_stock = 24,
    actor_filter = function(o)
      return require('mod.class.Store'):actor_filter_hack('MAGIC_SHOP', o)
    end,
    stock_base = {
      -- resolve_flags{} below will make this a school spell book.
      magic = 'spellbook',
      jewelry = { ring=true, amulet=true, },
      utility = {
	staff=true, wand=true, rod=true, rodtip=true, scroll=true, potion=true,
      },
      weapon = 'magestaff',
      misc = 'junkart',
    },
  },
  -- BEGIN VERBATIM
  resolve_flags = { force_spell_type = 'MAGIC' }
  -- END VERBATIM
}

newEntity {
  define_as = 'BLACK_MARKET',
  name = "Black Market",
  display = '7',
  color = colors.C_D,
  image = 'store/black_market.png',
  owner = resolvers.store_owner{ 'GARY', 'HISTOR', 'ZORAK', 'TIPO' },
  -- actions:
  --   Get share of stolen gold (30)
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ ALL_ITEM MEDIUM_LEVEL ]
  store = {
    prob_filters = {
      { id='full' },
    },
    max_stock = 24,
    actor_filter = function(o)
      return require('mod.class.Store'):actor_filter_hack('BLACK_MARKET', o)
    end,
    stock_base = function(o) return true end,
    black_market = true,
    level_adjust = { 25, 49 },
  },
}

newEntity {
  define_as = 'HOME',
  name = "Home",
  display = '8',
  color = colors.C_y,
  image = 'store/home.png',
  owner = resolvers.store_owner{ 'BILBO' },
  -- actions:
  --   Drop an item (54)
  --   Get an item (55)
  --   Examine an item (3)
  store = {
    max_stock = 24,
  },
}

newEntity {
  define_as = 'BOOK_STORE',
  name = "Book Store",
  display = '9',
  color = colors.C_o,
  image = 'store/book_store.png',
  owner = resolvers.store_owner{ 'DOLAF', 'ODNAR', 'GANDAR', 'RO_SHA' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  store = {
    prob_filters = {
      { defined='BOOK_OF_BEGINNER_CANTRIPS', id='full' },
      { defined='BOOK_OF_BEGINNER_CANTRIPS', id='full' },
      { defined='SPELLBOOK_OF', id='full' },
      { defined='SPELLBOOK_OF', id='full' },
      { defined='SPELLBOOK_OF', id='full' },
      { defined='SPELLBOOK_OF', id='full' },
      { defined='SPELLBOOK_OF', id='full' },
      { defined='SPELLBOOK_OF', id='full' },
    },
    max_stock = 24,
    actor_filter = function(o)
      return require('mod.class.Store'):actor_filter_hack('BOOK_STORE', o)
    end,
    stock_base = {
      magic = 'spellbook',
      weapon = function(o) return o.is_demongear end,
      armor = function(o) return o.is_demongear end,
    },
  },
}

newEntity {
  define_as = 'PET_SHOP',
  name = "Pet Shop",
  display = '+',
  color = colors.C_b,
  image = 'store/pet_shop.png',
  owner = resolvers.store_owner{ 'N_RAK', 'ESPERION', 'FLARIM', 'TRIL_AKHEB' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ MEDIUM_LEVEL ]
  store = {
    prob_filters = {
      { defined='EGG', id='full' },
      { defined='SCRL_SUMMON_NEVER_MOVING_PET', id='full' },
      { defined='HARD_BISCUIT', id='full' },
    },
    max_stock = 12,
    actor_filter = function(o)
      return require('mod.class.Store'):actor_filter_hack('PET_SHOP', o)
    end,
    stock_base = {
      misc = 'egg',
    },
    level_adjust = { 25, 49 },
  },
}

newEntity {
  define_as = 'MAYOR_S_OFFICE',
  name = "Mayor's Office",
  display = '+',
  color = colors.C_o,
  image = 'store/mayor_s_office.png',
  owner = resolvers.store_owner{ 'ULDRIK' },
  -- actions:
  --   Race legends (16)
  --   Town history (15)
  --   Get a quest (35)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'INN',
  name = "Inn",
  display = '+',
  color = colors.C_w,
  image = 'store/inn.png',
  owner = resolvers.store_owner{ 'OTICK', 'CELEBOR' },
  -- actions:
  --   Purchase an item (2)
  --   Steal an item (4)
  --   Rest for the night (5)
  --   Buy food and drink (6)
  --   Listen for rumours (7)
  store = {
    prob_filters = {
      { defined='RATION_OF_FOOD', id='full' },
      { defined='HARD_BISCUIT', id='full' },
      { defined='STRIP_OF_VENISON', id='full' },
      { defined='PINT_OF_FINE_WINE', id='full' },
      { defined='PINT_OF_FINE_ALE', id='full' },
    },
    max_stock = 8,
  },
}

newEntity {
  define_as = 'THE_SOOTHSAYER',
  name = "The Soothsayer",
  display = '+',
  color = colors.C_B,
  image = 'store/the_soothsayer.png',
  owner = resolvers.store_owner{ 'MERANA' },
  -- actions:
  --   Purchase an item (2)
  --   Presage fate (8)
  -- flags = [ RANDOM ]
  store = {
    prob_filters = {
      { defined='SCRL_DIVINATION', id='full', prob=20 },
      { defined='SCRL_DIVINATION', id='full', prob=20 },
      { defined='SCRL_DIVINATION', id='full', prob=20 },
      { defined='SCRL_DIVINATION', id='full', prob=20 },
      { defined='SCRL_DIVINATION', id='full', prob=20 },
      { defined='SCRL_DIVINATION', id='full', prob=20 },
    },
    max_stock = 2,
    dungeon_town = true,
  },
}

newEntity {
  define_as = 'LIBRARY',
  name = "Library",
  display = '+',
  color = colors.C_U,
  image = 'store/library.png',
  owner = resolvers.store_owner{ 'MIRIMBAR' },
  -- actions:
  --   Research item (14)
  --   Town history (15)
  --   Race legends (16)
  --   Purchase an item (2)
  store = {
    prob_filters = {
      { defined='STAFF_IDENTIFY', id='full' },
    },
    max_stock = 2,
  },
}

newEntity {
  define_as = 'CASTLE',
  name = "Castle",
  display = '+',
  color = colors.C_o,
  image = 'store/castle.png',
  owner = resolvers.store_owner{ 'ARAGORN' },
  -- actions:
  --   Race legends (16)
  --   Get a quest (35)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'CASINO',
  name = "Casino",
  display = '+',
  color = colors.C_s,
  image = 'store/casino.png',
  owner = resolvers.store_owner{ 'SONDAR' },
  -- actions:
  --   Game rules (13)
  --   In-Between (9)
  --   Play craps (10)
  --   Play dice slots (12)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'BEASTMASTER_SHANTY',
  name = "Beastmaster Shanty",
  display = '+',
  color = colors.C_g,
  image = 'store/beastmaster_shanty.png',
  owner = resolvers.store_owner{ 'SHARRA' },
  -- actions:
  --   Research monster (18)
  --   Get quest monster (21)
  --   Turn in quest corpse (22)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'FIGHTERS_HALL',
  name = "Fighters Hall",
  display = '+',
  color = colors.C_s,
  image = 'store/fighters_hall.png',
  owner = resolvers.store_owner{ 'HJOLGAR' },
  -- actions:
  --   Enchant weapon (24)
  --   Enchant armour (25)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'TOWER_OF_MAGERY',
  name = "Tower of Magery",
  display = '+',
  color = colors.C_b,
  image = 'store/tower_of_magery.png',
  owner = resolvers.store_owner{ 'TANISTIL' },
  -- actions:
  --   Recharge item (26)
  --   Identify possessions (27)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'INNER_TEMPLE',
  name = "Inner Temple",
  display = '+',
  color = colors.C_G,
  image = 'store/inner_temple.png',
  owner = resolvers.store_owner{ 'ELDORE' },
  -- actions:
  --   Healing prayer (28)
  --   Restoration (29)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'PALADINS_GUILD',
  name = "Paladins Guild",
  display = '+',
  color = colors.C_g,
  image = 'store/paladins_guild.png',
  owner = resolvers.store_owner{ 'VILIOS' },
  -- actions:
  --   Healing prayer (28)
  --   Enchant armour (25)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'RANGERS_GUILD',
  name = "Rangers Guild",
  display = '+',
  color = colors.C_u,
  image = 'store/rangers_guild.png',
  owner = resolvers.store_owner{ 'ANGROS' },
  -- actions:
  --   Enchant arrows (31)
  --   Enchant bow (32)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'THUNDERLORDS_NEST',
  name = "Thunderlords' Nest",
  display = '+',
  color = colors.C_U,
  image = 'store/thunderlords_nest.png',
  owner = resolvers.store_owner{ 'PALANO' },
  -- actions:
  --   Recall to dungeon (33)
  --   Purchase an item (2)
  --   Teleport to dungeon-level (34)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'THE_MIRROR',
  name = "The Mirror",
  display = '+',
  color = colors.C_U,
  image = 'store/the_mirror.png',
  owner = resolvers.store_owner{ 'GALADRIEL' },
  -- actions:
  --   Research item (44)
  --   Town history (15)
  --   Race legends (16)
  --   View fate (43)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'SEAT_OF_RULING',
  name = "Seat of Ruling",
  display = '+',
  color = colors.C_U,
  image = 'store/seat_of_ruling.png',
  owner = resolvers.store_owner{ 'CELEBORN' },
  -- actions:
  --   Look at busts of Kings (17)
  --   Get a quest (35)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'WIZARDS_SPIRE',
  name = "Wizards Spire",
  display = '+',
  color = colors.C_U,
  image = 'store/wizards_spire.png',
  owner = resolvers.store_owner{ 'VALCERONWE' },
  -- actions:
  --   Get a quest (60)
  --   Recharge item (26)
  --   Identify possessions (27)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'PRIESTS_CIRCLE',
  name = "Priests Circle",
  display = '+',
  color = colors.C_o,
  image = 'store/priests_circle.png',
  owner = resolvers.store_owner{ 'VORONWE' },
  -- actions:
  --   Healing prayer (28)
  --   Restoration (29)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'TOWER_OF_THE_KING',
  name = "Tower of the King",
  display = '+',
  color = colors.C_U,
  image = 'store/tower_of_the_king.png',
  owner = resolvers.store_owner{ 'TURGON' },
  -- actions:
  --   Look at busts of Kings (17)
  --   Get a quest (35)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'GONDOLIN_LIBRARY',
  name = "Library",
  display = '+',
  color = colors.C_U,
  image = 'store/gondolin_library.png',
  owner = resolvers.store_owner{ 'PENGOLODH' },
  -- actions:
  --   Research item (14)
  --   Town history (15)
  --   Race legends (16)
  --   Purchase an item (2)
  store = {
    prob_filters = {
      { defined='STAFF_IDENTIFY', id='full' },
    },
    max_stock = 2,
  },
}

newEntity {
  define_as = 'THE_WHITE_TREE',
  name = "The White Tree",
  display = '+',
  color = colors.C_w,
  image = 'store/the_white_tree.png',
  owner = resolvers.store_owner{ 'AERANDIR' },
  -- actions:
  --   Purchase an item (2)
  --   Steal an item (4)
  --   Rest for the night (5)
  --   Buy food and drink (6)
  --   Listen for rumours (7)
  store = {
    prob_filters = {
      { defined='RATION_OF_FOOD', id='full' },
      { defined='HARD_BISCUIT', id='full' },
      { defined='STRIP_OF_VENISON', id='full' },
      { defined='PINT_OF_FINE_WINE', id='full' },
      { defined='PINT_OF_FINE_ALE', id='full' },
    },
    max_stock = 8,
  },
}

newEntity {
  define_as = 'CRAFTSMASTER',
  name = "Craftsmaster",
  display = '+',
  color = colors.C_s,
  image = 'store/craftsmaster.png',
  owner = resolvers.store_owner{ 'CELEBRIMBOR' },
  -- actions:
  --   Enchant weapon (24)
  --   Enchant armour (25)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'EARTH_DOME_NATURE_',
  name = "Earth-Dome (Nature)",
  display = '+',
  color = colors.C_U,
  image = 'store/earth_dome_nature_.png',
  owner = resolvers.store_owner{ 'LOMELOSSE' },
  -- actions:
  --   Herbal Healing (39)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'MINSTRELS_HAVEN',
  name = "Minstrels Haven",
  display = '+',
  color = colors.C_U,
  image = 'store/minstrels_haven.png',
  owner = resolvers.store_owner{ 'ARLINDEL' },
  -- actions:
  --   Song of Lore (40)
  --   Distribute earnings (41)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'STAR_DOME',
  name = "Star-Dome",
  display = '+',
  color = colors.C_U,
  image = 'store/star_dome.png',
  owner = resolvers.store_owner{ 'SULRAEN' },
  -- actions:
  --   Identify possessions (46)
  --   Recharge item (47)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'VALARIN_TEMPLE',
  name = "Valarin Temple",
  display = '+',
  color = colors.C_U,
  image = 'store/valarin_temple.png',
  owner = resolvers.store_owner{ 'FIRIEL' },
  -- actions:
  --   Healing prayer (28)
  --   Restoration (48)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'SEA_DOME',
  name = "Sea-Dome",
  display = '+',
  color = colors.C_U,
  image = 'store/sea_dome.png',
  owner = resolvers.store_owner{ 'EARENDUR' },
  -- actions:
  --   Morph restoration (49)
  --   Get a quest (35)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'THE_GOLDEN_FLOWER',
  name = "The Golden Flower",
  display = '+',
  color = colors.C_U,
  image = 'store/the_golden_flower.png',
  owner = resolvers.store_owner{ 'GLORFINDEL' },
  -- actions:
  --   Enchant arrows (50)
  --   Enchant bow (51)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'THE_FOUNTAIN',
  name = "The Fountain",
  display = '+',
  color = colors.C_U,
  image = 'store/the_fountain.png',
  owner = resolvers.store_owner{ 'ECTHELION' },
  -- actions:
  --   Enchant armour (52)
  --   See Healers (53)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'AXE_SMITH',
  name = "Axe Smith",
  display = '3',
  color = colors.C_w,
  image = 'store/axe_smith.png',
  owner = resolvers.store_owner{ 'ARNOLD', 'ARNDAL', 'EDDIE', 'OGLIGN' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ MEDIUM_LEVEL RANDOM ]
  store = {
    prob_filters = {
      { type='weapon', subtype='axe', id='full' },
    },
    max_stock = 12,
    dungeon_town = true,
    level_adjust = { 25, 49 },
  },
}

newEntity {
  define_as = 'HAFTED_SMITH',
  name = "Hafted Smith",
  display = '3',
  color = colors.C_w,
  image = 'store/hafted_smith.png',
  owner = resolvers.store_owner{ 'ARNOLD', 'ARNDAL', 'EDDIE', 'OGLIGN' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ MEDIUM_LEVEL RANDOM ]
  store = {
    prob_filters = {
      { type='weapon', subtype='hafted', id='full' },
    },
    max_stock = 12,
    dungeon_town = true,
    level_adjust = { 25, 49 },
  },
}

newEntity {
  define_as = 'POLEARM_SMITH',
  name = "Polearm Smith",
  display = '3',
  color = colors.C_w,
  image = 'store/polearm_smith.png',
  owner = resolvers.store_owner{ 'ARNOLD', 'ARNDAL', 'EDDIE', 'OGLIGN' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ MEDIUM_LEVEL RANDOM ]
  store = {
    prob_filters = {
      { type='weapon', subtype='polearm', id='full' },
    },
    max_stock = 12,
    dungeon_town = true,
    level_adjust = { 25, 49 },
  },
}

newEntity {
  define_as = 'SWORD_SMITH',
  name = "Sword Smith",
  display = '3',
  color = colors.C_w,
  image = 'store/sword_smith.png',
  owner = resolvers.store_owner{ 'ARNOLD', 'ARNDAL', 'EDDIE', 'OGLIGN' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ MEDIUM_LEVEL RANDOM ]
  store = {
    prob_filters = {
      { type='weapon', subtype='sword', id='full' },
    },
    max_stock = 12,
    dungeon_town = true,
    level_adjust = { 25, 49 },
  },
}

newEntity {
  define_as = 'RARE_JEWELRY_SHOP',
  name = "Rare Jewelry Shop",
  display = '6',
  color = colors.C_v,
  image = 'store/rare_jewelry_shop.png',
  owner = resolvers.store_owner{ 'ARIEL', 'BUGGERBY', 'INGLORIAN', 'LUTHIEN' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ DEEP_LEVEL DEPEND_LEVEL FORCE_LEVEL RANDOM VERY_RARE ]
  store = {
    prob_filters = {
      { type='jewelry', subtype='amulet', id='full' },
      { type='jewelry', subtype='ring', id='full' },
    },
    max_stock = 10,
    use_dungeon_level = true,
    min_obj_level = true,
    dungeon_town = true,
    dungeon_town_prob = 20,
    level_adjust = { 45, 89 },
  },
}

newEntity {
  define_as = 'JEWELRY_SHOP',
  name = "Jewelry Shop",
  display = '6',
  color = colors.C_y,
  image = 'store/jewelry_shop.png',
  owner = resolvers.store_owner{ 'ARIEL', 'BUGGERBY', 'INGLORIAN', 'LUTHIEN' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ DEPEND_LEVEL FORCE_LEVEL MEDIUM_LEVEL RANDOM RARE ]
  store = {
    prob_filters = {
      { type='jewelry', subtype='amulet', id='full' },
      { type='jewelry', subtype='ring', id='full' },
    },
    max_stock = 20,
    use_dungeon_level = true,
    min_obj_level = true,
    dungeon_town = true,
    dungeon_town_prob = 30,
    level_adjust = { 25, 49 },
  },
}

newEntity {
  define_as = 'FOOTWEAR_SHOP',
  name = "Footwear Shop",
  display = '2',
  color = colors.C_r,
  image = 'store/footwear_shop.png',
  owner = resolvers.store_owner{ 'KON_DAR', 'DARG_LOW', 'DECADO', 'WIELAND' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ COMMON MEDIUM_LEVEL RANDOM ]
  store = {
    prob_filters = {
      { type='armor', subtype='footwear', id='full' },
    },
    max_stock = 12,
    dungeon_town_prob = 80,
    dungeon_town = true,
    level_adjust = { 25, 49 },
  },
}

newEntity {
  define_as = 'RARE_FOOTWEAR_SHOP',
  name = "Rare Footwear Shop",
  display = '2',
  color = colors.C_r,
  image = 'store/rare_footwear_shop.png',
  owner = resolvers.store_owner{ 'KON_DAR', 'DARG_LOW', 'DECADO', 'WIELAND' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ DEEP_LEVEL MEDIUM_LEVEL RANDOM VERY_RARE ]
  store = {
    prob_filters = {
      { type='armor', subtype='footwear', id='full' },
    },
    max_stock = 8,
    dungeon_town = true,
    dungeon_town_prob = 20,
    level_adjust = { 70, 138 },
  },
}

newEntity {
  define_as = 'DGN_TOWN_LIBRARY',
  name = "Library",
  display = '9',
  color = colors.C_y,
  image = 'store/dgn_town_library.png',
  owner = resolvers.store_owner{ 'KON_DAR', 'DARG_LOW', 'DECADO', 'WIELAND' },
  -- actions:
  --   Identify possessions (27)
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ DEPEND_LEVEL MEDIUM_LEVEL RANDOM ]
  store = {
    prob_filters = {
      { type='magic', subtype='spellbook', id='full' },
      { properties={ 'is_demongear' }, id='full' },
    },
    max_stock = 24,
    use_dungeon_level = true,
    dungeon_town = true,
    level_adjust = { 25, 49 },
  },
}

newEntity {
  define_as = 'FORBIDDEN_LIBRARY',
  name = "Forbidden Library",
  display = '9',
  color = colors.C_v,
  image = 'store/forbidden_library.png',
  owner = resolvers.store_owner{ 'KON_DAR', 'DARG_LOW', 'DECADO', 'WIELAND' },
  -- actions:
  --   Identify possessions (27)
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ DEEP_LEVEL DEPEND_LEVEL RANDOM RARE ]
  store = {
    prob_filters = {
      { type='magic', subtype='spellbook', id='full' },
      { properties={ 'is_demongear' }, id='full' },
    },
    max_stock = 12,
    use_dungeon_level = true,
    dungeon_town = true,
    dungeon_town_prob = 30,
    level_adjust = { 45, 89 },
  },
}

newEntity {
  define_as = 'EXPENSIVE_BLACK_MARKET',
  name = "Expensive Black Market",
  display = '7',
  color = colors.C_v,
  image = 'store/expensive_black_market.png',
  owner = resolvers.store_owner{ 'GARY', 'HISTOR', 'ZORAK', 'TIPO' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ ALL_ITEM DEEP_LEVEL DEPEND_LEVEL MEDIUM_LEVEL RANDOM ]
  store = {
    prob_filters = {
      { id='full' },
    },
    max_stock = 12,
    black_market = true,
    use_dungeon_level = true,
    dungeon_town = true,
    level_adjust = { 70, 138 },
  },
}

newEntity {
  define_as = 'COMMON_SHOP',
  name = "Common Shop",
  display = '1',
  color = colors.C_U,
  image = 'store/common_shop.png',
  owner = resolvers.store_owner{ 'BILBO', 'RAISTLIN', 'SULTAN', 'LYAR_EL' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ RANDOM ]
  store = {
    prob_filters = {
      { defined='BRASS_LANTERN', id='full', prob=95 },
      { defined='FLASK_OF_OIL', id='full' },
      { defined='RATION_OF_FOOD', id='full' },
      { defined='SHOVEL', id='full', prob=60 },
      { defined='PICK', id='full', prob=50 },
      { defined='IRON_SPIKE', id='full' },
      { defined='IRON_SHOT', id='full', prob=70 },
      { defined='BOLT', id='full', prob=70 },
      { defined='ARROW', id='full', prob=70 },
      { defined='CLOAK', id='full', prob=98 },
      { defined='FUR_CLOAK', id='full', prob=46 },
      { defined='SCRL_WORD_OF_RECALL', id='full' },
      { defined='POT_CURE_CRITICAL_WOUNDS', id='full' },
    },
    max_stock = 12,
    dungeon_town = true,
  },
}

newEntity {
  define_as = 'DRAGON_HUNTER',
  name = "Dragon Hunter",
  display = '2',
  color = colors.C_v,
  image = 'store/dragon_hunter.png',
  owner = resolvers.store_owner{ 'KON_DAR', 'DARG_LOW', 'DECADO', 'WIELAND' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ DEEP_LEVEL DEPEND_LEVEL RANDOM VERY_RARE ]
  store = {
    prob_filters = {
      { properties={ 'is_dragon_armor' }, id='full' },
    },
    max_stock = 12,
    use_dungeon_level = true,
    dungeon_town = true,
    dungeon_town_prob = 20,
    level_adjust = { 45, 89 },
  },
}

newEntity {
  define_as = 'SPEED_RING_MARKET',
  name = "Speed Ring Market",
  display = '6',
  color = colors.C_G,
  image = 'store/speed_ring_market.png',
  owner = resolvers.store_owner{ 'ARIEL', 'BUGGERBY', 'INGLORIAN', 'LUTHIEN' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ DEPEND_LEVEL RANDOM SHALLOW_LEVEL VERY_RARE ]
  store = {
    prob_filters = {
      { defined='RING_SPEED', id='full' },
    },
    max_stock = 6,
    use_dungeon_level = true,
    dungeon_town = true,
    dungeon_town_prob = 20,
    level_adjust = { 5, 9 },
  },
}

newEntity {
  define_as = 'SCRIBE',
  name = "Scribe",
  display = '5',
  color = colors.C_B,
  image = 'store/scribe.png',
  owner = resolvers.store_owner{ 'KON_DAR', 'DARG_LOW', 'DECADO', 'WIELAND' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ DEPEND_LEVEL MEDIUM_LEVEL RANDOM ]
  store = {
    prob_filters = {
      { type='utility', subtype='scroll', id='full' },
    },
    max_stock = 12,
    use_dungeon_level = true,
    dungeon_town = true,
    level_adjust = { 25, 49 },
  },
}

newEntity {
  define_as = 'POTION_STORE',
  name = "Potion Store",
  display = '5',
  color = colors.C_B,
  image = 'store/potion_store.png',
  owner = resolvers.store_owner{ 'KON_DAR', 'DARG_LOW', 'DECADO', 'WIELAND' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ DEPEND_LEVEL MEDIUM_LEVEL RANDOM ]
  store = {
    prob_filters = {
      { type='utility', subtype='potion', id='full' },
      { type='utility', subtype='potion', id='full' },
    },
    max_stock = 12,
    use_dungeon_level = true,
    dungeon_town = true,
    level_adjust = { 25, 49 },
  },
}

newEntity {
  define_as = 'RECALLER',
  name = "Recaller",
  display = '+',
  color = colors.C_b,
  image = 'store/recaller.png',
  owner = resolvers.store_owner{ 'KON_DAR', 'DARG_LOW', 'DECADO', 'WIELAND' },
  -- actions:
  --   Recall to dungeon (33)
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  -- flags = [ COMMON RANDOM ]
  store = {
    prob_filters = {
      { defined='SCRL_WORD_OF_RECALL', id='full' },
    },
    max_stock = 2,
    dungeon_town_prob = 80,
    dungeon_town = true,
  },
}

newEntity {
  define_as = 'MASTER_ARCHER',
  name = "Master Archer",
  display = '3',
  color = colors.C_g,
  image = 'store/master_archer.png',
  owner = resolvers.store_owner{ 'ARNOLD', 'ARNDAL', 'EDDIE', 'OGLIGN' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ DEPEND_LEVEL MEDIUM_LEVEL RANDOM RARE ]
  store = {
    prob_filters = {
      { defined='SLING', id='full' },
      { defined='SHORT_BOW', id='full' },
      { defined='LONG_BOW', id='full', prob=20 },
      { defined='LIGHT_CROSSBOW', id='full' },
      { defined='HEAVY_CROSSBOW', id='full', prob=20 },
      { type='ammo', subtype='shots', id='full', prob=50 },
      { type='ammo', subtype='arrows', id='full', prob=50 },
      { type='ammo', subtype='bolts', id='full', prob=50 },
    },
    max_stock = 24,
    use_dungeon_level = true,
    dungeon_town = true,
    dungeon_town_prob = 30,
    level_adjust = { 25, 49 },
  },
}

newEntity {
  define_as = 'MERCHANTS_GUILD',
  name = "Merchants Guild",
  display = '+',
  color = colors.C_g,
  image = 'store/merchants_guild.png',
  owner = resolvers.store_owner{ 'KANRIS' },
  -- actions:
  --   Request an item (56)
  --   Ask for loan (57)
  --   Pay back loan (58)
  store = {
    max_stock = 0,
  },
}

newEntity {
  define_as = 'THE_MATHOM_HOUSE',
  name = "The Mathom-house",
  display = '+',
  color = colors.C_g,
  image = 'store/the_mathom_house.png',
  owner = resolvers.store_owner{ 'BILBO' },
  -- actions:
  --   Donate an item (59)
  --   Examine an item (3)
  -- flags = [ MUSEUM ]
  store = {
    max_stock = 255,
    mathom_house = true,
  },
}

newEntity {
  define_as = 'THE_PRANCING_PONY',
  name = "The Prancing Pony",
  display = '+',
  color = colors.C_w,
  image = 'store/the_prancing_pony.png',
  owner = resolvers.store_owner{ 'BARLIMAN' },
  -- actions:
  --   Purchase an item (2)
  --   Steal an item (4)
  --   Rest for the night (5)
  --   Buy food and drink (6)
  --   Listen for rumours (7)
  store = {
    prob_filters = {
      { defined='RATION_OF_FOOD', id='full' },
      { defined='HARD_BISCUIT', id='full' },
      { defined='STRIP_OF_VENISON', id='full' },
      { defined='PINT_OF_FINE_WINE', id='full' },
      { defined='PINT_OF_FINE_ALE', id='full' },
    },
    max_stock = 8,
  },
}

newEntity {
  define_as = 'MINING_SUPPLY_STORE',
  name = "Mining Supply store",
  display = '+',
  color = colors.C_s,
  image = 'store/mining_supply_store.png',
  owner = resolvers.store_owner{ 'WIELAND', 'OGLIGN', 'LUDWIG', 'ZORAK' },
  -- actions:
  --   Sell an item (1)
  --   Purchase an item (2)
  --   Examine an item (3)
  --   Steal an item (4)
  -- flags = [ MEDIUM_LEVEL ]
  store = {
    prob_filters = {
      { type='tool', subtype='digger', id='full' },
      { defined='WOODEN_TORCH', id='full' },
      { defined='BRASS_LANTERN', id='full', prob=95 },
      { defined='FLASK_OF_OIL', id='full', prob=95 },
      { defined='DWARVEN_LANTERN', id='full', prob=75 },
      { defined='FEANORIAN_LAMP', id='full', prob=60 },
      { defined='WAND_TIDAL_WAVE', id='full', prob=60 },
      { defined='POT_DETONATIONS', id='full', prob=70 },
    },
    max_stock = 24,
    actor_filter = function(o)
      return require('mod.class.Store'):actor_filter_hack('MINING_SUPPLY_STORE', o)
    end,
    level_adjust = { 25, 49 },
  },
}

newEntity {
  define_as = 'MINAS_ANOR_LIBRARY',
  name = "Library",
  display = '+',
  color = colors.C_U,
  image = 'store/library.png',
  owner = resolvers.store_owner{ 'MIRIMBAR' },
  -- actions:
  --   Get a quest (61)
  --   Research item (14)
  --   Town history (15)
  --   Race legends (16)
  --   Purchase an item (2)
  store = {
    prob_filters = {
      { defined='STAFF_IDENTIFY', id='full' },
    },
    max_stock = 2,
  },
}
