-- $Id: magic.lua 2864 2017-05-08 01:36:27Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_skill' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Player skills generated from s_info.txt.

newSkill {
  name = 'Magic',
  short_name = 'MAGIC',
  desc = [[General ability to do magic, also affects mana reserves and magic device ability.  Helps pseudo-id of magic objects.]],
  rate = 1000,
  depth = 0,
  achievement = 'MAGIC_50',
  talents = {
    [ActorTalents.T_COPY_SPELL] = true,
    ActorTalents.T_COPY_SPELL,
  },
  random_gain = 100,
}

newSkill {
  name = 'Magic-Device',
  short_name = 'MAGIC_DEVICE',
  desc = [[Eases the use of magical devices, such as wands, staves and rods.  It also helps pseudo-id of magic objects.]],
  rate = 1000,
  depth = 1,
  achievement = 'MAGIC_DEVICE_50',
  parent = 'MAGIC',
  ripple_to = {
    MAGIC = 7,
  },
  random_gain = 100,
  -- BEGIN VERBATIM
  player_calc = function(def, p, init)
    if init then
      p.skill_device = 0
      return
    end
    local sk20 = p:getSkillLevel('MAGIC_DEVICE', 20)
    local sk150 = p:getSkillLevel('MAGIC_DEVICE', 150)
    p.skill_device = p.skill_device + sk20 + sk150
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Spell-power',
  short_name = 'SPELL_POWER',
  desc = [[Ability to increase the power of spells.]],
  rate = 1000,
  depth = 1,
  achievement = 'SPELL_POWER_50',
  parent = 'MAGIC',
  ripple_to = {
    MAGIC = 20,
  },
}

newSkill {
  name = 'Sorcery',
  short_name = 'SORCERY',
  desc = [[Ability to use all the magic schools as if their skill was sorcery.  But the price to channel that much magic is your health.]],
  rate = 1000,
  depth = 1,
  achievement = 'SORCERY_50',
  parent = 'MAGIC',
  ripple_to = {
    MAGIC = 20,
  },
  -- BEGIN VERBATIM
  no_gloves = true,
  player_calc = function(def, p, init)
    if not init then
      local d = p:getSkillLevel('SORCERY', 100)
      local d10 = math.floor(d/10)
      for _, o in ipairs(p:getInven('MAIN_HAND') or {}) do
	local dd = o.define_as == 'MAGE_STAFF' and d10 or d
	p:adjustDis('to_h', -dd, true, 'Sorcery penalty')
	p:adjustDis('to_d', -dd, true)
      end
    end
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Mana',
  short_name = 'MANA',
  desc = [[Ability to learn and use spells from the Mana school.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 1,
  achievement = 'MANA_50',
  parent = 'MAGIC',
  ripple_to = {
    MAGIC = 10,
  },
  sorcery_access = true,
  use_spell_power = true,
  prayer_access = {
    ['Eru Ilúvatar'] = { 1, 2 },
  },
  -- BEGIN VERBATIM
  no_gloves = true,
  convey_at_level = {
    -- Not sure how this works...
    [35] = { mana_mult=true },
  },
  -- END VERBATIM
}

newSkill {
  name = 'Geomancy',
  short_name = 'GEOMANCY',
  desc = [[Ability to understand the raw elemental forces of nature and use them to your advantage.  Most spells need Fire/Water/Earth/Air skills.]],
  rate = 1000,
  depth = 1,
  achievement = 'GEOMANCY_50',
  parent = 'MAGIC',
  talents = {
    [ActorTalents.T_GEO_CALL_ELEM] = 1,
    [ActorTalents.T_GEO_CHANNEL_ELEM] = 3,
    [ActorTalents.T_GEO_VAPORIZE] = { level=4, skills={AIR=4} },
    [ActorTalents.T_GEO_GEOLYSIS] = { level=7, skills={EARTH=7} },
    [ActorTalents.T_GEO_DRIP_TREAD] = { level=10, skills={WATER=10} },
    [ActorTalents.T_GEO_GROW_BARRIER] = { level=12, skills={EARTH=12} },
    [ActorTalents.T_GEO_ELEM_WAVE] = 15,
    [ActorTalents.T_GEO_ELEM_MINION] = 20,
    ActorTalents.T_GEO_CALL_ELEM, ActorTalents.T_GEO_CHANNEL_ELEM, ActorTalents.T_GEO_VAPORIZE, ActorTalents.T_GEO_GEOLYSIS, ActorTalents.T_GEO_DRIP_TREAD, ActorTalents.T_GEO_GROW_BARRIER, ActorTalents.T_GEO_ELEM_WAVE, ActorTalents.T_GEO_ELEM_MINION,
  },
  ripple_to = {
    FIRE = 45,
    EARTH = 45,
    AIR = 45,
    WATER = 45,
  },
  use_spell_power = true,
}

newSkill {
  name = 'Fire',
  short_name = 'FIRE',
  desc = [[Ability to learn and use spells from the Fire school.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 2,
  achievement = 'FIRE_50',
  parent = 'GEOMANCY',
  ripple_to = {
    MAGIC = 10,
  },
  sorcery_access = true,
  use_spell_power = true,
  -- BEGIN VERBATIM
  no_gloves = true,
  -- END VERBATIM
}

newSkill {
  name = 'Water',
  short_name = 'WATER',
  desc = [[Ability to learn and use spells from the Water school.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 2,
  achievement = 'WATER_50',
  parent = 'GEOMANCY',
  ripple_to = {
    MAGIC = 10,
  },
  sorcery_access = true,
  use_spell_power = true,
  prayer_access = {
    ['Yavanna Kementári'] = { 1, 2 },
  },
  -- BEGIN VERBATIM
  no_gloves = true,
  convey_at_level = {
    [30] = { convey_flags = { WATER_BREATH=true } },
  },
  -- END VERBATIM
}

newSkill {
  name = 'Air',
  short_name = 'AIR',
  desc = [[Ability to learn and use spells from the Air school.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 2,
  achievement = 'AIR_50',
  parent = 'GEOMANCY',
  ripple_to = {
    MAGIC = 10,
  },
  sorcery_access = true,
  use_spell_power = true,
  prayer_access = {
    ['Manwë Súlimo'] = { 2, 3 },
  },
  -- BEGIN VERBATIM
  no_gloves = true,
  convey_at_level = {
    [50] = { convey_flags = { MAGIC_BREATH=true, WATER_BREATH=true } },
  },
  -- END VERBATIM
}

newSkill {
  name = 'Earth',
  short_name = 'EARTH',
  desc = [[Ability to learn and use spells from the Earth school.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 2,
  achievement = 'EARTH_50',
  parent = 'GEOMANCY',
  ripple_to = {
    MAGIC = 10,
  },
  sorcery_access = true,
  use_spell_power = true,
  prayer_access = {
    ['Tulkas'] = { 4, 5 },
    ['Yavanna Kementári'] = { 1, 2 },
  },
  -- BEGIN VERBATIM
  no_gloves = true,
  -- END VERBATIM
}

newSkill {
  name = 'Meta',
  short_name = 'META',
  desc = [[Ability to learn and use spells from the Meta school.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 1,
  achievement = 'META_50',
  parent = 'MAGIC',
  ripple_to = {
    MAGIC = 10,
  },
  sorcery_access = true,
  use_spell_power = true,
  prayer_access = {
    ['Manwë Súlimo'] = { 1, 3 },
  },
}

newSkill {
  name = 'Conveyance',
  short_name = 'CONVEYANCE',
  desc = [[Ability to learn and use spells from the Conveyance school.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 1,
  achievement = 'CONVEYANCE_50',
  parent = 'MAGIC',
  ripple_to = {
    MAGIC = 10,
  },
  sorcery_access = true,
  use_spell_power = true,
  prayer_access = {
    ['Manwë Súlimo'] = { 1, 2 },
  },
  random_gain = 100,
}

newSkill {
  name = 'Divination',
  short_name = 'DIVINATION',
  desc = [[Ability to learn and use spells from the Divination school.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 1,
  achievement = 'DIVINATION_50',
  parent = 'MAGIC',
  ripple_to = {
    MAGIC = 10,
  },
  sorcery_access = true,
  use_spell_power = true,
  prayer_access = {
    ['Eru Ilúvatar'] = { 2, 3 },
  },
  random_gain = 100,
}

newSkill {
  name = 'Temporal',
  short_name = 'TEMPORAL',
  desc = [[Ability to learn and use spells from the Temporal school.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 1,
  achievement = 'TEMPORAL_50',
  parent = 'MAGIC',
  ripple_to = {
    MAGIC = 10,
  },
  sorcery_access = true,
  use_spell_power = true,
  prayer_access = {
    ['Yavanna Kementári'] = { 1, 6 },
  },
}

newSkill {
  name = 'Mind',
  short_name = 'MIND',
  desc = [[Ability to learn and use spells from the Mind school.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 1,
  achievement = 'MIND_50',
  parent = 'MAGIC',
  ripple_to = {
    MAGIC = 10,
  },
  sorcery_access = true,
  use_spell_power = true,
  prayer_access = {
    ['Eru Ilúvatar'] = { 1, 3 },
    ['Melkor Bauglir'] = { 1, 3 },
  },
}

newSkill {
  name = 'Nature',
  short_name = 'NATURE',
  desc = [[Ability to learn and use spells from the Nature school.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 1,
  achievement = 'NATURE_50',
  parent = 'MAGIC',
  ripple_to = {
    MAGIC = 10,
  },
  sorcery_access = true,
  use_spell_power = true,
  prayer_access = {
    ['Yavanna Kementári'] = { 1, 2 },
  },
}

newSkill {
  name = 'Udun',
  short_name = 'UDUN',
  desc = [[Ability to learn and use spells from the Udun school.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 1,
  achievement = 'UDUN_50',
  parent = 'MAGIC',
  ripple_to = {
    MAGIC = 10,
  },
  -- BEGIN VERBATIM
  spell_bonus = function(who)
    return math.floor(((who.level or 0) * 2)/3)
  end,
  visible = function()
    local p = game.player
    return p and p.descriptors and p.descriptors.god and p.descriptors.god == 'Melkor Bauglir'
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Demonology',
  short_name = 'DEMONOLOGY',
  desc = [[Ability to use incantations from the Demonblades.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 1,
  achievement = 'DEMONOLOGY_50',
  parent = 'MAGIC',
  ripple_to = {
    MAGIC = 10,
  },
  -- BEGIN VERBATIM
  convey_at_level = {
    [21] = { convey_resist_dam = { [DamageType.CONFUSION]=true } },
    [31] = { convey_resist_dam = { [DamageType.FEAR]=true } },
  },
  -- END VERBATIM
}

newSkill {
  name = 'Necromancy',
  short_name = 'NECROMANCY',
  desc = [[Ability to harness the powers of the dead.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 1,
  achievement = 'NECROMANCY_50',
  parent = 'MAGIC',
  talents = {
    [ActorTalents.T_HORRIFY] = 1,
    [ActorTalents.T_RAISE_DEAD] = 5,
    [ActorTalents.T_NECRO_TEETH] = 12,
    [ActorTalents.T_ABSORB_SOUL] = 20,
    [ActorTalents.T_VAMPIRISM] = 30,
    [ActorTalents.T_NECRO_DEATH] = 35,
    ActorTalents.T_HORRIFY, ActorTalents.T_RAISE_DEAD, ActorTalents.T_NECRO_TEETH, ActorTalents.T_ABSORB_SOUL, ActorTalents.T_VAMPIRISM, ActorTalents.T_NECRO_DEATH,
  },
  ripple_to = {
    MAGIC = 4,
  },
  random_gain = 60,
}

newSkill {
  name = 'Runecraft',
  short_name = 'RUNECRAFT',
  desc = [[Ability to combine magic runes to create your own spells.  Runespells use the dexterity stat.]],
  rate = 1000,
  depth = 1,
  achievement = 'RUNECRAFT_50',
  parent = 'MAGIC',
  talents = {
    [ActorTalents.T_RUNECRAFT] = true,
    ActorTalents.T_RUNECRAFT,
  },
  ripple_to = {
    MAGIC = 12,
  },
}

newSkill {
  name = 'Thaumaturgy',
  short_name = 'THAUMATURGY',
  desc = [[Ability to gain and cast innate spells.  Spells use the intelligence stat.]],
  rate = 1000,
  depth = 1,
  achievement = 'THAUMATURGY_50',
  parent = 'MAGIC',
  ripple_to = {
    MAGIC = 6,
  },
  random_gain = 100,
  -- BEGIN VERBATIM
  no_gloves = true,
  player_calc = function(def, p, init)
    local n = p:getSkillLevel('THAUMATURGY', 100)
    if init then
      if n > 0 then
	p.thaumaturgy_spells = p.thaumaturgy_spells or {}
      end
    elseif n > 0 then
      local n_gain = n - #p.thaumaturgy_spells
      while #p.thaumaturgy_spells < n do
	local lvl = math.floor((#p.thaumaturgy_spells+2)/2)
	local spell = spell.thaumaturgy.create(lvl)
	table.insert(p.thaumaturgy_spells, spell)
      end
      if n_gain > 0 then
	local stuff, it = 'one new thaumaturgy spell', 'it'
	if n_gain > 1 then
	  stuff, it = ('%d new thaumaturgy spells'):format(n_gain), 'them'
	end
	local key = util.getFormattedKeyBinds('USE_THAUMATURGY', "' or '")
	game.log("#00FFFF#%s has learned %s.  Press '%s' to view %s.#LAST#", p.name, stuff, key, it)
      end
    end
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Alchemy',
  short_name = 'ALCHEMY',
  desc = [[Ability to use essences to modify/create magic items.]],
  rate = 1000,
  depth = 1,
  achievement = 'ALCHEMY_50',
  parent = 'MAGIC',
  talents = {
    [ActorTalents.T_ALCH_FORGE] = 1,
    [ActorTalents.T_ALCH_EGO] = 1,
    [ActorTalents.T_ALCH_RECHARGE] = 1,
    [ActorTalents.T_ALCH_EXTRACT] = 1,
    [ActorTalents.T_ALCH_DETACH] = 1,
    ActorTalents.T_ALCH_FORGE, ActorTalents.T_ALCH_EGO, ActorTalents.T_ALCH_RECHARGE, ActorTalents.T_ALCH_EXTRACT, ActorTalents.T_ALCH_DETACH,
  },
  -- BEGIN VERBATIM
  on_increase = function(def, p, oldv, newv)
    print(('[GRMBL] %d -> %d'):format(oldv, newv))
    local function try_learn(def)
      local l_sk = def.learn_at_skill
      if l_sk then l_sk = l_sk * p.skill_step end
      print(('[GRMBL]   %s -> %s'):format(def.name, tostring(l_sk)))
      if l_sk and oldv < l_sk and newv >= l_sk then
	local cond = def.learn_at_skill_if
	if not cond or cond(def, p, oldv, newv) then
	  print(('[GRMBL]     learning %s'):format(def.name))
	  p:learnAlchemyRecipe(def, true)
	end
      end
    end
    for _, def in ipairs(p.alchemy_ego_recipe_def) do try_learn(def) end
    for _, def in ipairs(p.alchemy_obj_recipe_def) do try_learn(def) end
    for _, def in ipairs(p.alchemy_flag_recipe_def) do try_learn(def) end
  end,
  -- END VERBATIM
}
