-- $Id: air.lua 3397 2018-06-11 00:16:08Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_air.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Air spells',
  type = 'spell/air',
  description = 'Spells from the Air school',
}

newTalent {
  name = [[Noxious Cloud]],
  short_name = 'NOXIOUS_CLOUD',
  display_entity = Entity.new { image='talents/noxious_cloud.png' },
  type = 'spell/air',
  mode = 'activated',
  is_spell = true,
  skill = 'AIR',
  skill_level = 3,
  mana = spell.mana_cost,
  min_mana = 3,
  max_mana = 30,
  base_fail = 20,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/wand',
    charge = { 5, 7 },
    rarity = 15,
    base_level = { 1, 15 },
    max_level = { 25, 50 },
  },
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local dt = lev >= 30 and DamageType.UNBREATH or DamageType.POISON
    local dam = 7 + spell.get_spell_level(self, t, 150)
    local dur = 5 + spell.get_spell_level(self, t, 40)
    local ret = spell.cloud_spell(self, t, dt, dam, 3, dur)
    if ret then spell.stick.id = true end
    return ret
  end,
  info = function(self, t)
    local dam = 7 + spell.get_spell_level(self, t, 150)
    local dur = 5 + spell.get_spell_level(self, t, 40)
    local pf = util.colorize_damtype(DamageType.POISON)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Creates a radius-3 cloud of poison.  The cloud will persist for %d turns, doing %d %s damage per turn to all monsters passing by.  At spell level 30 it turns into a thick gas attacking all living beings.  Damage and duration will increase%s]]
    return ret:format(dur, dam, pf, sfx)
  end,
}

newTalent {
  name = [[Poison Blood]],
  short_name = 'POISON_BLOOD',
  display_entity = Entity.new { image='talents/poison_blood.png' },
  type = 'spell/air',
  mode = 'activated',
  is_spell = true,
  skill = 'AIR',
  skill_level = 12,
  mana = spell.mana_cost,
  min_mana = 10,
  max_mana = 20,
  base_fail = 30,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 1, 35 },
  stick = {
    type = 'utility/wand',
    charge = { 10, 15 },
    rarity = 45,
    base_level = { 1, 25 },
    max_level = { 35, 50 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local base_dur = 25 + spell.get_spell_level(self, t, 25)
    local p = { merge = 'no_replace' }
    if not self:hasEffect(self.EFF_RES_POISON) then spell.stick.id = true end
    self:setEffect(self.EFF_RES_POISON, base_dur + rng.range(1, 30), p)
    if lev >= 15 then
      if not self:hasEffect(self.EFF_POISON_HANDS) then spell.stick.id = true end
      self:setEffect(self.EFF_POISON_HANDS, base_dur + rng.range(1, 30), p)
    end
    return true
  end,
  info = function(self, t)
    local base_dur = 25 + spell.get_spell_level(self, t, 25)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Grants temporary resist poison for %d+1d30 turns.  At level 15, it additionally poisons your hands for %d+1d30 turns, making your weapons act like they are poison-branded.  Duration will increase%s]]
    return ret:format(base_dur, base_dur, sfx)
  end,
}

newTalent {
  name = [[Invisibility]],
  short_name = 'INVISIBILITY',
  display_entity = Entity.new { image='talents/invisibility.png' },
  type = 'spell/air',
  mode = 'activated',
  is_spell = true,
  skill = 'AIR',
  skill_level = 16,
  mana = spell.mana_cost,
  min_mana = 10,
  max_mana = 20,
  base_fail = 50,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 1, 30 },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local base_dur = 15 + spell.get_spell_level(self, t, 50)
    local pow = 20 + spell.get_spell_level(self, t, 50)
    local p = { power=pow, merge='no_replace' }
    self:setEffect(self.EFF_INVISIBLE, base_dur + rng.range(1, 20), p)
    return true
  end,
  info = function(self, t)
    local base_dur = 15 + spell.get_spell_level(self, t, 50)
    local pow = 20 + spell.get_spell_level(self, t, 50)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Confers invisibility (power %d) for %d+1d20 turns.  Duration will increase%s

#{bold}#NOTE:#{normal}#  The spell will have no effect if you are already temporariliy invisible.]]
    return ret:format(pow, base_dur, sfx)
  end,
}

newTalent {
  name = [[Sterilize]],
  short_name = 'STERILIZE',
  display_entity = Entity.new { image='talents/sterilize.png' },
  type = 'spell/air',
  mode = 'activated',
  is_spell = true,
  skill = 'AIR',
  skill_level = 20,
  mana = spell.mana_cost,
  min_mana = 10,
  max_mana = 100,
  base_fail = 50,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/staff',
    charge = { 7, 5 },
    rarity = 20,
    base_level = { 1, 10 },
    max_level = { 20, 50 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local base_dur = 20 + spell.get_spell_level(self, t, 70)
    self:setEffect(self.EFF_STERILIZE, base_dur + rng.range(1, 30), {})
    spell.stick.id = true
    return true
  end,
  info = function(self, t)
    local base_dur = 20 + spell.get_spell_level(self, t, 70)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Prevents explosively breeding monsters from reproducing for %d+1d30 turns.  Duration will increase%s]]
    return ret:format(base_dur, sfx)
  end,
}

newTalent {
  name = [[Wings of Winds]],
  short_name = 'WINGS_OF_WINDS',
  display_entity = Entity.new { image='talents/wings_of_winds.png' },
  type = 'spell/air',
  mode = 'activated',
  is_spell = true,
  skill = { 'AIR', 'CONVEYANCE' },
  skill_level = 22,
  mana = spell.mana_cost,
  min_mana = 30,
  max_mana = 40,
  base_fail = 60,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 1, 10 },
  stick = {
    type = 'utility/staff',
    charge = { 7, 5 },
    rarity = 27,
    base_level = { 1, 10 },
    max_level = { 20, 50 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local base_dur = 5 + spell.get_spell_level(self, t, 25)
    local eff_id = lev >= 16 and self.EFF_FLIGHT or self.EFF_FEATHER_FALL
    local p = { merge='no_replace' }
    if not self:hasEffect(eff_id) then spell.stick.id = true end
    self:setEffect(eff_id, rng.range(1, 10) + base_dur, p)
    return true
  end,
  info = function(self, t)
    local base_dur = 5 + spell.get_spell_level(self, t, 25)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Confers levitation (or controlled flight at level 16) for %d+1d10 turns.  Duration will increase%s]]
    return ret:format(base_dur, sfx)
  end,
}

newTalent {
  name = [[Thunderstorm]],
  short_name = 'THUNDERSTORM',
  display_entity = Entity.new { image='talents/thunderstorm.png' },
  type = 'spell/air',
  mode = 'activated',
  is_spell = true,
  skill = { 'AIR', 'NATURE' },
  skill_level = 25,
  mana = spell.mana_cost,
  min_mana = 40,
  max_mana = 60,
  base_fail = 60,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 2, 15 },
  stick = {
    type = 'utility/wand',
    charge = { 5, 5 },
    rarity = 85,
    base_level = { 1, 5 },
    max_level = { 25, 50 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local base_dur = 10 + spell.get_spell_level(self, t, 25)
    local dd, ds = t.dmg_dice(self, t)
    local p = { dmg_dice={dd,ds}, merge='no_replace' }
    if not self:hasEffect(self.EFF_THUNDERSTORM) then spell.stick.id = true end
    self:setEffect(self.EFF_THUNDERSTORM, base_dur+rng.range(1,10), p)
    return true
  end,
  info = function(self, t)
    local base_dur = 10 + spell.get_spell_level(self, t, 25)
    local dd, ds = t.dmg_dice(self, t)
    local ef = util.colorize_damtype(DamageType.ELEC)
    local sf = util.colorize_damtype(DamageType.SOUND)
    local lf = util.colorize_damtype(DamageType.LITE)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Charges up the air around you with electricity.  Each turn for %d+1d10 turns, a thunder bolt will strike a random monster in sight for %dd%d damage, split evenly between %s, %s and %s.  Damage and duration will increase%s]]
    return ret:format(base_dur, dd, ds, ef, sf, lf, sfx)
  end,
  -- BEGIN VERBATIM
  dmg_dice = function(self, t)
    local dd = 5 + spell.get_spell_level(self, t, 10)
    local ds = 10 + spell.get_spell_level(self, t, 25)
    return dd, ds
  end,
  -- END VERBATIM
}
