-- $Id: eru.lua 2941 2017-06-20 02:16:32Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_eru.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Eru prayers',
  type = 'spell/eru',
  description = 'Prayers to Eru Ilúvatar',
}

newTalent {
  name = [[See the Music]],
  short_name = 'ERU_SEE_MUSIC',
  display_entity = Entity.new { image='talents/see_the_music.png' },
  type = 'spell/eru',
  mode = 'activated',
  is_spell = true,
  skill = 'PRAYER',
  skill_level = 1,
  piety = spell.mana_cost,
  min_piety = 1,
  max_piety = 50,
  god = 'Eru Ilúvatar',
  base_fail = 20,
  blind_cast = true,
  stat = 'WIS',
  random_book = 'SPIRITUALITY',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local dur = rng.range(11, 30) + spell.get_spell_level(self, t, 100)
    self:setEffect(self.EFF_SEE_INVIS, dur, {})
    if lev >= 20 then
      self:removeEffect(self.EFF_BLIND)
    end
    if lev >= 30 then
      local map = game.level.map
      map:liteAll(0, 0, map.w, map.h)
      map:rememberAll(0, 0, map.w, map.h)
    else
      self:computeFOV(40, 'block_sense', spell.map_area_callback, true, true, true)
    end
    return true
  end,
  info = function(self, t)
    local dur_base = 10 + spell.get_spell_level(self, t, 100)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [['See' the Great Music from which the world originates, allowing you to see unseen things.
    
Confers temporary see invisible for %d+d20 turns.  At level 10, also allows you to see your surroundings (radius 40).  At level 20, cures blindness.  At level 30, allows you to fully see the entire level.  Duration will increase%s]]
    return ret:format(dur_base, sfx)
  end,
}

newTalent {
  name = [[Listen to the Music]],
  short_name = 'ERU_LISTEN_MUSIC',
  display_entity = Entity.new { image='talents/listen_to_the_music.png' },
  type = 'spell/eru',
  mode = 'activated',
  is_spell = true,
  skill = 'PRAYER',
  skill_level = 7,
  piety = spell.mana_cost,
  min_piety = 15,
  max_piety = 200,
  god = 'Eru Ilúvatar',
  base_fail = 25,
  stat = 'WIS',
  random_book = 'SPIRITUALITY',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    if lev >= 14 then
      self:inventoryApplyAll(function(_, _, o) o:identify(true, self) end)
      if lev >= 30 then
	for _, e in pairs(game.level.entities) do
	  if e:getEntityKind() == 'object' then e:identify(true, self) end
	end
      end
      return true
    else
      return spell.identify_dialog(self, true, 'Select item to identify')
    end
  end,
  info = function(self, t)
    return [[Listen to the Great Music from which the world originates, allowing you to understand the meaning of things.

Identifies a selected item in your inventory or equipment or on the floor.  At level 14, identifies all your worn or carried items.  At level 30, additionally identifies all items on the floor of the entire level.]]
  end,
}

newTalent {
  name = [[Know the Music]],
  short_name = 'ERU_KNOW_MUSIC',
  display_entity = Entity.new { image='talents/know_the_music.png' },
  type = 'spell/eru',
  mode = 'activated',
  is_spell = true,
  skill = 'PRAYER',
  skill_level = 30,
  piety = spell.mana_cost,
  min_piety = 200,
  max_piety = 600,
  god = 'Eru Ilúvatar',
  base_fail = 50,
  stat = 'WIS',
  random_book = 'SPIRITUALITY',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    if lev >= 10 then
      self:inventoryApplyAll(function(_, _, o) o:identify('full', self) end)
    else
      return spell.identify_dialog(self, 'full', 'Select item to fully identify')
    end
  end,
  info = function(self, t)
    return [[Understand the Great Music from which the world originates, allowing you to truly know what a thing is.

Reveals all properties of a selected item in your inventory or equipment or on the floor.  At level 10, fully identifies all worn or carried items.]]
  end,
}

newTalent {
  name = [[Lay of Protection]],
  short_name = 'ERU_LAY_PROTECTION',
  display_entity = Entity.new { image='talents/lay_of_protection.png' },
  type = 'spell/eru',
  mode = 'activated',
  is_spell = true,
  skill = 'PRAYER',
  skill_level = 35,
  piety = spell.mana_cost,
  min_piety = 400,
  max_piety = 400,
  god = 'Eru Ilúvatar',
  base_fail = 80,
  stat = 'WIS',
  random_book = 'SPIRITUALITY',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local r = 1 + spell.get_spell_level(self, t, 2, 0)
    return spell.ball_spell(self, t, DamageType.MAKE_GLYPH, 1, r, self.x, self.y)
  end,
  info = function(self, t)
    local r = 1 + spell.get_spell_level(self, t, 2, 0)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Fills the local terrain with glyphs of warding in a radius of %d around the caster.  Radius will increase%s]]
    return ret:format(r, sfx)
  end,
}
