-- $Id: meta.lua 3174 2017-11-11 04:26:14Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_meta.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Meta spells',
  type = 'spell/meta',
  description = 'Spells from the Meta school',
}

newTalent {
  name = [[Recharge]],
  short_name = 'RECHARGE',
  display_entity = Entity.new { image='talents/recharge.png' },
  type = 'spell/meta',
  mode = 'activated',
  is_spell = true,
  skill = 'META',
  skill_level = 5,
  mana = spell.mana_cost,
  min_mana = 10,
  max_mana = 100,
  base_fail = 20,
  stat = 'INT',
  random_book = 'MAGIC',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local power = 60 + spell.get_spell_level(self, t, 140)
    return obj_util.recharge(self, power)
  end,
  info = function(self, t)
    local power = 60 + spell.get_spell_level(self, t, 140)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Taps the ambient mana to recharge an object's power, replenishing the charges of a wand or staff or the stored power of a rod.  The power of the spell (currently %d) increases the amount of charges/power restored, and decreases the chance of a backfire that could destroy the selected object; power increases%s]]
    return ret:format(power, sfx)
  end,
  info = [[Taps on the ambient mana to recharge an object's power (charges or mana)]],
  info_aux = function(self, t)
			return "power "..(60 + get_level(RECHARGE, 140))
	end,
}

newTalent {
  name = [[Disperse Magic]],
  short_name = 'DISPERSE_MAGIC',
  display_entity = Entity.new { image='talents/disperse_magic.png' },
  type = 'spell/meta',
  mode = 'activated',
  is_spell = true,
  skill = 'META',
  skill_level = 15,
  mana = spell.mana_cost,
  min_mana = 30,
  max_mana = 60,
  base_fail = 40,
  blind_cast = true,
  confused_cast = true,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 1, 5 },
  stick = {
    type = 'utility/wand',
    charge = { 5, 5 },
    rarity = 25,
    base_level = { 1, 15 },
    max_level = { 5, 40 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local id = self:has('BLIND') or self:has('LIGHT')
    self:removeEffect(self.EFF_BLIND)
    self:removeEffect(self.EFF_LIGHT)
    if lev >= 5 then
      id = id or self:has('CONFUSED') or self:has('HALLUCINATION')
      self:removeEffect(self.EFF_CONFUSED)
      self:removeEffect(self.EFF_HALLUCINATION)
    end
    if lev >= 10 then
      id = id or  self:has('SLOW') or self:has('SPEED') or self:has('LIGHT_SPEED')
      self:removeEffect(self.EFF_SLOW)
      self:removeEffect(self.EFF_SPEED)
      self:removeEffect(self.EFF_LIGHT_SPEED)
    end
    if lev >= 15 then
      id = id or self:has('STUN') or self:has('CUT')
      self:removeEffect(self.EFF_STUN)
      -- No one seems to actually use this effect, so we haven't defined it.
      --self:removeEffect(self.EFF_MEDITATION)
      self:removeEffect(self.EFF_CUT)
    end
    if lev >= 20 then
      id = id or self:has('HEROISM') or self:has('SUPERHEROISM') or self:has('BLESS') or self:has('SHIELD') or self:has('AFRAID') or self:has('MIMIC_FORM')
      self:removeEffect(self.EFF_HEROISM)
      self:removeEffect(self.EFF_SUPERHEROISM)
      self:removeEffect(self.EFF_BLESSED)
      self:removeEffect(self.EFF_SHIELD)
      self:removeEffect(self.EFF_AFRAID)
      -- Haven't defined this effect yet...
      --self:removeEffect(self.EFF_PARASITE)
      self:removeEffect(self.EFF_MIMIC_FORM)
    end
    if id then spell.stick.id = true end
    return true
  end,
  info = function(self, t)
    return [[Dispels a lot of magic that can affect you, be it good or bad:
· At level 1, it removes blindness and temporary light.
· At level 5, it removes confusion and hallucination.
· At level 10, it removes speed (both bad or good) and light-speed.
· At level 15, it removes stunning and cuts.
· At level 20, it removes heroism, super-heroism, blessing, fear, all forms of shields, and all mimicry forms.]]
  end,
}

newTalent {
  name = [[Spellbinder]],
  short_name = 'SPELLBINDER',
  display_entity = Entity.new { image='talents/spellbinder.png' },
  type = 'spell/meta',
  mode = 'activated',
  is_spell = true,
  skill = 'META',
  skill_level = 20,
  mana = spell.mana_cost,
  min_mana = 100,
  max_mana = 300,
  base_fail = 85,
  stat = 'INT',
  random_book = 'MAGIC',
  points = 0,
  range = 18,
  direct_hit = true,
  -- This spell takes a *long* time to cast.
  use_speed = 32,
  action = function(self, t)
    local n_spells = math.min(spell.get_spell_level(self, t, 4), 4)
    local max_lev = 7 + spell.get_spell_level(self, t, 35)
    local SpellbinderDialog = require 'mod.dialogs.SpellbinderDialog'
    local d = SpellbinderDialog.new(self, n_spells, max_lev)
    local ret = self:talentDialog(d)
    if ret then
      local p = {
	pct = d:getThresholdPct(),
	tids = d.sel_spells,
      }
      self:setEffect(self.EFF_SPELLBINDER, 1, p)
    end
    return ret
  end,
  info = function(self, t)
    local n_spells = math.min(spell.get_spell_level(self, t, 4), 4)
    local s = n_spells == 1 and '' or 's'
    local max_lev = 7 + spell.get_spell_level(self, t, 35)
    local sfx = spell.spell_skill_desc(self, t)
    -- The original T2 description says this also costs the mana for the
    -- bound spells, but AFAICT the code doesn't do that.
    local ret = [[Stores spells in a trigger.  You can bind up to %d spell%s of skill level %d or lower; the spells will be fired automatically when your hit points fall below a specified threshold.  Note that this spell takes a #{italic}#long#{normal}# time to cast, so you should prepare it in a safe place.  The number of bindable spells and maximum skill level will increase%s]]
    return ret:format(n_spells, s, max_lev, sfx)
  end,
  -- BEGIN VERBATIM
  on_pre_use = function(who, t, silent, dry_run)
    if who:hasEffect(who.EFF_SPELLBINDER) then
      if not silent then
	game.logPlayer(who, 'You already have a spellbinder active.')
	game.logPlayer(who, 'You can deactivate your current spellbinder by right-clicking on the Spellbinder effect.')
      end
      return false
    end
    return true
  end,
  -- END VERBATIM
}

newTalent {
  name = [[Tracker]],
  short_name = 'TRACKER',
  display_entity = Entity.new { image='talents/tracker.png' },
  type = 'spell/meta',
  mode = 'activated',
  is_spell = true,
  skill = { 'META', 'CONVEYANCE' },
  skill_level = 30,
  mana = spell.mana_cost,
  min_mana = 50,
  max_mana = 50,
  base_fail = 95,
  stat = 'INT',
  random_book = 'MAGIC',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
			if last_teleportation_y == -1 then
				msg_print("There has not been any teleporatation here.")
				return TRUE
			end
			teleport_player_to(last_teleportation_y, last_teleportation_x)
			return TRUE
	end,
  info = [[Tracks down the last teleportation that happened on the level and teleports you to it TIMER_INERTIA_CONTROL player.inertia_controlled_spell]],
  info_aux = function(self, t)
			return ""
	end,
}

newTalent {
  name = [[Inertia Control]],
  short_name = 'INERTIA_CONTROL',
  display_entity = Entity.new { image='talents/inertia_control.png' },
  type = 'spell/meta',
  mode = 'activated',
  is_spell = true,
  skill = 'META',
  skill_level = 37,
  mana = spell.mana_cost,
  min_mana = 300,
  max_mana = 700,
  base_fail = 95,
  stat = 'INT',
  random_book = 'MAGIC',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local power = spell.get_spell_level(self, t, 10)
    local InertiaControlDialog = require 'mod.dialogs.InertiaControlDialog'
    local d = InertiaControlDialog.new(self, power)
    local ret = self:talentDialog(d)
    if ret then
      local p = { t_id=d.selected_spell }
      self:setEffect(self.EFF_INERTIA_CONTROL, 1, p)
    end
    return ret
  end,
  info = function(self, t)
    local power = spell.get_spell_level(self, t, 10)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Changes the energy flow of a spell to cause it to be continuously recast at an interval.  You can have only one such spell bound at a time.  Spells that can be used with Inertia Control will say so in their description, mentioning their flow power and repeat interval.  You can bind spells of power %d or less; this will increase%s  The bound spell will not use time or mana when it is auto-cast, but while the spell is bound, your maximum mana will be reduced by four times its mana cost.]]
    return ret:format(power, sfx)
  end,
  -- BEGIN VERBATIM
  on_pre_use = function(who, t, silent, dry_run)
    if who:hasEffect(who.EFF_INERTIA_CONTROL) then
      if not silent then
	game.logPlayer(who, 'You already have a spell bound via Inertia Control.')
	game.logPlayer(who, 'You can deactivate your current binding by right-clicking on the Inertia Control effect.')
      end
      return false
    end
    return true
  end,
  -- END VERBATIM
}
