-- $Id: udun.lua 3174 2017-11-11 04:26:14Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_udun.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Udun spells',
  type = 'spell/udun',
  description = 'Spells from the Udun school',
}

newTalent {
  name = [[Drain]],
  short_name = 'DRAIN',
  display_entity = Entity.new { image='talents/drain.png' },
  type = 'spell/udun',
  mode = 'activated',
  is_spell = true,
  skill = { 'UDUN', 'MANA' },
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 0,
  max_mana = 0,
  base_fail = 20,
  stat = 'INT',
  random_book = 'MAGIC',
  points = 0,
  range = 18,
  direct_hit = true,
  use_item = {
    name = 'Drain (spell)',
    close_after = true,
    filter = function(o)
      return o.tval == 55 or o.tval == 65 or o.tval == 67
    end,
    action = function(self, t, o, inven, item, floor)
      if not o then return nil end
      local add = 0
      if o.tval == 55 or o.tval == 65 then
	-- Wands and staffs are consumed.
	add = o.level * o.power * o:getNumber()
	if floor then
	  game.level.map:removeObject(self.x, self.y, item)
	else
	  self:removeObject(self:getInven(inven).id, item, true)
	end
      elseif o.tval == 67 then
	add = o.power
	o.power = 0
      end
      self:sortInven()
      self:incMana(add)
      self:recalcEverything()
      return true
    end,
  },
  action = function(self, t)
    local function sel_cb(o, item, floor)
      self:talentDialogReturn(true, {o=o, item=item, floor=floor})
      return true
    end
    local ShowInvenFloor = require('mod.dialogs.ShowInvenFloor')
    local inven = self:getInven('INVEN')
    local ret, p = self:talentDialog(ShowInvenFloor.new('Select object to drain', inven, t.use_item.filter, sel_cb, self))
    if not ret then return nil end
    return t.use_item.action(self, t, p.o, self:getInven('INVEN'), p.item, p.floor)
  end,
  info = function(self, t)
    return [[Drains the mana contained in wands, staves or rods to increase yours.  Wands and staffs will be consumed by the spell; rods will simply be drained of power.]]
  end,
}

newTalent {
  name = [[Genocide]],
  short_name = 'GENOCIDE',
  display_entity = Entity.new { image='talents/genocide.png' },
  type = 'spell/udun',
  mode = 'activated',
  is_spell = true,
  skill = { 'UDUN', 'NATURE' },
  skill_level = 25,
  mana = spell.mana_cost,
  min_mana = 50,
  max_mana = 50,
  base_fail = 90,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/staff',
    charge = { 2, 2 },
    rarity = 85,
    base_level = { 1, 1 },
    max_level = { 5, 15 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    spell.stick.id = true
    local lev = spell.get_spell_level(self, t)
    local all = false
    if lev >= 10 then
      local function yn_cb(ok) self:talentDialogReturn(ok) end
      all = self:talentDialog(ui_util.yesnoPopup('Genocide', 'Genocide all monsters near you?', yn_cb))
    end
    if all then
      spell.genocide(self, nil, 20, 3)
    else
      spell.genocide(self, 'target', nil, 4)
    end
    return true
  end,
  info = function(self, t)
    return [[Removes all non-unique monsters of a selected type from the level.  You will take 1d4 damage for each monster removed.

At level 10, you can choose to remove all non-unique monsters within radius 20.  You will only take 1d3 damage per monster removed in this case.]]
  end,
}

newTalent {
  name = [[Wraithform]],
  short_name = 'WRAITHFORM',
  display_entity = Entity.new { image='talents/wraithform.png' },
  type = 'spell/udun',
  mode = 'activated',
  is_spell = true,
  skill = { 'UDUN', 'CONVEYANCE' },
  skill_level = 30,
  mana = spell.mana_cost,
  min_mana = 20,
  max_mana = 40,
  base_fail = 95,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 4, 30 },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local dur = rng.range(1, 30) + 20 + spell.get_spell_level(self, t, 40)
    self:setEffect(self.EFF_WRAITH_FORM, dur, {})
  end,
  info = function(self, t)
    local base_dur = 20 + spell.get_spell_level(self, t, 40)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Turns you into an immaterial being for %d+1d30 turns.  Duration will increase%s]]
    return ret:format(base_dur, sfx)
  end,
}

newTalent {
  name = [[Flame of Udun]],
  short_name = 'FLAME_UDUN',
  display_entity = Entity.new { image='talents/flame_of_udun.png' },
  type = 'spell/udun',
  mode = 'activated',
  is_spell = true,
  skill = { 'UDUN', 'FIRE' },
  skill_level = 35,
  mana = spell.mana_cost,
  min_mana = 70,
  max_mana = 100,
  base_fail = 95,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 7, 15 },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local ObjectData = require 'mod.class.interface.ObjectData'
    local mf = ObjectData:getMimicryForm('Balrog')
    local lev = spell.get_spell_level(self, t)
    local dur = rng.range(1, 15) + 5 + spell.get_spell_level(self, t, 30)
    self:setEffect(self.EFF_MIMIC_FORM, dur, { mimic=mf, level=lev })
    return true
  end,
  info = function(self, t)
    local ObjectData = require 'mod.class.interface.ObjectData'
    local mf = ObjectData:getMimicryForm('Balrog')
    local lev = spell.get_spell_level(self, t)
    local base_dur = 5 + spell.get_spell_level(self, t, 30)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Turns you into a powerful Balrog for %d+1d15 turns.  Duration will increase%s]]
    local desc = tstring {
      ret:format(base_dur, sfx),
      true, true, 'Effects at your current spell level:', true
    }
    desc:merge(mf.info(self, lev))
    return desc:toString()
  end,
}
