-- $Id: wand-staff.lua 3174 2017-11-11 04:26:14Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_stick.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Wand/staff spells',
  type = 'spell/wand-staff',
  description = 'Spells that only appear on wands, staffs or other devices',
}

newTalent {
  name = [[Artifact Durandil]],
  short_name = 'DEVICE_DURANDIL',
  display_entity = Entity.new { image='talents/artifact_durandil.png' },
  type = 'spell/wand-staff',
  mode = 'activated',
  is_spell = true,
  skill = 'MAGIC_DEVICE',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 0,
  max_mana = 0,
  base_fail = 0,
  stat = 'INT',
  device_use = 3,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    game.log("You hear a little song in your head in some unknown tongue:")
    game.log("'Les epees Durandils sont forgees dans les mines par des nains.")
    game.log("Avec ca c'est facile de tuer un troll avec une seule main. Pas besoin")
    game.log("de super entrainement nis de niveau 28. Quand tu sors l'instrument")
    game.log("c'est l'ennemi qui prend la fuite! Avec ton epee Durandil quand tu")
    game.log("parcours les chemins, tu massacre sans peine les brigands et les gobelins,")
    game.log("les rats geants, les ogres mutants, les zombies et les liches, tu les")
    game.log("decoupe en tranches comme si c'etait des parts de quiches.")
    game.log("Les epees Durandil! Les epees Durandil!")
    game.log("Quand tu la sort dans un dongeon au moins t'as pas l'air debile.")
    game.log("C'est l'arme des bourins qui savent etre subtils.")
    game.log("Ne partez pas a l'aventure sans votre epee Durandil!'")
  end,
  info = function(self, t)
    return [[Sings a cheerful song.]]
  end,
}

newTalent {
  name = [[Artifact Eternal Flame]],
  short_name = 'DEVICE_ETERNAL_FLAME',
  display_entity = Entity.new { image='talents/artifact_eternal_flame.png' },
  type = 'spell/wand-staff',
  mode = 'activated',
  is_spell = true,
  skill = 'MAGIC_DEVICE',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 0,
  max_mana = 0,
  base_fail = 0,
  stat = 'INT',
  device_use = { 0, 0 },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
			local ret, item, obj

			ret, item = get_item("Which object do you want to imbue?",
					     "You have no objects to imbue.",
					     bor(USE_INVEN),
					     function (obj)
						if obj.name1 > 0 or obj.name2 > 0 then return FALSE end
					     	if (obj.tval == TV_SWORD) and (obj.sval == SV_LONG_SWORD) then
							return TRUE
					     	elseif (obj.tval == TV_MSTAFF) and (obj.sval == SV_MSTAFF) then
							return TRUE
					     	elseif (obj.tval == TV_BOW) and (obj.sval == SV_HEAVY_XBOW) then
							return TRUE
					     	elseif (obj.tval == TV_DRAG_ARMOR) and (obj.sval == SV_DRAGON_POWER) then
							return TRUE
					     	end
						return FALSE
					     end
			)
			if ret == FALSE then return FALSE end

			obj = get_object(item)

			if (obj.tval == TV_SWORD) and (obj.sval == SV_LONG_SWORD) then
				obj.name1 = 147
			elseif (obj.tval == TV_MSTAFF) and (obj.sval == SV_MSTAFF) then
				obj.name1 = 127
			elseif (obj.tval == TV_BOW) and (obj.sval == SV_HEAVY_XBOW) then
				obj.name1 = 152
			elseif (obj.tval == TV_DRAG_ARMOR) and (obj.sval == SV_DRAGON_POWER) then
				obj.name1 = 17
			end
			apply_magic(obj, -1, TRUE, TRUE, TRUE)

			obj.found = OBJ_FOUND_SELFMADE

			inven_item_increase(flame_item, -1)
			inven_item_describe(flame_item)
			inven_item_optimize(flame_item)

			return TRUE
	end,
  info = [[Imbuing an object with the eternal fire]],
  info_aux = function(self, t)
			return ""
	end,
}

newTalent {
  name = [[Artifact Lebauhaum]],
  short_name = 'DEVICE_LEBOHAUM',
  display_entity = Entity.new { image='talents/artifact_lebauhaum.png' },
  type = 'spell/wand-staff',
  mode = 'activated',
  is_spell = true,
  skill = 'MAGIC_DEVICE',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 0,
  max_mana = 0,
  base_fail = 0,
  stat = 'INT',
  device_use = 3,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    game.log("You hear a little song in your head in some unknown tongue:")
    game.log("'Avec le casque Lebohaum y a jamais d'anicroches, je parcours les dongeons,")
    game.log("j'en prend plein la caboche. Avec le casque Lebohaum, tout ces monstres a la")
    game.log("con, je leur met bien profond: c'est moi le maitre du dongeon!'")
  end,
  info = function(self, t)
    return [[Sings a cheerful song.]]
  end,
}

newTalent {
  name = [[Artifact Thunderlords]],
  short_name = 'DEVICE_THUNDERLORDS',
  display_entity = Entity.new { image='talents/artifact_thunderlords.png' },
  type = 'spell/wand-staff',
  mode = 'activated',
  is_spell = true,
  skill = 'MAGIC_DEVICE',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 1,
  max_mana = 1,
  base_fail = 20,
  stat = 'INT',
  stick = {
    type = 'utility/staff',
    charge = { 3, 3 },
    rarity = 999,
    base_level = { 1, 1 },
    max_level = { 1, 1 },
  },
  points = 0,
  action = function(self, t)
    spell.stick.id = true
    if game.zone.town or game.zone.wilderness or game.zone.worldmap then
      game.logPlayer(self, 'You cannot use the horn here.')
      return false
    end
    game.logPlayer(self, 'As you blow the horn a thunderlord pops out of nowhere and grabs you.')
    spell.set_recall(self, 0, 1)
    return true
  end,
  info = function(self, t)
    return [[Summons a thunderlord to transport you quickly to the surface.]]
  end,
}

newTalent {
  name = [[Nothing]],
  short_name = 'DEVICE_NOTHING',
  display_entity = Entity.new { image='talents/nothing.png' },
  type = 'spell/wand-staff',
  mode = 'activated',
  is_spell = true,
  skill = 'MAGIC_DEVICE',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 0,
  max_mana = 0,
  base_fail = 0,
  stat = 'INT',
  stick = {
    type = 'utility/staff',
    charge = { 0, 0 },
    rarity = 3,
    base_level = { 1, 1 },
    max_level = { 1, 1 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t) return false end,
  info = function(self, t) return [[It does nothing.  Hence the name.]] end,
}

newTalent {
  name = [[Artifact Maggot]],
  short_name = 'DEVICE_MAGGOT',
  display_entity = Entity.new { image='talents/artifact_maggot.png' },
  type = 'spell/wand-staff',
  mode = 'activated',
  is_spell = true,
  skill = 'MAGIC_DEVICE',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 7,
  max_mana = 7,
  base_fail = 20,
  stat = 'INT',
  device_use = { 10, 50 },
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    return spell.ball_spell(self, t, DamageType.TURN_ALL, 40, 2)
  end,
  info = function(self, t)
    return [[Attempts to scare away monsters (power 40) in a radius-2 ball around the target.]]
  end,
}

newTalent {
  name = [[Heal Monster]],
  short_name = 'DEVICE_HEAL_MONSTER',
  display_entity = Entity.new { image='talents/heal_monster.png' },
  type = 'spell/wand-staff',
  mode = 'activated',
  is_spell = true,
  skill = 'MAGIC_DEVICE',
  skill_level = 3,
  mana = spell.mana_cost,
  min_mana = 5,
  max_mana = 20,
  base_fail = 15,
  stat = 'INT',
  stick = {
    type = 'utility/wand',
    charge = { 10, 10 },
    rarity = 17,
    base_level = { 1, 15 },
    max_level = { 20, 50 },
  },
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local pow = 20 + spell.get_spell_level(self, t, 380)
    local ret = spell.hit_spell(self, t, DamageType.OLD_HEAL, pow)
    if ret then spell.stick.id = true end
    return ret
  end,
  info = function(self, t)
    local pow = 20 + spell.get_spell_level(self, t, 380)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Heals the targeted monster for %d hit points.  Healing will increase%s]]
    return ret:format(pow, sfx)
  end,
}

newTalent {
  name = [[Summon]],
  short_name = 'DEVICE_SUMMON',
  display_entity = Entity.new { image='talents/summon.png' },
  type = 'spell/wand-staff',
  mode = 'activated',
  is_spell = true,
  skill = 'MAGIC_DEVICE',
  skill_level = 5,
  mana = spell.mana_cost,
  min_mana = 5,
  max_mana = 25,
  base_fail = 20,
  stat = 'INT',
  stick = {
    type = 'utility/staff',
    charge = { 1, 20 },
    rarity = 13,
    base_level = { 1, 40 },
    max_level = { 25, 50 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local num = 4 + spell.get_spell_level(self, t, 30)
    local ret = spell.summon(nil, self.x, self.y, {}, num)
    if ret then spell.stick.id = true end
    return true
  end,
  info = function(self, t)
    local num = 4 + spell.get_spell_level(self, t, 30)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Summons up to %d hostile monsters near you; the number will increase%s]]
    return ret:format(num, sfx)
  end,
}

newTalent {
  name = [[Haste Monster]],
  short_name = 'DEVICE_SPEED_MONSTER',
  display_entity = Entity.new { image='talents/haste_monster.png' },
  type = 'spell/wand-staff',
  mode = 'activated',
  is_spell = true,
  skill = 'MAGIC_DEVICE',
  skill_level = 10,
  mana = spell.mana_cost,
  min_mana = 10,
  max_mana = 10,
  base_fail = 30,
  stat = 'INT',
  stick = {
    type = 'utility/wand',
    charge = { 10, 5 },
    rarity = 7,
    base_level = { 1, 1 },
    max_level = { 20, 50 },
  },
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local ret = spell.hit_spell(self, t, DamageType.OLD_SPEED, 1)
    if ret then spell.stick.id = true end
    return ret
  end,
  info = function(self, t)
    return [[Increases the targeted monster's speed by 10.]]
  end,
}

newTalent {
  name = [[Mana]],
  short_name = 'DEVICE_MANA',
  display_entity = Entity.new { image='talents/mana.png' },
  type = 'spell/wand-staff',
  mode = 'activated',
  is_spell = true,
  skill = 'MAGIC_DEVICE',
  skill_level = 30,
  mana = spell.mana_cost,
  min_mana = 1,
  max_mana = 1,
  base_fail = 80,
  stat = 'INT',
  stick = {
    type = 'utility/staff',
    charge = { 2, 3 },
    rarity = 78,
    base_level = { 1, 5 },
    max_level = { 20, 35 },
  },
  points = 0,
  range = 18,
  action = function(self, t)
    spell.stick.id = true
    if not self.max_mana then
      game.logPlayer(self, 'You have no mana to restore.')
      return false
    end
    local pct = 20 + spell.get_spell_level(self, t)
    self:incMana(math.floor(self.max_mana * pct/100))
    return true
  end,
  info = function(self, t)
    local pct = 20 + spell.get_spell_level(self, t)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Restores %d%% of your maximum mana, up to full.  Mana restored increases%s]]
    return ret:format(pct, sfx)
  end,
}

newTalent {
  name = [[Holy Fire of Mithrandir]],
  short_name = 'DEVICE_HOLY_FIRE',
  display_entity = Entity.new { image='talents/holy_fire_of_mithrandir.png' },
  type = 'spell/wand-staff',
  mode = 'activated',
  is_spell = true,
  skill = 'MAGIC_DEVICE',
  skill_level = 30,
  mana = spell.mana_cost,
  min_mana = 50,
  max_mana = 150,
  base_fail = 75,
  stat = 'INT',
  stick = {
    type = 'utility/staff',
    charge = { 2, 5 },
    rarity = 999,
    base_level = { 1, 1 },
    max_level = { 35, 35 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local dam = 50 + spell.get_spell_level(self, t, 300)
    local cast, seen = spell.los_spell(self, t, DamageType.HOLY_FIRE, dam)
    if seen then spell.stick.id = true end
    return cast
  end,
  info = function(self, t)
    local dam = 50 + spell.get_spell_level(self, t, 300)
    local hff = util.colorize_damtype(DamageType.HOLY_FIRE)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[The Holy Fire created by this staff does %d %s damage (doubled for evil creatures) to all monsters in line of sight.  Damage will increase%s]]
    return ret:format(dam, hff, sfx)
  end,
}

newTalent {
  name = [[Wish]],
  short_name = 'DEVICE_WISH',
  display_entity = Entity.new { image='talents/wish.png' },
  type = 'spell/wand-staff',
  mode = 'activated',
  is_spell = true,
  skill = 'MAGIC_DEVICE',
  skill_level = 50,
  mana = spell.mana_cost,
  min_mana = 400,
  max_mana = 400,
  base_fail = 99,
  stat = 'INT',
  stick = {
    type = 'utility/staff',
    charge = { 1, 2 },
    rarity = 98,
    base_level = { 1, 1 },
    max_level = { 1, 1 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
			make_wish()
			return TRUE
	end,
  info = [[This grants you a wish, beware of what you ask for!]],
  info_aux = function(self, t)
			return ""
	end,
}
