-- $Id: zone.lua 2835 2017-04-11 00:13:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- Zone file for Heart of the Earth.

return {
  name = 'Heart of the Earth',
  display_abbr = 'HoE',
  level_scheme = 'fixed',
  max_level = 12,
  level_range = { 25, 36 },
  width = 198,
  height = 66,

  generator = {
    map = {
      class = 'mod.class.generator.map.T2GameOfLifeLevel',
      floor = { 'FLOOR' },
      fill = { 'WALL' },
      outer_wall = 'WALL',
      inner_wall = 'WALL',
      up = 'UP',
      down = 'DOWN',
      flags = {
	EVOLVE = true,
	NO_RECALL = true,
	NO_SHAFT = true,
	NO_UP = true,
      },
    },
    actor = {
      class = 'mod.class.generator.actor.T2LevelFilteredActors',
      init_npc = 14,
      respawn_in = 160,
      filters = {
	{ prob=40, mode='or', syms={ '#', 'X', 'g', 'E' } },
	{ prob=30, mode='or', flags={ 'PASS_WALL', 'KILL_WALL', 'HURT_ROCK' } },
	{ prob=30, mode='any' },
      },
      guardian = 'GOLGARACH_THE_LIVING_ROCK',
    },
    object = {
      class = 'mod.class.generator.object.T2LevelFilteredObjects',
      weights = { treasure=40, combat=10, magic=10, tools=20, junk=20 },
    },
    trap = {
      class = 'mod.class.generator.trap.T2LevelFilteredTraps',
    },
  },
  alter_level_data = util.adjust_level,
  levels = {
    [1] = {
      generator = {
	map = {
	  up = 'UP_TO_MIRKWOOD',
	  -- up_lev = 15
	},
      },
    },
  },
}
