-- $Id: zone.lua 3333 2018-04-20 00:32:38Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2018 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

return {
  name = "Abandoned Mine",
  level_scheme = 'fixed',
  max_level = 1,
  level_range = { 60, 60 },
  width = 33,
  height = 23,
  no_level_connectivity = true,
  no_recall_depth = true,

  generator = {
    map = {
      class = 'mod.class.generator.map.Static',
      map = 'quests/khazad-dum-evil',
      flags = { NO_GENO=true },
    },
    actor = {
      class = 'mod.class.generator.actor.T2LevelFilteredActors',
      -- We'll generate actors in post_process() below.
      no_prepop = true,
    },
  },

  -- cf. quest_evil_gen_hook() in src/q_evil.c
  post_process = function(level, zone)
    -- Place some Balrogs.
    local Map = require 'mod.class.Map'
    local gen = zone:getGenerator('actor', level)
    local map = level.map
    local n = 6
    while n > 0 do
      local x, y = rng.range(0, 30) + 1, rng.range(0, 20) + 1
      if map:checkEntity(x, y, Map.TERRAIN, 'floor') and not map:checkEntity(x, y, Map.TERRAIN, 'permanent') then
	local m = gen:generateOne{ name='LESSER_BALROG', x=x, y=y, ret=true }
	if m then
	  m.quest_on_die = 'khazad-dum-house'
	  n = n - 1
	end
      end
    end
  end,
}
